import React from "react";
import { Row, Col } from "antd";
import Panel from 'components/Panel';
import Icon from 'components/Icon';
import './index.less';
import { jrequest } from 'utils/request'

//消息栏
export default class InfoBar extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      bars:[],
    }

    if(props.option) {
      this.state.bars = props.option.bars;

      if(props.option.countUrl) {
        jrequest({
          url:props.option.countUrl,
          method:"get",
        }).then((result) => {
          //这里的result应该是:
          //[["111"],["222"],["333"],["444"]]
          let bars = this.state.bars;
          for (let i = 0; i < bars.length; i++) {
            bars[i].count = result[i][0];
          }
          this.setState({
            bars:bars
          });
        });
      }
    }
  }

  // componentWillReceiveProps(props) {
  //   if(props.option) {
  //     this.setState({bars:props.option.bars});

  //     if(props.option.countUrl) {
  //       jrequest({
  //         url:props.option.countUrl,
  //         method:"get",
  //       }).then((result) => {
  //         //这里的result应该是:
  //         //["111","222","333","444"]
  //         let bars = this.state.bars;
  //         for (let i = 0; i < bars.length; i++) {
  //           bars[i].count = result[i][0];
  //         }
  //         this.setState({
  //           bars:bars
  //         });
  //       });
  //     }
  //   }
  // }

  render() {
    let result;
    if (this.props.option) {
      let barDoms = this.state.bars.map((item) => {
        return (
          <Col md={6} key={item.id}>
            <Panel className={item.className} header={false} cover>
              <Icon type={item.type} antd />
              <h2>
                <b>{item.count}</b>
              </h2>
              <h5 className="text-muted">{item.name}</h5>
            </Panel>
          </Col>
        );
      });
      result = (
        <Row gutter={20} className="full-layout page dashboard-page">
          {barDoms}
        </Row>
      );
    } else {
      result = (
        <Row gutter={20} className="full-layout page dashboard-page">
          <Col md={6}>
            <Panel className="qq" header={false} cover>
              <Icon type="qq" antd />
              <h2>
                <b>523</b>
              </h2>
              <h5 className="text-muted">官网</h5>
            </Panel>
          </Col>
          <Col md={6}>
            <Panel className="wechat" header={false} cover>
              <Icon type="wechat" antd />
              <h2>
                <b>99+</b>
              </h2>
              <h5 className="text-muted">微信</h5>
            </Panel>
          </Col>
          <Col md={6}>
            <Panel className="skype" header={false} cover>
              <Icon type="skype" antd />
              <h2>
                <b>2</b>
              </h2>
              <h5 className="text-muted">天猫</h5>
            </Panel>
          </Col>
          <Col md={6}>
            <Panel className="github" header={false} cover>
              <Icon type="github" antd />
              <h2>
                <b>999</b>
              </h2>
              <h5 className="text-muted">京东</h5>
            </Panel>
          </Col>
        </Row>
      );
    }
    return result;
  }
}