import React from "react";
import { Row, Col } from "antd";
import Panel from 'components/Panel';
import Icon from 'components/Icon';
import './../NormalComponent/index.less';
import { jrequest } from 'utils/request'

//门店销售情况
export default class StoreRank extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            rankingListData : []
        }

        if(props.option) {
            if(props.option.ranks) {
                this.state.rankingListData = props.option.ranks;
            } else if(props.option.rankUrl) {
                jrequest({
                    url:props.option.rankUrl,
                    method:"get",
                }).then((result) => {
                    let listData = result.map((item) => {
                        return {
                            title: item[0],
                            total: item[1]
                        };
                    });
                    this.setState({rankingListData:listData});
                });
            }
        } else {
            let rankingListData = [];
            for (let i = 0; i < 7; i += 1) {
                rankingListData.push({
                    title: `亮健 ${i} 号店`,
                    total: 323234
                });
            }
            this.state.rankingListData = rankingListData;
        }
    }

    // componentWillReceiveProps(props) {
    //     if(props.option) {
    //         if(props.option.ranks) {
    //             this.setState({rankingListData:props.option.ranks});
    //         } else if(props.option.rankUrl) {
    //             request({
    //                 url:props.option.rankUrl,
    //                 method:"get"
    //             }).then((result) => {
    //                 this.setState({rankingListData:result});
    //             });
    //         }
    //     }
    // }

    render() {
        return (
            <div className="flex-none sales-order" style={{maxHeight:"465px", overflowY:"scroll",width:"100%",height:"100%"}}>
                {/* <h4>门店销售额排名</h4> */}
                <ul>
                    {this.state.rankingListData.map((item, i) => (
                        <li key={item.title}>
                            <span>{i + 1}</span>
                            <span>{item.title}</span>
                            <span>{item.total}</span>
                        </li>
                    ))}
                </ul> 
            </div>
        );
    }
}