import React from 'react';
import { jrequest } from 'utils/request';
import { Input, Modal, Button, Select, Collapse,Row, Col, message } from 'antd';

const { TextArea } = Input;

class EditFeatureModal extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            visible: false,
            confirmLoading:false,

            name: props.modalData.name,
            url: props.modalData.url,
            descrition: props.modalData.descrition,
            version: props.modalData.version,
        }
        this.staticData = {
            name: props.modalData.name,
            url: props.modalData.url,
            descrition: props.modalData.description,
            version: props.modalData.version,
        }
    }

    componentWillReceiveProps(props) {
        this.staticData = {
            name: props.modalData.name,
            url: props.modalData.url,
            descrition: props.modalData.description,
            version: props.modalData.version,
        }
        this.setState({
            name: props.modalData.name,
            url: props.modalData.url,
            descrition: props.modalData.descrition,
            version: props.modalData.version,
        })
    }

    //显示modal框
    showModal = () => {
        this.setState({
            visible: true,
          });
    }

    handleOk = () => {
        let objectData = this.props.modalData.objectData;
        if(this.props.modalData.isUpdate) {
            this.setState({confirmLoading:true});
            //是跟新的情况
            objectData.name = this.staticData.name;
            objectData.url = this.staticData.url;
            objectData.descrition = this.staticData.descrition;
            objectData.version = this.staticData.version;
            jrequest({
                url:"/feature/feature",
                method:"put",
                data:objectData
            }).then((result) => {
                if(result.success) {
                   //跟新后的回调
                   this.props.afterOk();
                   this.setState({confirmLoading:false,visible:false});
                } else {
                    message.error(result.msg);
                    this.setState({confirmLoading:false});
                }
            }).catch((error) => {
                this.setState({confirmLoading:false});
            })
        } else {
            //是新增的情况
            let objectData = {
                name: this.staticData.name,
                url: this.staticData.url,
                descrition: this.staticData.descrition,
                version: this.staticData.version,
            }
            jrequest({
                url:"/feature/feature",
                method:"post",
                data:objectData
            }).then((result) => {
                if(result.success) {
                   //跟新后的回调
                   this.props.afterOk();
                   this.setState({confirmLoading:false,visible:false});
                } else {
                    message.error(result.msg);
                    this.setState({confirmLoading:false});
                }
            }).catch((error) => {
                this.setState({confirmLoading:false});
            });
        }
    }

    handleCancel = () => {
        this.setState({
            visible: false,
          });
    }

    render() {
        let modalData = this.props.modalData;
        return (
            <div>
            <Button style={{float:"left"}} type="primary" onClick={this.showModal}>{modalData.type}</Button>
            <Modal
                title={modalData.type}
                visible={this.state.visible}
                onOk={this.handleOk}
                confirmLoading={this.state.confirmLoading}
                onCancel={this.handleCancel}>
                
                <Row gutter={8} style={{marginBottom: "50px"}}>
                    <Col span={4}>功能名称:</Col>
                    <Col span={20}>
                        <Input defaultValue={this.state.name} onChange={(e) => this.staticData.name = e.target.value} />
                    </Col>
                </Row>
                <Row gutter={8} style={{marginBottom: "50px"}}>
                    <Col span={4}>版本号:</Col>
                    <Col span={20}>
                        <Input disabled={this.props.modalData.isUpdate} defaultValue={this.state.version} onChange={(e) => this.staticData.version = e.target.value} />
                    </Col>
                </Row>
                <Row gutter={8} style={{marginBottom: "50px"}}>
                    <Col span={4}>功能链接:</Col>
                    <Col span={20}>
                        <TextArea rows={4} defaultValue={this.state.url} onChange={(e) => this.staticData.url = e.target.value} />
                    </Col>
                </Row>
                <Row gutter={8} style={{marginBottom: "50px"}}>
                    <Col span={4}>功能介绍:</Col>
                    <Col span={20}>
                        <TextArea disabled={this.props.modalData.isUpdate} rows={4} defaultValue={this.state.descrition} onChange={(e) => this.staticData.descrition = e.target.value} />
                    </Col>
                </Row>
            </Modal>
            </div>
        )
    }
}

export default EditFeatureModal