import React from 'react';
import PropTypes from 'prop-types';
import { request, config, util } from 'utils';
import { Select } from 'antd';

const defaultInnerProps = {
  showSearch: true,
  filterOption: (input, option) => { return option.props.children.toLowerCase().indexOf(input.toLowerCase()) >= 0 }
}

class BirdSelector extends React.Component {
  constructor(props) {
    super(props);
    
    let option = this.props.data;
    let inline = !this.props.inline?false:true;
    /*if(typeof(this.props.data)=="object" ){
      option = [];
      this.props.data.then(result=>{
        console.log("-->"+result);
        this.setState({
          options: result
        }, () => {
          console.log("==>"+this.state.options); // 12
      })
      });
    }*/
    this.state = {
      placeholder: '',
      options:  option|| [],
      inline:inline,
    }
  }
  componentDidUpdate(){
      //console.log("-=>"+this.state.options);
  }
  setStateAsync(state) {
    return new Promise((resolve) => {
      this.setState(state, resolve)
    });
  }

 componentDidMount() {
    let self = this;
    if (self.props.data.length > 0) return;

    if(self.props.paramsData && self.state.options.length == 0){
       self.setStateAsync({options: self.props.paramsData})
    }
    
    if(!this.state.inline &&(!self.props.paramsData||!self.props.paramsData.length) && this.state.options.length == 0){
      var result =  this.initOptionData(self.props);
      ;
      //this.setStateAsync({options: result})
    }
    /*if (self.props.url) {
      let urlstr = self.props.url+"";
      if(self.props.params&&self.props.params.length>0){
          urlstr += "?";
          for(var param in self.props.params){
            urlstr += self.props.params[param].key+"=";
            for(var paramData in self.props.paramsData){
              if(self.props.paramsData[paramData].key == self.props.params[param].key){
                urlstr += self.props.paramsData[paramData].value+
                "&";
              }
            }
          }
      }
      request({
        url: urlstr,
        method: "get"
      }).then(function (result) {
        self.setState({
          options: result
        })
      });
    } else if (self.props.dicKey) {
      request({
        url: config.api.getDic + self.props.dicKey,
        method: "get"
      }).then(function (result) {
        self.setState({
          placeholder: result.placeholder,
          options: result.options
        });
        result.defaultCode && self.onPropsChange(result.defaultCode);
      });
    }*/
  }

  async UNSAFE_componentWillReceiveProps(nextProps) {
    if (!util.object.equal(nextProps.data, this.props.data)) {
      this.setState({
        options: nextProps.data
      })
    }
    if(nextProps.paramsData && this.state.options.length == 0){
      this.setState({
        options: nextProps.paramsData
      })
    }
    if(!this.state.inline && (!nextProps.paramsData||!nextProps.paramsData.length) && this.state.options.length == 0){
      var result =  this.initOptionData(nextProps);
      
      //this.setStateAsync({options: result});
    }
    /*
    let self = this;
    if(typeof(this.props.data)=="object" ){
      this.props.data.then(result=>{
        console.log("-->"+result);
        self.setState({
          options: result
        }, () => {
          console.log("==>"+this.state.options); // 12
      })
      });
    }*/
  }

  onPropsChange(value) {
    this.props.onChange && this.props.onChange(value);
  }

  initOptionData(nextProps){
    let self = this;
    if (self.props.url) {
      let urlstr = self.props.url+"";
      if(self.props.params&&nextProps.params.length>0){
          urlstr += "?";
          for(var param in nextProps.params){
            urlstr += nextProps.params[param].key+"=";
            for(var paramData in nextProps.paramsData){
              if(nextProps.paramsData[paramData].key == nextProps.params[param].key){
                urlstr += nextProps.paramsData[paramData].value+
                "&";
              }
            }
          }
      }
      var dom = request({
        url: urlstr,
        method: "get"
      }).then(function (result) {
        self.setState({options: result})
        return result;
      });
      return dom;
    }
  }

  render() {
    
    let self = this;
    let innerProps = this.props.innerProps || {};
    return (
      <Select {...{
        value: typeof (self.props.selectedValue) === 'undefined' ? '' : self.props.selectedValue + '',
        onChange: value => self.onPropsChange(value),
        disabled: self.props.disabled,
        style: { width: self.props.width },
        ...defaultInnerProps,
        ...innerProps
      }}>
        {this.state.options.map((option, index) => (
          <Select.Option key={'selector_' + self.props.dicKey + '_' + index} value={option.value}
            disabled={option.disabled + '' === 'true'}>{option.label}</Select.Option>
        ))}
      </Select>
    )
  }
}

BirdSelector.propTypes = {
  data: PropTypes.array,
  url: PropTypes.string,
  params: PropTypes.array,
  dicKey: PropTypes.string,
  disabled: PropTypes.bool,
  selectedValue: PropTypes.oneOfType([
    PropTypes.string,
    PropTypes.number
  ]),
  onChange: PropTypes.func,
  innerProps: PropTypes.object,
  paramsData: PropTypes.array,
  inline:PropTypes.bool,
};

BirdSelector.defaultProps = {
  width: '100%',
  data: []
}

export default BirdSelector;
