import BirdForm from './BirdForm';
import BirdSelector from './BirdSelector';
import BirdStoredForm from './BirdStoredForm';
import BirdButton from './BirdButton';
import BirdCascader from './BirdCascader';
import AutoField from './AutoField';
import BirdMulti from './BirdMulti'

const validate = (formData,fieldOptions) => {
    let dto = formData?formData:[];
  
    //验证数据合法性
    let fieldOption = fieldOption?fieldOptions:[];
    for (let field of fieldOption) {
      if (!field.editor) continue;
      if (field.editor.isRequired && util.string.isEmpty(dto[field.data])) {
        message.error('`' + field.title + '`不能为空.');
        return false;
      }
      if (field.editor.validateRegular) {
        let reg = typeof (field.editor.validateRegular) === 'string' ? new RegExp(field.editor.validateRegular) : field.editor.validateRegular;
        if (reg.test && !reg.test(dto[field.data])) {
          message.error('`' + field.title + '`数据格式不正确.');
          return false;
        }
      }
    }
    return true;
  };
export {BirdForm,BirdSelector,BirdStoredForm,BirdButton,BirdCascader,AutoField,BirdMulti,validate}
