import React from 'react';
import PropTypes from 'prop-types';
import { request, deepClone, util,hashToArray,validate } from 'utils';
import AutoField from '../Form/AutoField';
//import validate from '../Form';
import { Form, message } from 'antd';

class BirdGridForm extends React.Component {
  constructor(props) {
    super(props);

    let formOption = deepClone(this.props.formOption);
    let initValue = deepClone(this.props.formOption.value);
    let sourceData = this.props.formOption.sourceData?deepClone(this.props.formOption.sourceData):{};
    
    for (let field of this.props.formOption.fields) {
      if(field.editor&&field.editor.value){
        if(typeof (field.editor.value) === 'function' ){
          initValue[field.data]=field.editor.value();
        }else{
          initValue[field.data]=field.editor.value;
        }
      }
    }
    
    let extraParams = this.props.formOption.extraParams;
    for (let extra of extraParams) {
      initValue[extra.field] = extra.value;
    }
    this.state = {
      formOption: formOption,
      initValue: initValue,
      extraParams: this.props.formOption.extraParams,
      sourceData:sourceData
    }
  }

  UNSAFE_componentWillReceiveProps(nextProps) {
    if ( !util.object.equal(nextProps.formOption, this.state.formOption)) {
      if ( !util.object.equal(nextProps.formOption.value, this.state.initValue)) {
        var initValue = deepClone(nextProps.formOption.value);
        this.setState({
          initValue: initValue
        });
      }
      if ( !util.object.equal(nextProps.formOption.extraParams, this.state.extraParams)) {
        this.setState({
          extraParams: nextProps.formOption.extraParams
        });
      } 
      if ( !util.object.equal(nextProps.formOption.sourceData, this.state.sourceData)) {
        this.setState({
          sourceData: nextProps.formOption.sourceData
        });
      }
      if ( !util.object.equal(nextProps.formOption, this.state.formOption)) {
			
		  this.setState({
			formOption: nextProps.formOption
		  });
      }
    }
  }

  onFieldChange(key, value,that) { 
    let self = this;
    let initValue = this.state.initValue;
    initValue[key] = value;
    this.setState({
      initValue: initValue
    });
    
    var indextr = this.state.formOption.indextr;
    for (let field of this.props.formOption.fields) {
      if(field.editor&&field.data === key){
        if(field.editor.onChange){
          field.editor.onChange(key,value,indextr,that);
        }
      }
    }
  }
  
  onFieldSearch(key, value,that) {
    var indextr = this.state.formOption.indextr;
    for (let field of this.props.formOption.fields) {
      if(field.editor&&field.data === key) {
        if(field.editor&&field.editor.onSearch) {
          field.editor.onSearch(key,value,indextr,that);
        }else{
          if(field.editor.inline&&field.editor.inline.onSearch){
            field.editor.inline.onSearch(key,value,indextr,that);
          }
        }
      }
    }
  }

  validate() {
    return validate(this.state.initValue,this.props.formOption.fields);
    /*let dto = this.state.initValue;
    validate();
    //验证数据合法性
    let fieldOption = this.props.formOption.fields;
    for (let field of fieldOption) {
      if (!field.editor) continue;
      if (field.editor.isRequired && util.string.isEmpty(dto[field.data])) {
        message.error('`' + field.title + '`不能为空.');
        return false;
      }
      if (field.editor.validateRegular) {
        let reg = typeof (field.editor.validateRegular) === 'string' ? new RegExp(field.editor.validateRegular) : field.editor.validateRegular;
        if (reg.test && !reg.test(dto[field.data])) {
          message.error('`' + field.title + '`数据格式不正确.');
          return false;
        }
      }
    }
    return true;*/
  }

  saveClick(callback) {
    let dto = this.state.initValue;

    request({
      url: this.props.formOption.saveUrl,
      method: "post",
      data: dto
    }).then(function (result) {
      if(result.success)
      message.success((result.msg)?result.msg:'保存成功');
      else
      message.error(result.msg);
      if (callback) callback(result);
    });
  }

  render() {
    let self = this;
    let fieldOptions = [];

    for (let field of this.props.formOption.fields) {
      if (field.type === "command") continue;
      if (field.data === "id") continue;
      
      var hasProp = false;  
      if (field.editor){
        for (var prop in field.editor){  
            hasProp = true;  
            break;  
        }  
      }
      //if (!field.editor||!hasProp) continue;
      if (!field.editor) continue;

      let pattern = self.props.formOption.model === 'add' ? field.editor.ap : field.editor.ep;
      if (pattern === 'hide') continue;

        
      for (let field of this.props.formOption.fields) {
        if(field.editor&&field.editor.value){
          
          if(typeof (field.editor.value) === 'function' ){
            self.state.initValue[field.data]=field.editor.value();
          }else {
            self.state.initValue[field.data]=field.editor.value;
          }
        }
      }

      let fieldOption = {
        name: field.title,
        key: field.data,
        tips: field.editor.tips,
        isRequired: field.editor.isRequired,
        validateRegular: field.editor.validateRegular,
        step: field.editor.step,
        precision: field.editor.precision,
        fieldType: field.type,
        value: typeof (field.editor.value) != 'undefined' ? (typeof (field.editor.value) === 'function'?field.editor.value(): field.editor.value):(typeof (self.state.initValue[field.data]) === 'undefined' ? '' : self.state.initValue[field.data] + ''),
        disabled: pattern === 'disabled',
        source: field.source || {},
        innerProps:field.editor.innerProps,
        width:field.width
      }
      fieldOptions.push(fieldOption);
    }
    let fields = fieldOptions.map(function (field, index) {
      let sourceKeyMap = self.state.sourceData;
      let sourceData = sourceKeyMap[field.key];
      
      let col = field;
      let data = self.props.formOption.value;
      if(col.source && col.source.params && col.source.params.length>0 && sourceData){
                    let pramstring = "";
                    let qurystr = "";
                    for(var param in col.source.params){
                      if(data[col.source.params[param].key]){
                        pramstring = data[col.source.params[param].key];
                      }
                      qurystr += col.source.params[param].key+"="+pramstring+"&";
                    }
                    sourceData = sourceData[qurystr.replace("&","_").replace("=","-")];
      }
      sourceData = hashToArray(sourceData);

      return <AutoField key={'auto_field_' + index} fieldOption={field} fieldData={sourceData} 
      onChange={(key, value) => {
        self.onFieldChange(key, value)
      }} onSearch={(key, value,that) => {
        self.onFieldSearch(key, value,that)
      }} />;
    });

    return (
      <Form>
        {fields}
      </Form>
    );
  }
}

BirdGridForm.propTypes = {
  formOption: PropTypes.object.isRequired,
  onChange: PropTypes.func
}

export default BirdGridForm
