import React from 'react';
import DetailHeader from './DetailHeader';
import { Checkbox, Col, Row, Input, Button, Table, Tabs, Select, Divider, Icon } from 'antd';
import { jrequest } from 'utils/request';

class MetaTableDetail extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            realNode: props.nodeDetail.realNode,
            columns: props.nodeDetail.columns
        }
    }

    componentWillReceiveProps(props) {
        this.setState({
            realNode: props.nodeDetail.realNode,
            columns: props.nodeDetail.columns
        });
    }

    getColumnDef = () => {
        let columnDef = [{
            title: "字段",
            dataIndex: 'name',
            key: "name",
            width: "15%",
        }, {
            title: "类型",
            dataIndex: "type",
            key: "type",
            width: "10%",
        }, {
            title: "属性名称",
            dataIndex: "cnName",
            key: "cnName",
            width: "15%",
        }, {
            title: "属性描述",
            dataIndex: "comment",
            key: "comment",
            width: "10%",
        }, {
            title: "长度",
            dataIndex: "length",
            key: "length",
            width: "8%",
        }, {
            title: "精度",
            dataIndex: "prec",
            key: "prec",
            width: "8%",
        }, {
            title: "可为空",
            dataIndex: "nullable",
            key: "nullable",
            width: "10%",
            render: (text, row, index) => <Checkbox checked={row.entry.nullable} disabled={true} />
        }, {
            title: "主键",
            dataIndex: "pk",
            key: "pk",
            width: "5%",
            render: (text, row, index) => <Checkbox checked={row.entry.pk} disabled={true} />
        }, {
            title: "备注",
            dataIndex: "remark",
            key: "remark",
        }];
        return columnDef;
    }

    render() {
        let columnDefs = this.getColumnDef();
        // let topButtons = [
        //     { label: "表数据查看", icon: "file-search", type: "primary", onClick: (e) => { console.log("暂时未实现"); } },
        //     { label: "表数据导出", icon: "export", type: "primary", onClick: (e) => { console.log("暂时未实现"); } },
        // ];
        let allColCount = <span style={{marginLeft:"10px"}}>总行数:{this.state.columns.length}</span>;

        return (
            <div style={{ backgroundColor: "white" }}>
                {/* <DetailHeader buttons={topButtons} /> */}
                <Tabs type="card" style={{ marginTop: "20px" }} >
                    <Tabs.TabPane tab="字段信息" key="columns">
                        <Table
                            columns={columnDefs}
                            dataSource={this.state.columns}
                            rowKey='id'
                            bordered
                            pagination={false}
                            scroll={{ y: "600px" }}
                        />
                    </Tabs.TabPane>
                    <Tabs.TabPane tab="基本信息" key="info">
                    <div style={{ maxWidth: "550px", marginLeft:"25px" }}>
                            <div style={{ marginBottom: 10 }}>
                                <Input key={this.state.realNode.name} addonBefore="名称" defaultValue={this.state.realNode.name} disabled={true} />
                            </div>
                            <div style={{ marginBottom: 10 }}>
                                <Input key={this.state.realNode.name} addonBefore="中文名称" defaultValue={this.state.realNode.cnName} disabled={true} />
                            </div>
                            <div style={{ marginBottom: 10 }}>
                                <Input key={this.state.realNode.name} addonBefore="描述" defaultValue={this.state.realNode.comment} disabled={true} />
                            </div>
                            <div style={{ marginBottom: 10 }}>
                                <Input key={this.state.realNode.name} addonBefore="备注" defaultValue={this.state.realNode.remark} disabled={true} />
                            </div>
                        </div>
                    </Tabs.TabPane>
                </Tabs>
            </div>
        );
    }
}

export default MetaTableDetail