import React from 'react';
import { jrequest } from 'utils/request';
import { Input, Modal, Button } from 'antd';

class AddFolder extends React.Component {
    constructor(props){
        super(props);
        this.state = {
            visible: false,
            confirmLoading:false,
        }
        this.staticData = {
            name:"",
            cnName:"",
            comment:"",
            remark:""
        }
    }

    componentWillReceiveProps(props) {
        //重新刷新缓存值
        this.staticData.name = "";
        this.staticData.cnName = "";
        this.staticData.comment = "";
        this.staticData.remark = "";
    }

    onCancel = () => {
        this.setState({
            visible: false
        });
    }

    onOk = () => {
        this.setState({
            confirmLoading: true
        });

        let node = this.props.realNode;
        let packageType = 0;
        switch (node.namespace) {
            case "PDM": packageType = 1; break;
            case "ITF": packageType = 2; break;
            case "DB": packageType =3;break;
            case "HOST": packageType = 4;break;
            default: packageType = 0;
        }
        let data = {
            prtId: node.id,
            name: this.staticData.name,
            bizDomain: node.bizDomain,
            nodeType: "core.BasePackage",
            parent:true,
            comment: this.staticData.comment,
            remark: this.staticData.remark,
            namespace: node.namespace,
            cnName: this.staticData.cnName,
            packageType: packageType
        }

        jrequest({
            url:"/meta/package",
            method:"post",
            data:data
        }).then((result) => {
            this.setState({
                confirmLoading:false,
                visible: false
            });
            //成功后的回调
            this.props.afterOk(true);
        }).catch((error) => {
            this.setState({
                confirmLoading:false
            });
        });
    }

    render() {
        return (
            <div>
                <Button icon="folder-add" type="primary" onClick={(e) => {
                    this.setState({ visible: true });
                }}>添加下级目录</Button>

                <Modal title="添加下级目录"
                    visible={this.state.visible}
                    onOk={this.onOk}
                    onCancel={this.onCancel}
                    confirmLoading={this.confirmLoading}>

                    <div style={{ maxWidth: "550px", marginLeft: "25px" }}>
                        <div style={{ marginBottom: 10 }}>
                            <Input addonBefore="名称" onChange={(e) => {
                                this.staticData.name = e.target.value;
                            }} />
                        </div>
                        <div style={{ marginBottom: 10 }}>
                            <Input addonBefore="中文名称" onChange={(e) => {
                                this.staticData.cnName = e.target.value;
                            }} />
                        </div>
                        <div style={{ marginBottom: 10 }}>
                            <Input addonBefore="描述" onChange={(e) => {
                                this.staticData.comment = e.target.value;
                            }} />
                        </div>
                        <div style={{ marginBottom: 10 }}>
                            <Input addonBefore="备注" onChange={(e) => {
                                this.staticData.remark = e.target.value;
                            }} />
                        </div>
                    </div>
                </Modal>
            </div>

        );
    }
}

export default AddFolder