import React from 'react';
import { jrequest } from 'utils/request';
import { Input, Modal, Button, message } from 'antd';

class AddPDM extends React.Component {
    constructor(props){
        super(props);
        this.state = {
            visible:false,
            confirmLoading:false
        }
        this.staticData = {
            name:"",
            cnName:"",
            comment:"",
            remark:""
        }
    }

    componentWillReceiveProps(props) {
        //重新刷新缓存值
        this.staticData.name = "";
        this.staticData.cnName = "";
        this.staticData.comment = "";
        this.staticData.remark = "";
    }

    onCancel = () => {
        this.setState({
            visible: false
        });
    }

    onOk = () => {
        this.setState({
            confirmLoading: true
        });

        let node = this.props.realNode;
        let data = {
            prtId: node.id,
            name: this.staticData.name,
            bizDomain: node.bizDomain,
            nodeType: "model.PhysicalModel",
            parent:true,
            comment: this.staticData.comment,
            remark: this.staticData.remark,
            namespace: node.namespace,
            cnName: this.staticData.cnName
        }

        jrequest({
            url:"/meta/pdm",
            method:"post",
            data:data
        }).then((result) => {
            this.setState({
                confirmLoading:false,
                visible: false
            });
            //成功后的回调
            this.props.afterOk(true);
            message.success("添加成功");
        }).catch((error) => {
            this.setState({
                confirmLoading:false
            });
            message.error("添加失败");
        });
    }

    render() {
        return (
        <div>
            <Button style={{ marginRight: "8px" }} key="click-add" icon="file-add" type="primary" onClick={(e) => {
                this.setState({visible:true});
            }}>添加表</Button>
            <Modal
                visible={this.state.visible}
                onOk={this.onOk}
                onCancel={this.onCancel}
                confirmLoading={this.confirmLoading}
            >
                <div style={{ maxWidth: "550px", marginLeft: "25px" }}>
                    <div style={{ marginBottom: 10 }}>
                        <Input addonBefore="名称" onChange={(e) => {
                            this.staticData.name = e.target.value;
                        }} />
                    </div>
                    <div style={{ marginBottom: 10 }}>
                        <Input addonBefore="中文名称" onChange={(e) => {
                            this.staticData.cnName = e.target.value;
                        }} />
                    </div>
                    <div style={{ marginBottom: 10 }}>
                        <Input addonBefore="描述" onChange={(e) => {
                            this.staticData.comment = e.target.value;
                        }} />
                    </div>
                    <div style={{ marginBottom: 10 }}>
                        <Input addonBefore="备注" onChange={(e) => {
                            this.staticData.remark = e.target.value;
                        }} />
                    </div>
                </div>
            </Modal>
        </div>
        )
    }
}

export default AddPDM