import React from 'react';
import { jrequest } from 'utils/request';
import { Input, Modal, Button, Icon } from 'antd';

class DeleteFolder extends React.Component {
    constructor(props){
        super(props);
        this.state = {
            visible: false,
            confirmLoading:false,
        }
    }

    onCancel = () => {
        this.setState({
            visible: false
        });
    }

    onOk = () => {
        let id = this.props.realNode.id;

        jrequest({
            url:"/meta/node",
            method:"delete",
            data:{'id':id}
        }).then((result) => {
            this.setState({
                confirmLoading:false,
                visible: false
            });
            //成功后的回调
            this.props.afterOk(false);
        }).catch((error) => {
            this.setState({
                confirmLoading:false
            });
        })
    }

    render() {
        return(
            <div>
                <Button icon="delete" type="danger" onClick={(e) => {
                    this.setState({ visible: true });
                }}>删除目录</Button>
                <Modal title="删除目录"
                    visible={this.state.visible}
                    onOk={this.onOk}
                    onCancel={this.onCancel}
                    okButtonProps={{ type:"danger" }}
                    confirmLoading={this.confirmLoading}>
                    <Icon type="exclamation-circle" style={{color:"red"}} /> 注意，此操作会同时删除子项！
                </Modal>
            </div>
        );
    }
}

export default DeleteFolder