import React from 'react';
import { jrequest } from 'utils/request';
import { Input, Modal, Button, Select, Collapse,Row, Col, message } from 'antd';

const { TextArea } = Input;

export default class EditSqlManageModal extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            visible: false,
            confirmLoading:false,

            description:props.modalData.description,
            sql: props.modalData.sql,
        }

        this.staticData = {
            description:props.modalData.description,
            sql: props.modalData.sql,
        }
    }

    componentWillReceiveProps(props) {
        this.staticData = {
            description:props.modalData.description,
            sql: props.modalData.sql,
        }

        this.setState({
            description:props.modalData.description,
            sql: props.modalData.sql,
        });
    }

    //显示modal框
    showModal = () => {
        this.setState({
            visible: true,
          });
    }

    //点击确定
    handleOk = () => {
        if(this.props.modalData.isUpdate) {
            let objectData = this.props.modalData.objectData;
            this.setState({confirmLoading:true});
            //更新的情况
            objectData.description = this.staticData.description;
            objectData.sql = this.staticData.sql;
            jrequest({
                url:"/sql/sql",
                method:"put",
                data:objectData
            }).then((result) => {
                if(result.success) {
                   //跟新后的回调
                   this.props.afterOk();
                   this.setState({confirmLoading:false,visible:false});
                } else {
                    message.error(result.msg);
                    this.setState({confirmLoading:false});
                }
            }).catch((error) => {
                this.setState({confirmLoading:false});
            });
        } else {
            //新增的情况
            let objectData = {
                sql: this.staticData.sql,
                description: this.staticData.description
            };
            jrequest({
                url:"/sql/sql",
                method:"post",
                data:objectData
            }).then((result) => {
                if(result.success) {
                   //跟新后的回调
                   this.props.afterOk();
                   this.setState({confirmLoading:false,visible:false});
                } else {
                    message.error(result.msg);
                    this.setState({confirmLoading:false});
                }
            }).catch((error) => {
                this.setState({confirmLoading:false});
            });
        }
    }

    handleCancel = () => {
        this.setState({
            visible: false,
          });
    }

    render() {
        let modalData = this.props.modalData;
        return (
            <div>
                <Button style={{ float: "left" }} type="primary" onClick={this.showModal}>{modalData.type}</Button>
                <Modal
                    title={modalData.type}
                    visible={this.state.visible}
                    onOk={this.handleOk}
                    confirmLoading={this.state.confirmLoading}
                    onCancel={this.handleCancel}>

                    <Row gutter={8} style={{ marginBottom: "50px" }}>
                        <Col span={4}>配置描述:</Col>
                        <Col span={20}>
                            <Input defaultValue={this.state.description} onChange={(e) => this.staticData.description = e.target.value} />
                        </Col>
                    </Row>
                    <Row gutter={8} style={{ marginBottom: "50px" }}>
                        <Col span={4}>sql:</Col>
                        <Col span={20}>
                            <TextArea rows={4} defaultValue={this.state.sql} onChange={(e) => this.staticData.sql = e.target.value} />
                        </Col>
                    </Row>
                </Modal>
            </div>
        );
    }
}