import React,{ PureComponent} from 'react';
import { Tabs,message } from 'antd';
import PropTypes from 'prop-types';
import { connect } from 'dva';
import { routerRedux } from 'dva/router'
import { bindActionCreators } from 'redux';
import { util } from '../../../utils';

const { TabPane } = Tabs;

class TopTabs extends PureComponent {
  constructor(props) {
    super(props);
    this.newTabIndex = 0;
    // const panes = [
    //   { title: 'Tab 1', content: <div>eweweff<span>22</span></div>, key: '1' },
    //   { title: 'Tab 2', content: 'Content of Tab 2', key: '2' },
    //   {
    //     title: 'Tab 3',
    //     content: 'Content of Tab 3',
    //     key: '3',
    //     closable: false,
    //   },
    // ];
    
    let panes = this.props.panes;
    let activeKey = this.props.activeKey;
    let remove = this.props.remove;
    this.state = {
      activeKey: activeKey?activeKey:panes[0].key,
      panes,
      remove
    };
    this.onChange.bind(this);
  }

  /* 性能优化 props改变才渲染 */
  // shouldComponentUpdate(nextProps,nextState){
  //   if(util.object.equal(nextProps, this.props)&&
  //   util.object.equal(nextState, this.state)){ //传入的count与组件当前props的count比较,count没改变，return false，不渲染
  //     return false    //不渲染
  //   }
  //   return true;  //渲染
  // }

  onChange = activeKey => {
    this.setState({ activeKey });
  };

  onEdit = (targetKey, action) => {
    this[action](targetKey);
  };

  add = () => {
    const panes = this.props.panes;
    const activeKey = `newTab${this.newTabIndex++}`;
    panes.push({ title: 'New Tab', content: 'Content of new Tab', key: activeKey });
    this.setState({ panes, activeKey });
  };

  remove = targetKey => {
    if(this.props.panes.length == 1){
      message.error('至少保留一个');
      return false;
    }
    let activeKey = this.state.activeKey;
    let lastIndex;
    this.props.panes.forEach((pane, i) => {
      if (pane.key === targetKey) {
        lastIndex = i - 1;
      }
    });
    //globalPanes.splice(lastIndex+1,1);
    const panes = this.props.panes.filter(pane => pane.key !== targetKey);
    let menuPath = [];
    if (panes.length ) {
      if(activeKey === targetKey){
        if (lastIndex >= 0) {
          activeKey = panes[lastIndex].key;
          menuPath = panes[lastIndex].menuPath;
        } else {
          activeKey = panes[0].key;
          menuPath = panes[0].menuPath;
        }
      }else{
        if (lastIndex >= 0) {
          activeKey = panes[lastIndex].key;
          menuPath = panes[lastIndex].menuPath;
        } else {
          activeKey = panes[0].key;
          menuPath = panes[0].menuPath;
        }
      }
    }
    this.setState({ panes, activeKey,menuPath });
    this.props.remove(menuPath,lastIndex);
  };

  componentWillReceiveProps(nextProps) {
    this.setState({
      // panes: nextProps.panes,
      activeKey: nextProps.activeKey,
      menuPath: nextProps.menuPath,
      // remove: nextProps.remove
    });
  }

  render() {
    
    return (
      <Tabs
        hideAdd
        onChange={this.onChange}
        activeKey={this.state.activeKey}
        type="editable-card"
        onEdit={this.onEdit}
      >
        {this.props.panes.map(pane => (
          <TabPane tab={pane.title} key={pane.key} closable={pane.closable} 
          ref="toppan">
            {pane.content}
          </TabPane>
        ))}
      </Tabs>
    );
  }
}

TopTabs.propTypes = {
  panes: PropTypes.array.isRequired,
  activeKey: PropTypes.string,
  remove: PropTypes.func
}

TopTabs.defaultProps = {
  panes: [],
}

export default TopTabs;