import { config, util, arrayToTree,permission } from 'utils'
import { routerRedux } from 'dva/router'
import * as menuService from 'services/menus'
import * as permissionsService from 'services/permissions'
import queryString from 'query-string'

export default {
  namespace: 'app',
  state: {
    cfMenu: {},
    globalPanes: [],
    menusMeta: [],//菜单元数据
    menus: [],//菜单树形数据
    topmenus: [],
    menuHash: {},
    menuPath: [{id:"252",name:"仪表盘",url:"/dashboard"}],
    openKeys: [],
    selectedKeys: [],
    locationPath: '',
    locationQuery: {},
    topOpenKeys:[]
  },
  subscriptions: {
    setupHistory({ dispatch, history }) {
      history.listen((location) => {
        dispatch({
          type: 'updateState',
          payload: {
            locationPath: location.pathname,
            locationQuery: location.query,
          },
        })
      })
      
      dispatch({ 
        type: 'query',payload:{
          // locationPath: location.pathname,
          // locationQuery: location.query,
        }
      })
      
    },

    //  setup({ dispatch }) {
    //   dispatch({ type: 'query' })
    //  }
  },
  effects: {

    * query({ payload }, { call, put, select }) {
      const { locationPath } = yield select(_ => _.app);
      const { menuPath } = yield select(_ => _.app);
      var { globalPanes } = yield select(_ => _.app);
      // var locationPath = "";
      // if(payload)
      // var { locationPath } = payload;

      let user = util.auth.getUser();
      if (user) {
        let menus = yield call(menuService.query,{type:"U",parentId:""});
        let menuHash = {}, openKeys = [];

        let topMenus = yield call(menuService.query,{type:"M"});
        let topOpenKeys = [];
        if(menus && menus.length > 0){
            //顶部菜单初始化
            let topMenusNode = util.json.generateNode(topMenus);

            topMenusNode.forEach(item => { menuHash[item.id] = item });
            if (topMenusNode.length > 0) {
              topOpenKeys = [`${topMenusNode[0].id}`];
            }
            let topMenuTree = arrayToTree(topMenusNode, 'id', 'parentId');
          
            //侧边菜单初始化
            let menusNode = util.json.generateNode(menus);

            menusNode.forEach(item => { menuHash[item.id] = item });
            if (menusNode.length > 0) {
              openKeys = [`sMenu_${menusNode[0].id}`];
            }
            let menuTree = arrayToTree(menusNode, 'id', 'parentId');
          
  
          let permissions = permission.getPermissions();
          if (!permissions) {
            permissions = yield call(permissionsService.query);
            permission.setPermissions(permissions)
          }
  
          //获取当前location的menupath 用于刷新时面包屑的menupath丢失
          var menuPath1 = [{id:"252",name:"仪表盘",url:"/dashboard"}];
          if(locationPath && locationPath !='' ) menuPath1 = menus.filter(menu => menu.url === locationPath); //刚登陆为''
          if(locationPath && locationPath !='' &&menuPath1 &&menuPath && menuPath.length && menuPath1.length 
            && menuPath[0].id == "252"&& menuPath[0].id != menuPath1[0].id)  
            globalPanes = [];//刷新时默认globalPanes设为[]

             
          yield put({
            type: 'updateState',
            payload: {
              user: { userName: user.username },
              globalPanes:globalPanes,
              menuPath:menuPath1,
              menusMeta: menusNode,//菜单元数据
              menus: menuTree,//菜单树形数据
              cfMenu: menuTree.length > 0 ? menuTree[0] : {},
              menuHash,
              openKeys,
              topMenusNode: topMenusNode,//菜单元数据
              topMenus: topMenuTree,
              topOpenKeys
            },
          })
        }else{
           util.auth.removeToken();
           permission.clear();
          //  window.location.href = "/";
           yield put(routerRedux.push({
            pathname: '/',
            search: queryString.stringify({
              from: ''
            })
          }))
        }
      }else if(config.openPages && config.openPages.indexOf(locationPath) < 0){
        yield put(routerRedux.push({
          pathname: '/login',
          search: queryString.stringify({
            from: locationPath
          })
        }))
      }
    }
  },
  reducers: {
    updateState(state, { payload }) {
      return {
        ...state,
        ...payload,
      }
    }
  }
}