import React, { Component } from 'react';
import { BirdGrid } from 'components/Grid';
import { config } from 'utils';

const { JAPIV } = config;

class AreaData extends Component {
    constructor(props) {
        super(props);
        this.state = {};
    }

    handleRedirc = (data) => {
        console.log(data);
        const w = window.open('about:blank');
        w.location.href = "areaTags?ObjectId=" + data.id
    }

    render() {
        let self = this;

        let gridOption = {
            title: "区域数据",
            url: {
                read: JAPIV + "/areaData/areaDataCondition",
                // add: "/test/add",
                // edit: "/test/edit",
                // delete: "/test/delete"
            },
            // method: "get",
            // size: 8,
            // page: 1,
            checkable: false,
            //actions: [{ name: '外部按钮', color: 'error', onClick: function () { } }],
            columns: [
                { title: "id", data: "id", editor: {}, type: "number", hide: true },
                { title: "地区编号", data: "MappingCode", type: "number" },
                { title: "地区名称", data: "AreaName", type: "text", query: true },
                { title: "上级地区", data: "ParentAreaName", type: "text" },
                {
                    title: "操作", type: "command", actions: [{
                        name: '标签',
                        color: '#67c23a',
                        onClick: (data) => {
                            this.handleRedirc(data);
                        }
                    }]
                }
            ]
        };

        return (
            <div>
                <BirdGrid gridOption={gridOption} ref="grid" />
            </div>
        );
    }
}

export default AreaData;