import React, { Component } from 'react';

// 引入 ECharts 主模块
import echarts from 'echarts/lib/echarts';
// 引入柱状图
import  'echarts/lib/chart/bar';
// 引入饼状图
import  'echarts/lib/chart/pie';
// 引入散点图
import  'echarts/lib/chart/scatter';
// 引入提示框
import 'echarts/lib/component/tooltip';
//引入标题组件
import 'echarts/lib/component/title';

import {
  request,
  config,
  util,
  permission
} from 'utils';

class EchartsTest extends Component {
  constructor(props) {
    super(props)
    this.state = {
      options: ""
    }
  }


    componentDidMount() {
        let o = this;
        // 基于准备好的dom，初始化echarts实例
        var myChart = echarts.init(document.getElementById('main'));
        
       

        //获取数据
        var json={"query":"select a.AppreciationPrice  from product a limit 2"};
        request({
          url: 'http://localhost:5080/value/sql',
          // data:{
          //   format:json
          // },
          data:json,
          method: "post",
        }).then(res=>{
          console.log(res)
             // 绘制图表
          myChart.setOption({
            title: { text: 'ECharts' },
            tooltip: {},
            //xAxis: {
            //data: ["衬衫", "羊毛衫", "雪纺衫", "裤子", "高跟鞋", "袜子"]
            //},
            //yAxis: {},
            series: [{
                name: '销量',
                type: 'pie',
                data: [res.rows[0],res.rows[1]]
            }]
          });
        })
    }
    render() {
        return (
            <div id="main" style={{ width: 400, height: 500 }}></div>
        );
    }
}

export default EchartsTest;