import React from 'react';
import { BirdTreeGrid } from 'components/Grid';
import { config,request,permission,util } from 'utils'
import { message,Modal } from 'antd';
import AutoForm from 'components/Grid/BirdGridForm';
const { APIV3 } = config

class BirdGridPermissionPage extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
        customRule: [],
        paramName: '',
        itemClick:null,
        itemValue:null,
        formOption:[],
        formWidth: 520,
        formConfirmLoading:false,
        formOption:{modal:"",title:""},
    }
  }
  /* 弹出框取消事件 */
  cancelClick() {
    this.setState({
      formVisiable: false,
      formConfirmLoading: false,
    });
  }
  saveClick(callback) {
    let self=this;
    let form = this.refs.autoForm;
    if (!form.validate()) return;

    let dto = form.state.initValue;

    let extraParams = form.state.extraParams;
    for (let extra of extraParams) {
      dto[extra.field] = extra.value;
    }
    request({
      url:'/web/auth/add',
      method: "post",
      data: dto
    }).then(function (result) {
      if(result.success) {
        message.success('保存成功');
      } else {
        message.error(result.msg);
      }
      if (callback) callback(result);
      self.setState({
        formVisiable: false,
        formConfirmLoading: false,
      });
      self.refs.tg.getGrid().reload();
    });
  }
  render() {
    let self = this;
    let user = util.auth.getUser();
    let gridOption = {
      title: "内部账户",
      url: {
        read: "/web/auth/index",
        add: "/web/auth/add",
        edit: "/web/auth/edit",
        delete: "/web/auth/delete"
      },
      checkable: true,
      sortField:"Sort",
      sortDirection:0,
      columns: [
        { title: "权限id", data: "Id", type: "number" },
        { title: "权限名", data: "PermissionName", type: "text", editor: {}, query: true, isRequired: true },
        { title: "权限url", data: "PermissionUrl", type: "text", editor: {}, query: true, isRequired: true },
        { title: "类型", data: "AuthType", type: "dropdown", editor: {}, source: { url: '/web/auth/authType' }, query: true },
        { title: "权限图标", data: "Icon", type: "text", editor: {}, query: true },
        { title: "父权限", data: "ParentId", type: "dropdown", editor: {},source: { url: '/web/auth/parents' } ,query: true },
        { title: "是否禁用", data: "IsDelete", type: "switch", editor: {}, query: true },
        { title: "排序", data: "Sort", type: "number" },
        { title: "角色", data: "Roleids", type: "multi", editor: {}, source: { url: '/web/user/role' }, query: true },
        { title: "创建时间", data: "CreationDate", type: "datetime", query: true },
        {
          title: "操作选项", type: "command", actions: []
        }
      ],
      actions: [{ name: '按钮新增', onClick: function () {
          const fields=[
            { title: "权限id", data: "Id", type: "number" },
            { title: "权限名", data: "PermissionName", type: "text", editor: {}, query: true, isRequired: true },
            { title: "权限url", data: "PermissionUrl", type: "text", editor: {}, query: true, isRequired: true },
            { title: "类型", data: "AuthType", type: "dropdown", editor: {}, source: {data:[{value:'A',label:'按钮'}]}, query: true },
            { title: "按钮类型", data: "ActionType", type: "dropdown", editor: {}, 
              source: {
                data:[{value:'1',label:'外部按钮'},{value:'2',label:'内部按钮'}]
              }, query: true },
            { title: "权限图标", data: "Icon", type: "text", editor: {}, query: true },
            { title: "父权限", data: "ParentId", type: "dropdown", editor: {},source: {url: '/web/auth/parents'} ,query: true },
            { title: "是否禁用", data: "IsDelete", type: "switch", editor: {}, query: true },
            { title: "角色", data: "Roleids", type: "multi", editor: {}, source: { url: '/web/user/role' }, query: true },
            { title: "创建时间", data: "CreationDate", type: "datetime", query: true }
          ];
          let formOption = {
            model: "add",
            title: "按钮新增",
            fields: fields,
            value: {},
            extraParams: []
          };
          self.setState({
            formVisiable: true,
            formOption: formOption
          });
        }
      }]
    };
    
    let treeOption = {
      url: "/web/auth/menusTree?type=U','O','M",
      canSelectFolder: false,
      expandAll: true,
      paramName:"ParentId",
      onSelect: (value,selectKeys,type) => {
        if(type === "folder"){
          self.refs.tg.getTree().setState({selectedKeys: selectKeys});
        }
      },
      title:"树实例"
    };

    return <div><BirdTreeGrid gridOption={gridOption}
    treeOption = {treeOption}  ref='tg' />
      <Modal title={this.state.formOption.title}
        width={this.state.formWidth}
        visible={this.state.formVisiable}
        onOk={() => this.saveClick()}
        onCancel={() => this.cancelClick()}
        confirmLoading={this.state.formConfirmLoading}
        ><AutoForm formOption={this.state.formOption} ref="autoForm" /></Modal>
      </div>
  }
}
export default BirdGridPermissionPage
