import React from 'react';
import {Card} from 'antd';
import {BirdForm} from 'components/Form';
import { config } from 'utils'
const { APIV3 } = config

const fields=[
  {
    name: '权限名',
    key: 'PermissionName',
    fieldType: 'text',
    isRequired: true,
    tips:'我是提示啊',
    groupName:'基础信息',
  },
  {
    name: '权限url',
    key: 'PermissionUrl',
    fieldType: 'text',
    isRequired: true,
    value:'2222',
    groupName:'基础信息',
  },
  {
    name: '类型',
    key: 'AuthType',
    fieldType: 'dropdown',
    source:{url:'/web/auth/authtype'},
    groupName:'基础信息',
  },
  {
    name: '权限图标',
    key: 'Icon',
    fieldType: 'text',
    isRequired: true,
    groupName:'基础信息',
  },
  {
    name: '父权限',
    key: 'ParentId',
    fieldType: 'dropdown',
    source:{url:'/web/auth/parents'},
    groupName:'基础信息',
  },
  {
    name: '是否禁用',
    key: 'IsDelete',
    fieldType: 'switch',
    groupName:'基础信息',
  },
  /*{
    name: '权限创建人',
    key: 'CreationPerson',
    fieldType: 'text',
    groupName:'基础信息',
  },*/
  {
    name: '角色',
    key: 'Roleids',
    fieldType: 'multi',
    source:{url:'/web/user/role'},
    groupName:'基础信息',
  }
];

class BirdFormDemoPage extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
    }
  }

  render() {

    return (
      <Card>
        <BirdForm fields={fields} lineCapacity={1} saveUrl={'/web/auth/add'} withTab={true} value={{}}/>
      </Card>
    )
  }
}

export default BirdFormDemoPage
