import React from 'react';
import { BirdGrid } from 'components/Grid';
import { config,request,permission,util } from 'utils'
import { message,Modal } from 'antd';
import AutoForm from 'components/Grid/BirdGridForm';
const { APIV3 } = config

class BirdGridOrgPage extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
        customRule: [],
        paramName: '',
        itemClick:null,
        itemValue:null,
        formOption:[],
        formWidth: 520,
        formConfirmLoading:false,
        formOption:{modal:"",title:""},
    }
  }
  /* 弹出框取消事件 */
  cancelClick() {
    this.setState({
      formVisiable: false,
      formConfirmLoading: false,
    });
  }
  saveClick(callback) {
    let self=this;
    let form = this.refs.autoForm;
    if (!form.validate()) return;

    let dto = form.state.initValue;

    let extraParams = form.state.extraParams;
    for (let extra of extraParams) {
      dto[extra.field] = extra.value;
    }
    request({
      url:'/web/org/add',
      method: "post",
      data: dto
    }).then(function (result) {
      if(result.success) {
        message.success('添加成功');
      } else {
        message.error(result.msg);
      }
      if (callback) callback(result);
      self.setState({
        formVisiable: false,
        formConfirmLoading: false,
      });
      self.refs.grid.reload();
    });
  }
  render() {
    let self = this;
    let user = util.auth.getUser();
    let gridOption = {
      title: "机构管理",
      url: {
        //read: "/web/auth/index",
        read: "/web/org/index",//-tanyang
        add: "/web/org/add",
        edit: "/web/org/edit",
        delete: "/web/org/delete"
      },
      primaryKey:"OrgId",
      checkable: true,
      columns: [
        //{ title: "组织id", data: "id", type: "number" },
        { title: "组织id", data: "OrgId", type: "text",hide:true},//-tanyang
        { title: "组织编码", data: "OrgCode", type: "text", editor: {}, query: true, isRequired: true },
        { title: "组织名称", data: "OrgName", type: "text", editor: {}, query: true , isRequired: true },
        { title: "父权限编码", data: "FullCode", type: "dropdown", editor: {},source: { url: '/web/org/parents' },  query: true },
      //  { title: "父权限编码", data: "FullCode", type: "dropdown", editor: {},  query: true },
        { title: "父权限名", data: "FullName", type: "dropdown", editor: {},source: { url: '/web/org/parents' } ,query: true },
        //{ title: "用户id", data: "userid", type: "dropdown", editor: {},source: { url: '/web/org/roles' } ,query: true },
        {
          title: "操作选项", type: "command", actions: []
        }
      ]
    };
    return <div><BirdGrid gridOption={gridOption} ref="grid"/>
      <Modal title={this.state.formOption.title}
        width={this.state.formWidth}
        visible={this.state.formVisiable}
        onOk={() => this.saveClick()}
        onCancel={() => this.cancelClick()}
        confirmLoading={this.state.formConfirmLoading}
        ><AutoForm formOption={this.state.formOption} ref="autoForm" /></Modal>
      </div>
  }
}
export default BirdGridOrgPage
