import React from 'react';
import {message,Card} from 'antd';
import {BirdTreeGrid} from 'components/Grid';
import {
    config,
    request,
    util
  } from 'utils';
  const {
    APIV3
  } = config


class BirdTreeDemoPage extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
        //customRule:[{field:'field-text',value:'4'}]   
        roleId:1     
    }
  }

  /**
   * 树条目点击事件
   * @param value
   */
  itemClick(value) {
      this.setState({roleId: value -1})       
  }

  render() {
    let o = this;
    let gridOption = {
      title: "权限列表",
      url: {
        read: "/web/auth/table"
      },
      checkable: true,
      autoQuery:false,   
      pageSize:20,
      primaryKey:'id',        
      //afterQuery:	(result,filters)=>{alert(JSON.stringify(filters))},
      sortField:"Sort",
      actions: [{ name: '保存', color: 'error', onClick: function (checkedValues) {
        request({
            url: APIV3 + '/web/auth/setrole',
            method: "post",
            data: {data:checkedValues,roleId: o.state.roleId}
          }).then(function (result) {
            if (result.success)
              message.success('提交成功');
            else
              message.error(result.msg);
          });
      } }],
      columns: [
        { title: "编号", data: "id", type: "number" },
        { title: "菜单名称", data: "permissionName", type: "text", editor: {}, query: true },
        { title: "菜单URL", data: "permissionUrl", type: "text", editor: {}, query: true },
        { title: "菜单操作权限", data: "permissionRule", type: "text", editor: {inline:{}}, query: false },
        { title: "菜单操作权限类型", data: "permissionRuleType", type: "dropdown", editor: {inline:{}}, source: { url: '/web/auth/getruletype' }, query: false },
        { title: "类型", data: "authType", type: "dropdown", editor: {}, source: { url: '/web/auth/authtype' }, query: true },
        { title: "排序", data: "Sort", type: "number" },
        {
          title: "操作选项", type: "command", actions: [{
            name: '保存',
            color: '#67c23a',
            onClick: (data) => {
              request({
                url: '/web/auth/editroleperm',
                method: "post",
                data: data
              }).then(function (result) {
                if (result.success)
                  message.success('保存成功');
                else
                  message.error(result.msg);
              });
            }
          }]
        }
      ]
    };

    let treeOptions = {
      url: '/web/auth/getrole',
      canSelectFolder: false,
      expandAll: true,
      paramName:"roleId",
      onSelect: value => this.itemClick(value),
      title:"树实例"
    };


    return (
        <BirdTreeGrid gridOption={gridOption} treeOption={treeOptions} ref='tg'/>
    )
  }
}

export default BirdTreeDemoPage
