import React from 'react';
import { BirdGrid } from 'components/Grid';
import { config } from 'utils'
import { connect } from 'dva';
const { APIV3 } = config

// class BirdGridRolePage extends React.Component {
//   constructor(props) {
//     super(props)
//     this.state = {
//     }
//   }
//   render() {
const BirdGridRolePage =  ({fetch, count, loading,menuPathId}) => {
    let gridOption = {
      title: "角色管理",
      url: {
        read: "/web/role/index",
        add: "/web/role/add",
        edit: "/web/role/edit",
        delete: "/web/role/delete"
      },
      checkable: true,
      primaryKey:"Id",
      columns: [
        { title: "角色id", data: "Id", type: "text" ,hide:true},
        { title: "角色名称", data: "RoleName", type: "text", editor: {}, query: true, isRequired: true },
        { title: "角色部分ID", data: "RoleDepartmentId", type: "text", isRequired: true ,hide:true},
        { title: "角色中文名", data: "RoleRemark", type: "text", editor: {}, query: true, isRequired: true },
        { title: "是否删除", data: "IsDelete", type: "text", isRequired: true ,hide:true},
        { title: "创造者", data: "CreationPerson", type: "text", isRequired: true ,hide:true},
        { title: "创建日期", data: "CreationDate", type: "datetime", isRequired: true },
        { title: "最后修改人", data: "LastModifiedPerson", type: "text", isRequired: true,hide:true },
        { title: "最后修改时间", data: "LastModified", type: "datetime", isRequired: true },
        {
          title: "操作选项", type: "command", actions: []
        }
      ]
    };
    return (
    <div>
      {/* <BirdGrid gridOption={gridOption} 
    menuPathId = {this.props.menuPathId} /> */}
    
    <BirdGrid gridOption={gridOption} 
    menuPathId = {menuPathId} />
    
    {loading ? <div>loading...</div> : <div>{count}</div>}
      <button onClick={() => fetch(count)}>add</button>
    </div>
    );
  }
// }

//字面意思就是，把models的state变成组件的props
function mapStateToProps (state) {
  const { menuPath} = state.app // test就是models命名空间名字 
  const auth = state.auth;
  
  let menuPathId = '';
  if(menuPath && menuPath.length>0) menuPathId = menuPath[0].id;
  return {
    ...auth,menuPath,menuPathId, // 在这return,上面才能获取到
  }
}

function mapDispatchToProps(dispatch) {
  return {
    fetch(count){
      dispatch({type: 'auth/fetch', count});
    }
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(BirdGridRolePage)
// export default BirdGridRolePage