import React from 'react';
import { BirdGrid } from 'components/Grid';
import { config,request,util } from 'utils'
import { connect } from 'dva';
import { routerRedux } from 'dva/router'
import { Modal,message, Row,Col,Button,DatePicker,Select} from 'antd';
const { Option } = Select;
import Panel from 'components/Panel';
import moment from 'moment';
import './order_statis.less';
const { MonthPicker, RangePicker } = DatePicker;
const dateFormat = 'YYYY/MM';

const { APIV3 } = config

class BirdGridElasticPage extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      visible:false,
      tagKey1:"",
      tagKey2:"",
      tagKey3:"",
      seleTag:[],
      tagKey:[],
      gridDatas:[],
      gridDataBuy:[],
      zKeyList:[],//终端已选
      dateStr:"0",//时间
      sumCount:0,
      sumCount1:0,
      sumCount2:0,
      sumCount3:0,
      filtData:{field:"tagKey",operate:"equal",value:""}
    }
  }
 
    //获取平台。终端
    componentDidMount(){
      let self=this
      if(self.state.items==null){
        request({
          url: APIV3+"/web/ES_UsageMem/getTermain",
         method: "post",
         data:[]
       }).then(function (result) {
         if(result.items!=null){
           self.setState({
             items:result.items
           })
         }
         if(result.items1!=null){
           self.setState({
             items1:result.items1
           })
         }
       }); 
      }

      request({
        url: APIV3+"/web/Mem_Terminaldoc/getgender",
        method: "get",
        data:[]
      }).then(function (result) {
        if(result!=null){
          self.setState({
           sexJson:result
          })
        }
      }); 

    }
          
  //关闭
  onCancel = () => {
    this.setState({ visible: false });
  };

  //确定
  onCreate = () => {
    this.setState({ visible: false });
  };

  unique5(arr){
    var x = new Set(arr);
   return [...x];
  }

  getTagList(){
    this.setState({
        formVisiable: true,
        formConfirmLoading: true
      });
  }
  rmTag(rowIndex){  
    this.state.seleTag.splice(rowIndex,1),
    this.state.tagKey.splice(rowIndex,1)
    this.setState({
      seleTag:this.state.seleTag,
      tagKey:this.state.tagKey
    }) 
  }
  cancelClick() {
    this.setState({
      formVisiable: false,
      formConfirmLoading: false
    });
  }
  onChangedate1(data,dateString){
    let filterRules=this.refs.grid.state.filterRules
    var emtp=true;
    for(var filter of filterRules){
      if(filter["field"]=="tagKey1"){
        filter["value"]=dateString;
        emtp=false;
      }
    }
    if(emtp){
      filterRules.push({
        field:"tagKey1",
        operate:"equal",
        value:dateString
      })
    }

    this.refs.grid.setState({
      filterRules:filterRules
    }); 
  }

  //所属终端
  handleChange1(arr){
    this.setState({
      zkeyList:arr
    })
    
    let filterRules=this.refs.grid.state.filterRules
    for(var i=0;i<filterRules.length;i++){
      if(filterRules[i].field=="tagKey3"){
        filterRules.splice(i,1)
      }
    }
    filterRules.push({
      field:"tagKey3",
      operate:"equal",
      value:arr.join(",")
    })
    this.refs.grid.setState({
      filterRules:filterRules
    }); 
  } 
  render() { 
    let self = this;
    let {items,gridDataBuy} = self.state
    //深分页参数
    var scroll_id="";
    /*
    if(gridDataBuy.current!=null&&gridDataBuy.current.state.gridDatas._scroll_id!=null){
      scroll_id=gridDataBuy.current.state.gridDatas._scroll_id
      let filtData=self.state.filtData
      filtData["field"]="scrollId";
      filtData["value"]=scroll_id;
        self.setState({
          filtData:filtData,//标签//平台//时间
      })
    }*/
    let itemsTag=[];//终端
    if(items!=null){
      itemsTag=items.map((data, rowIndex) => {
        itemsTag=[<Option key={rowIndex} value={data.ParentTerminalKey} label={data.TerminalDesc}>{data.TerminalDesc}</Option>]
       return itemsTag;
      })
    }




    let seTag=[];
        //标签  
    seTag = self.state.seleTag.map((data, rowIndex) => {
        seTag=[<div key={rowIndex} onClick={self.rmTag.bind(self,rowIndex)} style={{border:'1px solid #CDC9C9',padding:'5px 10px',float:'left',fontSize:'12px',margin:'0 1% 0 0',textAlign:"center"}}>{data.TagName}</div>]
        return seTag;
    })
    

    let gridOption = {
      title: "复购率统计",
      url: {
        read: "/web/ES_DataStais/index"
      },
      checkable: true,
      primaryKey:"_id",
      afterQuery:	function(filters,result){
        if(self.refs.grid.state.filterRules!=null){
          let filterRules=self.refs.grid.state.filterRules;
          let gridDatas=util.object.deepClone(self.refs.grid.state.gridDatas);
          
          var month="";
          for(var col in filterRules){
            if(filterRules[col].field=='tagKey1'&&filterRules[col].value!=null){
              month ="ym"+ filterRules[col].value.replace("-","");             
            }
          }       
          for(var item of gridDatas.items){
            if(item && month !="" &&item[month]!=null){
              item["MonthF"]=item[month].RN;
              item["MonthM"]=item[month].RM/100;
            }else{
              item["MonthF"]=item["F1"];
              item["MonthM"]=item["M1"];              
            }
          }       
          self.refs.grid.setState({gridDatas:gridDatas});
        }
        self.setState({
          sumCount:filters.jsonSum.M_COUNT.value,
          sumCount1:filters.jsonSum.M_COUNTS.M_COUNTS.value,
          sumCount2:filters.jsonSum.F_SUMS.F_SUMS.value,
          sumCount3:filters.jsonSum.M_SUMS.M_SUMS.value,
        })
        /*
        self.refs.grid.setState({
          filterRules:[{
            field:"Consignee",
            operate:"equal",
            value:"",
          }]
        },() => {
          self.setState({hasInitFilters:true});
        }); */
        },
        actions:[{
          name: '统计导出',
          color: '#67c23a',
          onClick: function(data) {
            window.location.href=APIV3+"/web/ES_DataStais/memorderExport"; 

          }
        }],
      columns: [
        { title: "手机号", data: "AConsigneePhone2", type: "text", editor: {}, query: false, isRequired: true },
        { title: "昵称", data: "Consignee", type: "text", editor: {}, query: true, isRequired: true },
        { title: "性别", data: "sex", type: "dropdown", query: false ,source: { data:self.state.sexJson}, isRequired: true },
        { title: "年龄", data: "age", type: "text",editor: {}, isRequired: true },
        { title: "总单数", data: "F1", type: "text", editor: {}, isRequired: true }, 
        { title: "总金额", data: "M1", type: "text", editor: {}, isRequired: true }, 
        { title: "下单月份", data: "tagKey1", type: "text", editor: {}, isRequired: true ,query:true,hide:true}, 
        { title: "用户标签", data: "tagKey2", type: "text", editor: {}, isRequired: true ,query:true,hide:true},
        { title: "下单终端", data: "tagKey3",type: "text", editor: {}, query: true,hide:true }, 
        { title: "复购单数", data: "MonthF", type: "text", editor: {}, isRequired: true }, 
        { title: "复购金额", data: "MonthM", type: "text", editor: {}, isRequired: true },  
        {
          title: "操作选项", type: "command", actions: [
            
            {
              name: '详情',
              color: '#67c23a',
              onClick: (data) => {
                this.props.dispatch({
                  type: 'app/updateState', payload: {
                    menuPath: [{id:"251",name:"个人用户管理"},{id:"249",name:"个人用户详情"}]
                  }
                });
                this.props.dispatch(routerRedux.push({
                  pathname: '/memdoc/mem_prescription',
                  query: {MemberPhone: data['id']},
                  })
                );
              }
            }
          ]
        }
      ]
    };





        //对象列表
        let gridOptionsTag = {
          title: "标签列表",
          url: {
            read: "/web/mem_tag/AllTagList"
          },
          primaryKey:'_id',
          columns: [
            { title: "标签ID", data: "_id", type: "text", editor: {ap: 'hide', ep: 'hide'}, isRequired: true },
            { title: "标签名称", data: "TagName", type: "text", editor: {},query:false,  query: true },
            { title: "标签类型名称", data: "TagTypeName", type: "text", editor: {ap: 'hide', ep: 'hide'},hide:true}, 
            { title: "标签类型", data: "TagTypeId", type: "dropdown", editor: {},
              source: { url: '/web/Mem_TagType/type?t='+self.state.randStr },query:true }, 
            { title: "标签名称", data: "TagName", type: "text", editor: {},query:false,  query: true },
          ],
          checkable: true,
          actions: [{
            name: '确认选择',
            onClick: function (e) {
              let arrTag=[]
              for(let key in e){
                  self.state.tagKey.push(e[key])
                  self.state.tagKey=self.unique5(self.state.tagKey)
                  arrTag.push(e[key])
                }
                var chilTag=self.state.gridDatas.current.state.gridDatas.items
                for(let tag in chilTag){
                  for(let key in self.state.tagKey){
                    if(self.state.tagKey[key]==chilTag[tag].TagId){
                      self.state.seleTag.push(chilTag[tag])
                      self.state.seleTag=self.unique5(self.state.seleTag)                     
                      break;
                    }
                  }
                }
              self.setState({
                formVisiable: false,
                formConfirmLoading: false
              });
              let filterRules=self.refs.grid.state.filterRules
              for(var i=0;i<filterRules.length;i++){
                if(filterRules[i].field=="tagKey2"){
                  filterRules.splice(i,1)
                }
              }
              filterRules.push({
                field:"tagKey2",
                operate:"equal",
                value:arrTag.join(",")
              })
              self.refs.grid.setState({
                filterRules:filterRules
              }); 
              
            }
          }]         
          };
    return <div>

      <div style={{width:'96%',margin:'30px 0 -20px 2%'}}>
        <Row gutter={20}>
            <div className="text-par">
            <Col md={4}>
              <Panel className="text-col" header={false} cover>
              <h3 className="text-muted">总下单会员数</h3>
                <h3>
                  <b>{self.state.sumCount}</b>
                </h3>  
              </Panel>
              </Col>
            <Col md={4}>
              <Panel className="text-col" header={false} cover>
              <h3 className="text-muted">复购用户数</h3>
                <h3>
                  <b>{self.state.sumCount1}</b>
                </h3>  
              </Panel>
            </Col>
            <Col md={4}>
              <Panel className="text-col" header={false} cover>
              <h3 className="text-muted">复购单数</h3>
                <h3>
                  <b>{self.state.sumCount2}</b>
                </h3>  
              </Panel>
            </Col>
            <Col md={4}>
              <Panel className="text-col" header={false} cover>
              <h3 className="text-muted">复购金额</h3>
                <h3>
                  <b>{self.state.sumCount3/100}</b>
                </h3>  
              </Panel>
            </Col>
            <Col md={4}>
              <Panel className="text-col" header={false} cover>
                <h3 className="text-muted">复购率</h3>
                <h3>
                  <b>{((self.state.sumCount1/self.state.sumCount)*100).toFixed(4)}%</b>
                </h3>               
              </Panel>
            </Col>
            </div>
          </Row>

          <div style={{clear:'both'}}></div>
        </div>
        <div style={{width:"90%",margin:"10px 0 0 2%"}}>
      <span style={{paddingRight:'20px'}}></span>
      <div>
        {seTag}      
      <Button onClick={self.getTagList.bind(self)} icon='plus' style={{float:'left'}} type="primary">{'选择标签'}</Button>
      <div style={{clear:'both'}}></div>
      </div>
      </div>

      <div style={{width:'90%',margin:'20px 0 0 2%'}}>  
      <span style={{paddingRight:'20px'}}>选择时段</span>
      <div>
      <MonthPicker onChange={self.onChangedate1.bind(self)} placeholder="选择月份" />
      </div>
      </div>

      <div style={{width:"90%",margin:"15px 0 0 2%"}}>
      <div style={{width:'20%',float:'left'}}>
        选择终端
        <Select
          mode="multiple"
          style={{ width: '100%' }}
          placeholder="所属终端选择"
          onChange={self.handleChange1.bind(self)}
          optionLabelProp="label">
          {itemsTag}
        </Select>
      </div>

        <div style={{clear:'both'}}></div>
      </div>
      <BirdGrid gridOption={gridOption} ref="grid"/>


      <Modal title="选择标签"
          width="70%"
          visible={self.state.formVisiable}
          okButtonProps={{ disabled: true }}
          onCancel={() => self.cancelClick()}
          confirmLoading={self.state.formConfirmLoading}>
            
      <Row>
        <Col>
        <div ><BirdGrid gridOption={gridOptionsTag} ref={self.state.gridDatas}></BirdGrid></div>     
        </Col>
      </Row>
     </Modal>
    </div>
  }
}
// export default BirdGridElasticPage
export default connect( ( { bindActionCreators } ) => ( { bindActionCreators } ) )( BirdGridElasticPage );
