import React from 'react';
import ReactEcharts from 'echarts-for-react';
import { BirdGrid } from 'components/Grid';
import {Layout,Row,Col,Modal,Button,Select,DatePicker,Spin} from 'antd';
import Panel from 'components/Panel';
const { Option } = Select;
const { MonthPicker, RangePicker } = DatePicker;
//import DataSet from '@antv/data-set';

import { connect } from 'dva';
require('echarts/map/js/china.js');
import {
  request,
  config,
  util,
  permission
} from 'utils';
import './order_statis.less';
const { Content } = Layout;
const {
  APIV3
} = config;





class BirdGridPermissionPage extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      option: {},
      optionMemProv:{},
      rankingListData:[],//前十省份
      sexCount0:0,
      sexCount1:0,
      sexCount2:0,     
      seleTag:[],
      tagKey:[],
      gridDatas:[],
      zKeyList:[],//终端已选
      sexJson:[],
      dateStr:"",//性别
      searchObj:[],
      updateLoading:true,//加载数据
    }
  }

  getSearch(arrobj){
    let o = this;
    let opMemProv = {
      title: {
        text: '各省用户',
        subtext: '',
        left: 'center'
      },
      tooltip: {
        trigger: 'item'
      },
      legend: {
        orient: 'vertical',
        left: 'left',
        data:['member']
      },
      visualMap: {
        min: 0,
        max: 1500000,
        left: 'left',
        top: 'bottom',
        text: ['高','低'],       // 文本，默认为数值文本
        calculable: true
      },
      toolbox: {
        show: true,
        orient: 'vertical',
        left: 'right',
        top: 'center',
        feature: {
          dataView: {readOnly: false},
          restore: {},
          saveAsImage: {}
        }
      },
      series: [
        {
          name: 'member',
          type: 'map',
          mapType: 'china',
          roam: false,
          label: {
            normal: {
              show: true
            },
            emphasis: {
              show: true
            }
          },
          data:[
            {name: '北京',value: 0 },
            {name: '天津',value: 0 },
            {name: '上海',value: 0 },
            {name: '重庆',value: 0 },
            {name: '河北',value: 0 },
            {name: '河南',value: 0 },
            {name: '云南',value: 0 },
            {name: '辽宁',value: 0 },
            {name: '黑龙江',value: 0 },
            {name: '湖南',value: 0 },
            {name: '安徽',value: 0 },
            {name: '山东',value: 0 },
            {name: '新疆',value: 0 },
            {name: '江苏',value: 0 },
            {name: '浙江',value: 0 },
            {name: '江西',value: 0 },
            {name: '湖北',value: 0 },
            {name: '广西',value: 0 },
            {name: '甘肃',value: 0 },
            {name: '山西',value: 0 },
            {name: '内蒙古',value: 0 },
            {name: '陕西',value: 0 },
            {name: '吉林',value: 0 },
            {name: '福建',value: 0 },
            {name: '贵州',value: 0 },
            {name: '广东',value: 0 },
            {name: '青海',value: 0 },
            {name: '西藏',value: 0 },
            {name: '四川',value: 0 },
            {name: '宁夏',value: 0 },
            {name: '海南',value: 0 },
            {name: '台湾',value: 0 },
            {name: '香港',value: 0 },
            {name: '澳门',value: 0 }
          ]
        }]
    };
    request({
      url: APIV3 + '/web/ES_DataStais/memCount',
      method: "get",
      data:arrobj
    }).then((resp) => {
      let arr = [];
      let rankingListData=[];
      if(resp.sexjson!=null){
        let sexCount0=0;
        let sexCount1=0;
        let sexCount2=0;
        for(var i=0;i<resp.sexjson.length;i++){
          if(resp.sexjson[i][0]==0){
              sexCount0=resp.sexjson[i][1]
          }else if(resp.sexjson[i][0]==1){
              sexCount1=resp.sexjson[i][1]
          }else if(resp.sexjson[i][0]==2){
              sexCount2=resp.sexjson[i][1]
          }
        }
        o.setState({
          sexCount0:sexCount0,
          sexCount1:sexCount1,
          sexCount2:sexCount2
        })
      }
      for(var i =0; i< resp.itmes.length;i++){
        arr.push( {
          name: resp.itmes[i][0],
          value: resp.itmes[i][1]
        });
        if(i<10){//前十
          rankingListData.push({
            title: resp.itmes[i][0],
            total: resp.itmes[i][1]
          });
        }
        //数量
      }
      opMemProv.series[0].data = arr.sort(function (a, b) {
        return a.value - b.value;
      })
      if(arr.length>0){
        opMemProv.visualMap.max = opMemProv.series[0].data[arr.length-1].value;
      }
      //console.log(op)
      o.setState({
        optionMemProv:opMemProv,
        rankingListData:rankingListData,
        updateLoading:false
      })
    });
  }
  getOption() {
    const option = this.state.option
    return option;
  }
  getOptionMemProv(){
   
    const option = this.state.optionMemProv;
    return option;
  }

  componentWillMount() {
    this.getSearch(this.setState.searchObj);
    this.getAddMeber(15);
  }
    getAddMeber(num){
      let self=this;
      var mday=[];
      var mcount=[];
      request({
        url: APIV3+"/web/ES_DataStais/memDay?mDay="+num,
        method: "get"
      }).then(function (result) {
        if(result!=null){
          for(var i=0;i<result.dayJson.length;i++){
            mday.push(result.dayJson[i][0].substring(0,10));
            mcount.push(result.dayJson[i][1]);
          }       
          var option =  {
            title: {text: '最新动态'},
            tooltip: {trigger: 'axis'},
            toolbox: {
                feature: {
                    dataView: {},
                    saveAsImage: {
                        pixelRatio: 2
                    },
                    restore: {}
                }
            },          
            xAxis: {
              name:'日期',
              data: mday 
            },
            yAxis: {},
            series: [{
                name:'数量',
                type: 'line',
                smooth: false,
                symbolSize:10,
                data: mcount,
            }]
        };
        self.setState({
          option:option
        })
        }
      }); 
    }
    getAddMeber1(){this.getAddMeber(7); }
    getAddMeber2(){this.getAddMeber(15);}
    getAddMeber3(){this.getAddMeber(31);}

    //终端
    componentDidMount(){
      let self=this
      if(self.state.items==null || self.state.items<=0){
        request({
          url: APIV3+"/web/ES_UsageMem/getTermain",
         method: "post",
         data:[]
       }).then(function (result) {
         if(result.items!=null){
           self.setState({
             items:result.items
           })
         }
         if(result.items1!=null){
           self.setState({
             items1:result.items1
           })
         }
       }); 
      }

      if(self.state.sexJson==null||self.state.sexJson.length<=0){
        request({
         url: APIV3+"/web/Mem_Terminaldoc/getgender",
         method: "get",
         data:[]
       }).then(function (result) {
         if(result!=null){
           self.setState({
            sexJson:result
           })
         }
       }); 
      }
      self.getOption();
    }

    unique5(arr){
      var x = new Set(arr);
     return [...x];
    }
  
    getTagList(){
      this.setState({
          formVisiable: true,
          formConfirmLoading: true
        });
    }
    rmTag(rowIndex){  
      this.state.seleTag.splice(rowIndex,1),
      this.state.tagKey.splice(rowIndex,1)
      this.setState({
        seleTag:this.state.seleTag,
        tagKey:this.state.tagKey
      }) 
    }
    cancelClick() {
      this.setState({
        formVisiable: false,
        formConfirmLoading: false
      });
    }
  
    getZoom(){
      let self=this; 
      let tagKey=self.state.tagKey;
      let zkeyList=self.state.zkeyList;
      if(tagKey!=null && tagKey!="" && tagKey!=undefined){
        tagKey=tagKey.join(",")
      }else{
        tagKey="0"
      }
  
      if(zkeyList!=null && zkeyList!="" && zkeyList!=undefined){
        zkeyList=zkeyList.join(",")
      }else{
        zkeyList="0"
      }
      let searchObj={"tagKey":tagKey,"zkey":zkeyList,"sexkey":self.state.dateStr}
      this.getSearch(searchObj);
    }
    //所属终端
    handleChange1(arr){
      this.setState({
        zkeyList:arr
      })
    } 
    //选择性别
    sexChange(arr){
      this.setState({
        dateStr:arr
      })
    }
    getOption() {
      const option = this.state.option
      return option;
    }

  render() {//full-layout page
    
    const { dashboard } = this.props;
    let rankingListData=this.state.rankingListData;
    let self = this;


        //标签，终端
        let gridOptionsTag = {
          title: "标签列表",
          url: {
            read: "/web/mem_tag/AllTagList"
          },
          primaryKey:'_id',
          columns: [
            { title: "标签ID", data: "_id", type: "text", editor: {ap: 'hide', ep: 'hide'}, isRequired: true },
            { title: "标签名称", data: "TagName", type: "text", editor: {},query:false,  query: true },
            { title: "标签类型名称", data: "TagTypeName", type: "text", editor: {ap: 'hide', ep: 'hide'},hide:true}, 
            { title: "标签类型", data: "TagTypeId", type: "dropdown", editor: {},
              source: { url: '/web/Mem_TagType/type?t='+self.state.randStr },query:true }, 
            { title: "标签名称", data: "TagName", type: "text", editor: {},query:false,  query: true },
          ],
          checkable: true,
          actions: [{
            name: '确认选择',
            onClick: function (e) {
              for(let key in e){
                  self.state.tagKey.push(e[key])
                  self.state.tagKey=self.unique5(self.state.tagKey)
                }
                var chilTag=self.state.gridDatas.current.state.gridDatas.items
                for(let tag in chilTag){
                  for(let key in self.state.tagKey){
                    if(self.state.tagKey[key]==chilTag[tag].TagId){
                      self.state.seleTag.push(chilTag[tag])
                      self.state.seleTag=self.unique5(self.state.seleTag)
                      break;
                    }
                  }
                }
              self.setState({
                formVisiable: false,
                formConfirmLoading: false
              });
            }
          }]         
          };
         
          let {items,sexJson} = self.state
          let itemsTag=[];//终端
          if(items!=null){
            itemsTag=items.map((data, rowIndex) => {
              itemsTag=[<Option key={rowIndex} value={data.ParentTerminalKey} label={data.TerminalDesc}>{data.TerminalDesc}</Option>]
             return itemsTag;
            })
          }               
          let seTag=[];
          //标签  
          seTag = self.state.seleTag.map((data, rowIndex) => {
              seTag=[<div key={rowIndex} onClick={self.rmTag.bind(self,rowIndex)} style={{border:'1px solid #CDC9C9',padding:'5px 10px',float:'left',fontSize:'12px',margin:'0 1% 0 0',textAlign:"center"}}>{data.TagName}</div>]
              return seTag;
          })
          //性别
          let sexTag=[];
          if(sexJson!=null){
            sexTag=sexJson.map((data, rowIndex) => {
              sexTag=[<Option key={rowIndex} value={data.value} label={data.label}>{data.label}</Option>]
             return sexTag;
            })
          }


    return (
      <Layout className="full-layout page dashboard-page">
        <Spin spinning={this.state.updateLoading} tip="数据加载中...">
        <Content>

          <Row>
            <div style={{width:"90%",margin:"10px 0 0 5%"}}>
              <span style={{paddingRight:'20px'}}>选择标签</span>
              <div>
                {seTag}      
              <Button onClick={self.getTagList.bind(self)} icon='plus' style={{float:'left'}} type="primary">{'选择标签'}</Button>
              <div style={{clear:'both'}}></div>
              </div>
              </div>

              <div style={{width:'90%',margin:'20px 0 0 5%'}}>  
              <span style={{paddingRight:'20px'}}>选择性别</span>
              <div>             
              <Select defaultValue="性别" onChange={self.sexChange.bind(self)} style={{ width: 200 }}>
                {sexTag}
              </Select>
              </div>
              </div>

              <div style={{width:"90%",margin:"15px 0 25px 5%"}}>
              <div style={{width:'20%',float:'left'}}>
                选择终端
                <Select
                  mode="multiple"
                  style={{ width: '100%' }}
                  placeholder="所属终端选择"
                  onChange={self.handleChange1.bind(self)}
                  optionLabelProp="label">
                  {itemsTag}
                </Select>
              </div>
                <div style={{width:'20%',float:'left',margin:'22px 0 0 15px'}}>
                <Button onClick={self.getZoom.bind(self)} icon='search' type="primary">{'搜索'}</Button>
              </div>
                <div style={{clear:'both'}}></div>
            </div>
        </Row>


          <Row gutter={20}>
            <div className="text-par">
            <Col md={5}>
              <Panel className="text-col" header={false} cover>
              <h3 className="text-muted">会员总数</h3>
                <h3>
                  <b>{this.state.sexCount1+this.state.sexCount0+this.state.sexCount2}</b>
                </h3>  
              </Panel>
              </Col>
            <Col md={5}>
              <Panel className="text-col" header={false} cover>
              <h3 className="text-muted">男</h3>
                <h3>
                  <b>{this.state.sexCount1}</b>
                </h3>  
              </Panel>
            </Col>
            <Col md={5}>
              <Panel className="text-col" header={false} cover>
                <h3 className="text-muted">女</h3>
                <h3>
                  <b>{this.state.sexCount0}</b>
                </h3>               
              </Panel>
            </Col>
            <Col md={5}>
              <Panel className="text-col" header={false} cover>
                <h3 className="text-muted">未知</h3>
                <h3>
                  <b>{this.state.sexCount2}</b>
                </h3>               
              </Panel>
            </Col>
            </div>
          </Row>
          <Row>
            <Col>
              <Panel title="数据面板组件" height={600} >
                <div className="flex">
                  <div className="flex-auto-hidden flex flex-column">
                    <h4 className="flex-none">用户分布</h4>
                    <div className="flex-auto-hidden">
                       
                        <ReactEcharts
            option={this.getOptionMemProv()}
            style={{height: '500px', width: '100%'}}
            className='react_for_echarts' />}
                    </div>
                  </div>
                  <div className="flex-none sales-order">
                    <h4>省份销售额排名</h4>
                    <ul>
                      {rankingListData.map((item, i) => (
                        <li key={item.title}>
                          <span>{i + 1}</span>
                          <span>{item.title}</span>
                          <span>{item.total}</span>
                        </li>
                      ))}
                    </ul>
                  </div>
                </div>
              </Panel>
            </Col>
          </Row>



          <Row gutter={20}>
            <Col md={20}>
              <Panel title="" height={350}>
              <Button onClick={self.getAddMeber1.bind(self)} type="primary">{'7天内'}</Button>
              <Button onClick={self.getAddMeber2.bind(self)} type="primary">{'15天内'}</Button>
              <Button onClick={self.getAddMeber3.bind(self)} type="primary">{'31天内'}</Button>
              <ReactEcharts option = {
            this.getOption()
            }
            style = {
            {
              width: '100%',height:'100%'
            }
          }
          />
              </Panel>
            </Col>
          </Row>



    </Content>
    </Spin>
    <Modal title="选择标签"
          width="70%"
          visible={self.state.formVisiable}
          okButtonProps={{ disabled: true }}
          onCancel={() => self.cancelClick()}
          confirmLoading={self.state.formConfirmLoading}>          
      <Row>
        <Col>
        <div ><BirdGrid gridOption={gridOptionsTag} ref={self.state.gridDatas}></BirdGrid></div>     
        </Col>
      </Row>
     </Modal>
    </Layout>
    )
  }
}



export default BirdGridPermissionPage