import React from 'react';
import ReactEcharts from 'echarts-for-react';
import { BirdGrid } from 'components/Grid';
import {Layout,Row,Col,Modal,Button,Select,DatePicker,Spin} from 'antd';
import Panel from 'components/Panel';
const { Option } = Select;
const { MonthPicker, RangePicker } = DatePicker;
//import DataSet from '@antv/data-set';

import { connect } from 'dva';
require('echarts/map/js/china.js');
import {
  request,
  config,
  util,
  permission
} from 'utils';
import './order_statis.less';
const { Content } = Layout;
const {
  APIV3,
  APIV4
} = config;





class BirdGridPermissionPage extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      option: {},
      optionMemProv:{},
      rankingListData:[],//前十省份
      orderCount0:0,
      orderCount1:0,
      orderCount2:0, 
      orderCount3:0,    
      seleTag:[],
      tagKey:[],
      gridDatas:[],
      zKeyList:[],//终端已选
      dateStr:"",//性别
      searchObj:[],
      updateLoading:true,//加载数据
    }
  }

  getSearch(arrobj){
    let o = this;
    let opMemProv = {
      title: {
        text: '各省用户',
        subtext: '',
        left: 'center'
      },
      tooltip: {
        trigger: 'item'
      },
      legend: {
        orient: 'vertical',
        left: 'left',
        data:['member']
      },
      visualMap: {
        min: 0,
        max: 1500000,
        left: 'left',
        top: 'bottom',
        text: ['高','低'],       // 文本，默认为数值文本
        calculable: true
      },
      toolbox: {
        show: true,
        orient: 'vertical',
        left: 'right',
        top: 'center',
        feature: {
          dataView: {readOnly: false},
          restore: {},
          saveAsImage: {}
        }
      },
      series: [
        {
          name: 'member',
          type: 'map',
          mapType: 'china',
          roam: false,
          label: {
            normal: {
              show: true
            },
            emphasis: {
              show: true
            }
          },
          data:[
            {name: '北京',value: 0 },
            {name: '天津',value: 0 },
            {name: '上海',value: 0 },
            {name: '重庆',value: 0 },
            {name: '河北',value: 0 },
            {name: '河南',value: 0 },
            {name: '云南',value: 0 },
            {name: '辽宁',value: 0 },
            {name: '黑龙江',value: 0 },
            {name: '湖南',value: 0 },
            {name: '安徽',value: 0 },
            {name: '山东',value: 0 },
            {name: '新疆',value: 0 },
            {name: '江苏',value: 0 },
            {name: '浙江',value: 0 },
            {name: '江西',value: 0 },
            {name: '湖北',value: 0 },
            {name: '广西',value: 0 },
            {name: '甘肃',value: 0 },
            {name: '山西',value: 0 },
            {name: '内蒙古',value: 0 },
            {name: '陕西',value: 0 },
            {name: '吉林',value: 0 },
            {name: '福建',value: 0 },
            {name: '贵州',value: 0 },
            {name: '广东',value: 0 },
            {name: '青海',value: 0 },
            {name: '西藏',value: 0 },
            {name: '四川',value: 0 },
            {name: '宁夏',value: 0 },
            {name: '海南',value: 0 },
            {name: '台湾',value: 0 },
            {name: '香港',value: 0 },
            {name: '澳门',value: 0 }
          ]
        }]
    };
    request({
      // APIV4 + '/orderFormStatis/orderCount',
      url: APIV3 + '/web/ES_DataStais/orderCount',
      method: "get",
      data:arrobj
    }).then((resp) => {
      console.log(resp)
      let arr = [];
      let rankingListData=[];
      if(resp.jsonSum!=null){
        var orderCount0=resp.jsonSum.cn.replace("\"","");//总单数
        var orderCount1=resp.jsonSum.sm;//总金额
        var orderCount2=resp.jsonSum.fcn.replace("\"","");//复购单数
        var orderCount3=resp.jsonSum.fsm;//复购金额
        o.setState({
          orderCount0:orderCount0,
          orderCount1:Number(orderCount1).toFixed(2),
          orderCount2:orderCount2,
          orderCount3:Number(orderCount3).toFixed(2)
        })
      }
      request({
        // url: APIV4 + '/orderFormStatis/orderProvCount',
      url: APIV3 + '/web/ES_DataStais/orderProvCount',
        method: "get",
        data:arrobj
      }).then((resps) => {
        for(var i =0; i< resps.listJson.length;i++){
          arr.push( {
            name: resps.listJson[i][0],
            value: resps.listJson[i][1]
          });
          if(i<10){//前十
            rankingListData.push({
              title: resps.listJson[i][0],
              total: resps.listJson[i][1]
            });
          }
          //数量
        }
        opMemProv.series[0].data = arr.sort(function (a, b) {
          return a.value - b.value;
        })
        if(arr.length>0){
          opMemProv.visualMap.max = opMemProv.series[0].data[arr.length-1].value;
        }
        o.setState({
          optionMemProv:opMemProv,
          rankingListData:rankingListData,
          updateLoading:false
        })
      })
    });
  }
  getOption() {
    const option = this.state.option
    return option;
  }
  getOptionMemProv(){
   
    const option = this.state.optionMemProv;
    return option;
  }

  componentWillMount() {
    this.getSearch(this.setState.searchObj);
    this.getAddMeber(16);
  }
    getAddMeber(num){
      let self=this;
      var mday=[];
      var mcount=[];
      var mcount2=[];
      request({
        url: APIV4+"/orderFormStatis/orderDay?mDay="+num,
        method: "get"
      }).then(function (result) {
        if(result!=null){
          for(var i=0;i<result.jsonSum.length;i++){
            mday.push(result.jsonSum[i].orDate);
            mcount.push(result.jsonSum[i].orCnt);
            mcount2.push((result.jsonSum[i].orSum/100).toFixed(2))
          }       
          var option =  {
            title: {text: '最新动态'},
            tooltip: {trigger: 'axis'},
            toolbox: {
                feature: {
                    dataView: {},
                    saveAsImage: {
                        pixelRatio: 2
                    },
                    restore: {}
                }
            },
            xAxis: {
              data: mday 
            },
            yAxis: {},
            series: [{
                name:'金额',
                type: 'line',
                smooth: false,
                data: mcount2,
                symbolSize:10
            },{
              name:'数量',
              type: 'line',
              smooth: false,
              data: mcount,
              symbolSize:0,itemStyle: {
                normal: {
                  label : {
                    show: true
                  },
                  lineStyle:{
                    color: 'rgba(0,0,0,0)'
                  }
                }
              }
          }]
        };
        self.setState({
          option:option
        })
        }
      }); 
    }
    getAddMeber1(){this.getAddMeber(7); }
    getAddMeber2(){this.getAddMeber(15);}
    getAddMeber3(){this.getAddMeber(31);}

    //终端
    componentDidMount(){
      let self=this
      if(self.state.items==null || self.state.items<=0){
        request({
          url: APIV4+"/orderFormStatis/getTermain",
         method: "post",
         data:[]
       }).then(function (result) {
         if(result.items!=null){
           self.setState({
             items:result.items
           })
         }
         if(result.items1!=null){
           self.setState({
             items1:result.items1
           })
         }
       }); 
      }
      self.getOption();
    }

    unique5(arr){
      var x = new Set(arr);
     return [...x];
    }

    rmTag(rowIndex){  
      this.state.seleTag.splice(rowIndex,1),
      this.state.tagKey.splice(rowIndex,1)
      this.setState({
        seleTag:this.state.seleTag,
        tagKey:this.state.tagKey
      }) 
    }
    cancelClick() {
      this.setState({
        formVisiable: false,
        formConfirmLoading: false
      });
    }
  
    getZoom(){
      let self=this; 
      let dateString=self.state.dateString;
      let zkeyList=self.state.zkeyList;
      if(dateString!=null && dateString!="" && dateString!=undefined){

      }else{
        dateString="0"
      }
  
      if(zkeyList!=null && zkeyList!="" && zkeyList!=undefined){
        zkeyList=zkeyList.join(",")
      }else{
        zkeyList="0"
      }
      let searchObj={"zKey":dateString,"tagKey":zkeyList}
      this.getSearch(searchObj);
    }
    //所属终端
    handleChange1(arr){
      this.setState({
        zkeyList:arr
      })
    } 
    onChangedate1(data,dateString){
      this.setState({
        dateString:dateString
      })
    }
    getOption() {
      const option = this.state.option
      return option;
    }

  render() {//full-layout page
    
    const { dashboard } = this.props;
    let rankingListData=this.state.rankingListData;
    let self = this;
         
    let {items} = self.state
    let itemsTag=[];//终端
    if(items!=null){
      itemsTag=items.map((data, rowIndex) => {
        itemsTag=[<Option key={rowIndex} value={data.ParentTerminalKey} label={data.TerminalDesc}>{data.TerminalDesc}</Option>]
        return itemsTag;
      })
    }               
          let seTag=[];
          //标签  
          seTag = self.state.seleTag.map((data, rowIndex) => {
              seTag=[<div key={rowIndex} onClick={self.rmTag.bind(self,rowIndex)} style={{border:'1px solid #CDC9C9',padding:'5px 10px',float:'left',fontSize:'12px',margin:'0 1% 0 0',textAlign:"center"}}>{data.TagName}</div>]
              return seTag;
          })


    return (
      <Layout className="full-layout page dashboard-page">
        
        <Content>

          <Row>
              <div style={{width:'90%',margin:'20px 0 0 5%'}}>  
              <span style={{paddingRight:'20px'}}>选择时段</span>
              <div>
              <MonthPicker onChange={self.onChangedate1.bind(self)} placeholder="选择月份" />
              </div>
              </div>

              <div style={{width:"90%",margin:"15px 0 25px 5%"}}>
              <div style={{width:'20%',float:'left'}}>
                选择终端
                <Select
                  mode="multiple"
                  style={{ width: '100%' }}
                  placeholder="所属终端选择"
                  onChange={self.handleChange1.bind(self)}
                  optionLabelProp="label">
                  {itemsTag}
                </Select>
              </div>
                <div style={{width:'20%',float:'left',margin:'22px 0 0 15px'}}>
                <Button onClick={self.getZoom.bind(self)} icon='search' type="primary">{'搜索'}</Button>
              </div>
                <div style={{clear:'both'}}></div>
            </div>
        </Row>


          <Row gutter={20}>
            <div className="text-par">
            <Col md={4}>
              <Panel className="text-col" header={false} cover>
              <h3 className="text-muted">订单总数</h3>
                <h3>
                  <b>{this.state.orderCount0}</b>
                </h3>  
              </Panel>
              </Col>
            <Col md={4}>
              <Panel className="text-col" header={false} cover>
              <h3 className="text-muted">订单金额</h3>
                <h3>
                  <b>{this.state.orderCount1}</b>
                </h3>  
              </Panel>
            </Col>
            <Col md={4}>
              <Panel className="text-col" header={false} cover>
                <h3 className="text-muted">复购单数</h3>
                <h3>
                  <b>{this.state.orderCount2}</b>
                </h3>               
              </Panel>
            </Col>
            <Col md={4}>
              <Panel className="text-col" header={false} cover>
                <h3 className="text-muted">复购金额</h3>
                <h3>
                  <b>{this.state.orderCount3}</b>
                </h3>               
              </Panel>
            </Col>
            <Col md={4}>
              <Panel className="text-col" header={false} cover>
                <h3 className="text-muted">复购率</h3>
                <h3>
                <b>{((this.state.orderCount2/this.state.orderCount0)*100).toFixed(4)}%</b>
                </h3>               
              </Panel>
            </Col>
            </div>
          </Row>
          <Spin spinning={this.state.updateLoading} tip="数据加载中...">

          <Row>
            <Col>
              <Panel title="数据面板组件" height={600} >
                <div className="flex">
                  <div className="flex-auto-hidden flex flex-column">
                    <h4 className="flex-none">用户分布</h4>
                    <div className="flex-auto-hidden">
                       
                        <ReactEcharts
            option={this.getOptionMemProv()}
            style={{height: '500px', width: '100%'}}
            className='react_for_echarts' />}
                    </div>
                  </div>
                  <div className="flex-none sales-order">
                    <h4>省份销售额排名</h4>
                    <ul>
                      {rankingListData.map((item, i) => (
                        <li key={item.title}>
                          <span>{i + 1}</span>
                          <span>{item.title}</span>
                          <span>{item.total}</span>
                        </li>
                      ))}
                    </ul>
                  </div>
                </div>
              </Panel>
            </Col>
          </Row>
</Spin>


          <Row gutter={20}>
            <Col md={20}>
              <Panel title="" height={350}>
              <Button onClick={self.getAddMeber1.bind(self)} type="primary">{'7天内'}</Button>
              <Button onClick={self.getAddMeber2.bind(self)} type="primary">{'15天内'}</Button>
              <Button onClick={self.getAddMeber3.bind(self)} type="primary">{'31天内'}</Button>
              <ReactEcharts option = {
            this.getOption()
            }
            style = {
            {
              width: '100%',height:'100%'
            }
          }
          />
              </Panel>
            </Col>
          </Row>



    </Content>
    </Layout>
    )
  }
}



export default BirdGridPermissionPage
