import { Tabs } from 'antd';
import PropTypes from 'prop-types';

const { TabPane } = Tabs;

class TopTabs1 extends React.Component {
  constructor(props) {
    super(props);
    this.newTabIndex = 0;
    // const panes = [
    //   { title: 'Tab 1', content: <div>eweweff<span>22</span></div>, key: '1' },
    //   { title: 'Tab 2', content: 'Content of Tab 2', key: '2' },
    //   {
    //     title: 'Tab 3',
    //     content: 'Content of Tab 3',
    //     key: '3',
    //     closable: false,
    //   },
    // ];
    
    let panes = this.props.panes;
    this.state = {
      activeKey: panes[0].key,
      panes,
    };
  }

  onChange = activeKey => {
    this.setState({ activeKey });
  };

  onEdit = (targetKey, action) => {
    this[action](targetKey);
  };

  add = () => {
    const panes = this.state.panes;
    const activeKey = `newTab${this.newTabIndex++}`;
    panes.push({ title: 'New Tab', content: 'Content of new Tab', key: activeKey });
    this.setState({ panes, activeKey });
  };

  remove = targetKey => {
    let activeKey = this.state.activeKey;
    let lastIndex;
    this.state.panes.forEach((pane, i) => {
      if (pane.key === targetKey) {
        lastIndex = i - 1;
      }
    });
    const panes = this.state.panes.filter(pane => pane.key !== targetKey);
    if (panes.length && activeKey === targetKey) {
      if (lastIndex >= 0) {
        activeKey = panes[lastIndex].key;
      } else {
        activeKey = panes[0].key;
      }
    }
    this.setState({ panes, activeKey });
  };

  render() {
    return (
      <Tabs
        onChange={this.onChange}
        activeKey={this.state.activeKey}
        type="editable-card"
        onEdit={this.onEdit}
      >
        {this.state.panes.map(pane => (
          <TabPane tab={pane.title} key={pane.key} closable={pane.closable}>
            {pane.content}
          </TabPane>
        ))}
      </Tabs>
    );
  }
}

TopTabs1.propTypes = {
  panes: PropTypes.array.isRequired
}

TopTabs1.defaultProps = {
  panes: [
      { title: 'Tab 1', content: <div>eweweff<span>22</span></div>, key: '1' },
      { title: 'Tab 2', content: 'Content of Tab 2', key: '2' },
      {
        title: 'Tab 3',
        content: 'Content of Tab 3',
        key: '3',
        closable: false,
      },
    ]
}

export default TopTabs1; 