import React from 'react';
import ReactQuill, { Quill, Mixin, Toolbar } from 'react-quill'; // ES6
import 'react-quill/dist/quill.snow.css';
import { Modal, Button,Upload,
    Icon } from 'antd';
import { config } from 'utils';
const { APIV3,APIV4 } = config
const uploadUrl=APIV4+"/memorder/uploadprofile"
export default class DashBoardExcel extends React.PureComponent {
    constructor(props) {
        super(props)
        let textStr="";
        if(props.gridOption!=null&&props.gridOption.ProductText!=null){
            textStr=props.gridOption.ProductText;
        }
        this.state = { text: textStr, formVisiable: false} // You can also pass a Quill Delta here
        this.imageHandler= this.imageHandler.bind(this)
    }

    handleChange(value) {
        //this.refs.reactQuillRef.state.value=value;
        //this.setState({ text: value })
    }
    imageHandlerv2() {
        this.setState({
            formVisiable: true
        });
    }
    cancelClick() {
        this.setState({
            formVisiable: false
        });
    }

    selectImage() {
        this.refs.uploadInput.click();//点击modal的html结构中的input标签
    }
    imageHandler(url) {
        let self=this
        let quill = self.refs.reactQuillRef.getEditor();//获取到编辑器本身
        const cursorPosition = quill.getSelection().index;//获取当前光标位置
        quill.insertEmbed(cursorPosition, "image", url);//插入图片
        quill.setSelection(cursorPosition + 1);//光标位置加1
        self.setState({
            text:quill.container.innerHTML
        })
    }
    normFile = e => {
        this.cancelClick();
        if(e.file!=null&&e.file.response!=null/*&&e.file.response.data!=null*/){
            this.imageHandler(e.file.thumbUrl)
        }
      };

    render() {
        let props2 = {
            action: uploadUrl,
            listType: 'picture',
            onChange:this.normFile,//回调方法
            className: 'upload-list-inline',
            accept:"image/png, image/jpeg"//文件类型
          };
        let self = this
        var toolbarContainer = [
            ['bold', 'italic', 'underline', 'strike', 'image'],        // toggled buttons
            ['blockquote', 'code-block'],
            [{ 'header': 1 }, { 'header': 2 }],               // custom button values
            [{ 'list': 'ordered' }, { 'list': 'bullet' }],
            [{ 'script': 'sub' }, { 'script': 'super' }],      // superscript/subscript
            [{ 'indent': '-1' }, { 'indent': '+1' }],          // outdent/indent
            [{ 'direction': 'rtl' }],                         // text direction         
            [{ 'header': [1, 2, 3, 4, 5, 6, false] }],
            [{ 'color': [] }, { 'background': [] }],          // dropdown with defaults from theme
            [{ 'font': [] }],
            [{ 'align': [] }]
        ];
        return (
            <div>
                <ReactQuill /*onChange={self.handleChange.bind(self)}*/ value={self.state.text} 
                     modules={{
                        toolbar: {
                            container: toolbarContainer,
                            handlers: {
                                image: self.imageHandlerv2.bind(self)
                            }
                        }
                    }} ref='reactQuillRef'/>
                <Modal title="图片上传"
                    width="70%"
                    visible={self.state.formVisiable}
                    onCancel={() => self.cancelClick()}>
                    <Upload {...props2}>
                        <Button>
                        <Icon type="upload" /> 添加图片
                        </Button>
                    </Upload>
                </Modal>
            </div>
        )
    }
}

