import React from 'react';
import { Form,
  Select,
  InputNumber,
  Switch,
  Radio,
  Slider,
  Button,
  Upload,
  Icon,
  Rate,
  Checkbox,
  Row,
  Col,
  Input,
  message} from 'antd';
import { config,util,request } from 'utils'
import './mem_product.less';
import DashBoardExcel from './DashBoardExcel'
const { APIV3,APIV4 } = config
const { TextArea } = Input;

class BirdFormDemoPage extends React.Component {
  constructor(props) {
    super(props); 
    let outputEntity=this.props.location.query.params;
    let fileList=[];
    if(outputEntity==null){
      outputEntity={MarketPrice:"",MarketIng:"",ProductCode:"",ProductName:"",ProductObject:"",ProductDesc:0,Mnufacturer:"",PurchasePrice:"",Amount:"",ProductText:""};
    }else if(outputEntity.dt!=null){
      for(var i=0;i< outputEntity.dt.length;i++){
        fileList.push({ uid: outputEntity.dt[i].PicID,name: outputEntity.dt[i].PicID,url: outputEntity.dt[i].PicUrl,thumbUrl: outputEntity.dt[i].PicUrl})
      }
    }
      
    this.state = {
      checkNick: false,
      fileList:fileList,
      disbool:false,
      productObj:outputEntity
    }
  }

  //提交产品信息
  handleSubmit = e => {
    let self= this
    let user = util.auth.getUser();
    let ProductText=self.refs.reactQuillRef.refs.reactQuillRef.state.value;
    let productObj=self.state.productObj;
    productObj["ProductText"]=ProductText;

    productObj["pics"]=self.state.fileList;
    if(productObj.pics.length<1){
      message.error("图片最少1张！");
      return;
    }
    if(productObj.pics.length>8){
      message.error("图片最多8张！");
      return;
    }else if(productObj.ProductName=="" || productObj.ProductName.length<=0){
      message.error("商品信息不能为空！");
      return;
    }

    if(productObj.ProductDesc=="" || productObj.ProductDesc.length<=0){
      message.error("商品信息不能为空！");
      return;
    }

    if(String(productObj.MarketPrice)=="" || productObj.MarketPrice==null){
      message.error("商品价格不能为空！");
      return;
    }
    if(String(productObj.MarketIng)=="" || productObj.MarketIng==null){

      message.error("商品积分不能为空！");
      return;
    }

    if(String(productObj.PurchasePrice)=="" || productObj.PurchasePrice==null){

      message.error("供货价不能为空！");
      return;
    }
    if(String(productObj.Amount)=="" || productObj.Amount==null){
      message.error("库存不能为空！");
      return;
    }
    if(productObj.ProductDesc=="" || productObj.ProductDesc.length<=0){
      message.error("商品信息不能为空！");
      return;
    }

    if(productObj.ProductObject==""|| productObj.ProductObject==null || productObj.ProductObject.length<=0){
      message.error("商品属性不能为空！");
      return;
    }
    if(productObj.PurchasePrice==""|| productObj.PurchasePrice==null || productObj.PurchasePrice.length<=0){
      productObj["PurchasePrice"]=0;
    }else{
      productObj["PurchasePrice"]=productObj.PurchasePrice*100
    }
    if(productObj.MarketPrice==""|| productObj.MarketPrice==null || productObj.MarketPrice.length<=0){
      productObj["MarketPrice"]=0;
    }else{
      productObj["MarketPrice"]=productObj.MarketPrice*100
    }

    var mak =String(productObj.MarketPrice);
    var ing =String(productObj.PurchasePrice);
    if(mak.indexOf(".")!=-1||ing.indexOf(".")!=-1){
      message.error("金额格式错误！")
      return;
    }
    /*if(productObj.MarketPrice==""|| productObj.MarketPrice==null || productObj.MarketPrice.length<=0){
      message.error("供货价不能为空！");
      return;
    }else{
      productObj.MarketPrice=productObj.MarketPrice*100
    }*/
    request({
      url: APIV4+"/memorder/addMemProduct?MemberId="+user.id+"&MemberName="+user.rolename,
      method: "post",
      data:productObj
  }).then(function (result) {
    message.success(result.msg);
    window.location.href="/ingproduct/mem_product";
  })
  };

  //图片上传成功
  normFile = e => {
    let self=this
    let fileList=self.state.fileList;
    /*if(fileList.length>=8){
      message.error("最多上传8张图！")

      return;
    }*/
    //上传成功
    if(e.file.status=="removed"){
      if(e.fileList.length<=0){
        fileList=[];
      }else{
        fileList=e.fileList;
      }
    }else if(e.file!=null&&e.file.response!=null&&e.file.response.success){
      fileList.push({
        uid: '-'+e.file.size,
        name: e.file.name,
        url: APIV3+e.file.response.path,
        thumbUrl: APIV3+e.file.response.path,
      })
      /*
      fileList.push({
        uid: '-'+e.file.size,
        name: e.file.name,
        url: e.file.thumbUrl,//response.data,
        thumbUrl: e.file.thumbUrl//response.data,
      })*/
  }
  self.setState({
    fileList:fileList
  })
  };
  updateInput(itme,event){//输入框
    let self= this
    let productObj=self.state.productObj;
    productObj[itme]=event.target.value;
    self.setState({productObj:productObj})
  }
  handeChangev2(itme,event){//选择框
    let self= this
    let productObj=self.state.productObj;
    productObj[itme]=event
    self.setState({productObj:productObj})
  }
  handeChangev3(itme,event){//选择框
    let self= this
    let productObj=self.state.productObj;
    productObj[itme]=event
    self.setState({productObj:productObj})
  }
  render() {
    let {fileList} = this.state
    //图片上传配置
    let props2 = {
      action: APIV3+'/web/memProduct/uploadprofile',
      //action: APIV4+"/memorder/uploadprofile",
      listType: 'picture',
      onChange:this.normFile,//上传回调
      multiple:true,//是否多选文件
      defaultFileList: [...fileList],
      className: 'upload-list-inline',
      accept:"image/png, image/jpeg"//文件类型
    };

    const formItemLayout = {
      labelCol: { span: 6 },
      wrapperCol: { span: 14 },
    };
    return (
      <div style={{width:"60%",marginLeft:"20%",background:"#fff"}}>
        <Form.Item>
          <h4>商品信息</h4>
        </Form.Item>

        <Form.Item label="商品名称">
          <Input value={this.state.productObj.ProductName} onChange={this.updateInput.bind(this,'ProductName')}></Input>
        </Form.Item>

        <Form.Item label="供应商品名称">
          <Input value={this.state.productObj.Manufacturer} onChange={this.updateInput.bind(this,'Manufacturer')}></Input>
        </Form.Item>
        <Form.Item label="库存数量">
          <InputNumber type={"number"} value={this.state.productObj.Amount} onChange={this.handeChangev2.bind(this,'Amount')} style={{width:"150px"}} min={0} max={100000} />

          <span style={{paddingLeft:"30px"}} className="ant-form-text">供货价格：</span>
          <InputNumber type={"number"} value={this.state.productObj.PurchasePrice} onChange={this.handeChangev2.bind(this,'PurchasePrice')} style={{width:"150px"}} min={0} max={100000} />
          <span className="ant-form-text"> 元</span>
        </Form.Item>     
        
        <Form.Item label="默认积分">
          <InputNumber type={"number"} value={this.state.productObj.MarketIng} onChange={this.handeChangev2.bind(this,'MarketIng')} style={{width:"150px"}} min={0} max={100000} />

          <span style={{paddingLeft:"30px"}}  className="ant-form-text"> 默认金额：</span>
          <InputNumber type={"number"} value={this.state.productObj.MarketPrice} onChange={this.handeChangev3.bind(this,'MarketPrice')} style={{width:"150px"}} min={0} max={100000} />        
          <span className="ant-form-text"> 元</span>
        </Form.Item>


        <Form.Item label="商品属性" hasFeedback>
            <Select style={{width:"60%"}} value={this.state.productObj.ProductObject==""?"请选择商品属性":(this.state.productObj.productObject==1?"实物商品":"虚拟商品")} onChange={this.handeChangev2.bind(this,'ProductObject')} placeholder="请选择商品属性">
              {/*<Option value="1">实物商品</Option>*/}
              <Option value="2">虚拟商品</Option>
            </Select>
        </Form.Item>

        <Form.Item label="简要信息" hasFeedback>
            <TextArea value={this.state.productObj.ProductDesc} onChange={this.updateInput.bind(this,'ProductDesc')}></TextArea>
        </Form.Item>


        <Form.Item label="商品图片">
          <div>上传图片，最多上传8张，最少上传一张！(1M)</div>
          <Upload disabled={this.state.disbool} {...props2}>
            <Button>
              <Icon type="upload" /> 添加图片
            </Button>
          </Upload>
        </Form.Item>

        <Form.Item label="详情介绍">
          {/* 编辑器 */}
          <DashBoardExcel gridOption={this.state.productObj} ref="reactQuillRef"></DashBoardExcel>
        </Form.Item>



        <Form.Item wrapperCol={{ span: 12, offset: 6 }}>
          <Button type="primary" onClick={this.handleSubmit}>
            保存
          </Button>
        </Form.Item>

      </div>
    )
  }
}

export default BirdFormDemoPage
