import React from 'react';
import { BirdGrid } from 'components/Grid';
import { routerRedux } from 'dva/router'
import { config,request,util } from 'utils'
import { jrequest } from 'utils/request';
import { connect } from 'dva';
import axios from "axios";
import moment from 'moment';
import {BirdForm} from 'components/Form';
import {Modal,
  message,
  Input,
  Select,
  Card,
  Icon,
  Tree,
  Button,
  Row,Col,Radio,
  DatePicker
} from 'antd';
const { APIV3,APIV4 } = config
class tag_setting extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      formConfirmLoading:false,
      formVisiable:false,
      typeId:"",
      typeName:"",
      code:""
    }
  }

  okClick(){
      let self=this
      let typeObj=self.state;
      let user = util.auth.getUser();
      request({
        url: APIV4+"/memorder/addMemProductType?MemberId="+user.id+"&MemberName="+user.rolename,
        method: "post",
        data:{typeId:typeObj.typeId,typeName:typeObj.typeName,code:typeObj.code}
      }).then(function (result) {
        message.success(result.msg);
        self.cancelClick();
        self.refs.grid.reload();
      })    
  }
  cancelClick() {
    this.setState({
      formVisiable: false,
      formConfirmLoading: false,
      typeId:"",
      typeName:"",
      code:""
    });
  }
  handeChange(e){
    this.setState({
      typeName:e.target.value
    })
  }
  //获取规则数据
  componentDidMount(){ 
    let self=this;
 }
  render() {
    let self = this;
    let gridOption = {
      title: "商品列表",
      url: {
        read: APIV4+"/memorder/AllproductType"
      },
      checkable: true,
      columns: [
        { title: "类目编码", data: "TypeId", type: "text", editor: {} },
        { title: "类目名称", data: "TypeName",type: "text", editor: {},query:true },
        { title: "类目商品数", data: "ProductCn", type: "text", editor: {}},
        {
          title: "操作选项", type: "command", actions: [
            {
              name: '编辑',          
              color: '#67c23a',
              onClick: (data) => {
                self.setState({
                  formVisiable: true,
                  formConfirmLoading: true,
                  typeId:data.TypeId,
                  typeName:data.TypeName,
                  code:2
                })
              }
            },{
            name: '详情',          
            color: '#67c23a',
            onClick: (data) => {
              self.props.dispatch({
                type: 'app/updateState', payload: {
                  menuPath: [{id:("301"+data.TypeId),name:"商品类目管理:"+data.TypeName}]
                }
              });
              self.props.dispatch(routerRedux.push({
                pathname: '/ingproduct/mem_producttypelist',
                query: {params: data},
                })
              );
            }
          }         
        ]
        }
      ],actions: [
        {
        name: '添加分类',          
        color: '#67c23a',
        onClick: (data) => {
          self.setState({
            formVisiable: true,
            formConfirmLoading: true,
            typeId:"",
            typeName:"",
            code:1
          })
        }
      }
    ]
    };
    return <div>
              <BirdGrid gridOption={gridOption} ref="grid"></BirdGrid>
                <Modal title="编辑分类"
                width="50%"
                visible={this.state.formVisiable}
                onCancel={() => this.cancelClick()}
                onOk={() => this.okClick()}>
                <Card>分类名称<Input value={self.state.typeName} onChange={self.handeChange.bind(self)}></Input></Card>
              </Modal>
           </div>
  }
}
export default connect( ( { bindActionCreators } ) => ( { bindActionCreators } ) )( tag_setting );
