import React from 'react';
import { BirdGrid } from 'components/Grid';
import { routerRedux } from 'dva/router'
import { config,request,util } from 'utils'
import { jrequest } from 'utils/request';
import { connect } from 'dva';
import axios from "axios";
import moment from 'moment';
import {BirdForm} from 'components/Form';
import {Modal,
  message,
  Input,
  Select,
  Card,
  Icon,
  Tree,
  Button,
  Row,Col,Radio,
  DatePicker
} from 'antd';
const { APIV3,APIV4 } = config
class tag_setting extends React.Component {
  constructor(props) {
    super(props)
    let typeObj=props.location.query.params;
    let typeName="";
    let typeId="";
    if(typeObj!=null&&typeof (typeObj.TypeId) != 'undefined'){
      typeName=typeObj.TypeName;
      typeId=typeObj.TypeId;
    }
    this.state = {
      formConfirmLoading:false,
      formVisiable:false,
      typeName:typeName,
      typeId:typeId
    }
  }

  okClick(){
    let self=this
    let typeObj=self.state;
    let user = util.auth.getUser();
    if(self.refs.grid0.state!=null && self.refs.grid0.state.checkedValues!=null){
      let checkedValues=self.refs.grid0.state.checkedValues
      var productcode = checkedValues.join(",");
      request({
      url: APIV4+"/memorder/editProductType?staffId="+user.staffid,
      method: "post",
      data:{typeId:typeObj.typeId,productCode:productcode,productName:typeObj.typeName}
    }).then(function (result) {
      message.success(result.msg);
      self.cancelClick();
      self.refs.grid.query();
    })

    }
 
}
cancelClick() {
  this.setState({
    formVisiable: false,
    formConfirmLoading: false
  });
}
  //获取规则数据
  componentDidMount(){ 
    let self=this;
 }
  render() {
    let self = this;
    let database = [
      {
        "label": "实物商品",
        "value": "1",
        "disabled": false
      },
      {
        "label": "虚拟商品",
        "value": "2",
        "disabled": false
      }
    ];

    let databasev2 = [
      {
        "label": "上架",
        "value": "1",
        "disabled": false
      },
      {
        "label": "下架",
        "value": "0",
        "disabled": false
      }
    ];
    let gridOption = {
      title: "商品列表",
      url: {
        read: APIV4+"/memorder/productList"
      },
      checkable: true,
      filterRules:[{field:"ProductType",operate:"equal",value:self.state.typeId}],
      
      afterQuery: function(resultout, filters) {

        //查询完后直接隐藏调按钮
        let eles = document.getElementsByClassName("ant-btn-icon-only");
        let ele = eles[eles.length - 2];
        ele.style = "display:none;";
        let ele2 = eles[eles.length - 1];
        ele2.style = "display:none;";
        let eles1 = document.getElementsByClassName("ant-col-10");
        let ele1 = eles1[eles1.length - 1];
        ele1.style = "display:none;";
        if(self.refs.grid.state.filterRules!=null){
          let gridDatas=util.object.deepClone(self.refs.grid.state.gridDatas);     
          for(var item of gridDatas.items){
            item["MarketPrice"]=item.MarketPrice/100
            item["PurchasePrice"]=item.PurchasePrice/100
          }       
          self.refs.grid.setState({gridDatas:gridDatas});
        }
    },
      columns: [
        { title: "编号", data: "ProductCode", type: "text", editor: {} },
        { title: "商品属性", data: "ProductObject",type: "dropdown", editor: {},source: { data:database },query:true },
        { title: "商品名称", data: "ProductName", type: "text", editor: {},query:true },
        { title: "供应商", data: "Manufacturer",  type: "text", editor: {} },
        { title: "成本价", data: "PurchasePrice", type: "text",  editor: {}},
        { title: "积分价格（分）", data: "MarketPrice", type: "text",  editor: {}},
        { title: "RMB价格（元）", data: "MarketIng", type: "text",  editor: {}},
        { title: "分类", data: "ProductType", type: "text",  editor: {},query:true,hide:true},
        { title: "库存", data: "Amount", type: "text",  editor: {}},
        { title: "状态", data: "State", type: "dropdown",  editor: {},source: { data:databasev2 },query:true},
        {
          title: "操作选项", type: "command", actions: [
            {
              name: '移出',          
              color: '#67c23a',
              onClick: (data) => {
                let user = util.auth.getUser();
                let typeId=self.state.typeId;
                if(typeId!=null && data.ProductCode!=null){
                  request({
                    url: APIV4+"/memorder/editProductType?staffId="+user.staffid,
                    method: "post",
                    data:{typeId:"0",productCode:data.ProductCode,productName:data.ProductName}
                  }).then(function (result) {
                    message.success(result.msg);
                    self.refs.grid.query();
                  }) 
                }else{
                  message.error("页面失效,请重新打开此页面！");
                }
              }
            }        
        ]
        }
      ],actions: [
        {
        name: '加入商品到分类',          
        color: '#1E90FF',
        onClick: (data) => {
          self.setState({
            formVisiable: true,
            formConfirmLoading: true
          })
        }
      }
    ]
    };

    let gridOptionv2 = {
      title: "商品列表",
      url: {
        read: APIV4+"/memorder/productList"
      },
      checkable: true,
      afterQuery:	function(filters,result){
        if(self.refs.grid0.state.filterRules!=null){
          let gridDatas=util.object.deepClone(self.refs.grid0.state.gridDatas);     
          for(var item of gridDatas.items){
            item["MarketPrice"]=item.MarketPrice/100
            item["PurchasePrice"]=item.PurchasePrice/100
          }       
          self.refs.grid0.setState({gridDatas:gridDatas});
        }
        },
      columns: [
        { title: "编号", data: "ProductCode", type: "text", editor: {} },
        { title: "商品属性", data: "ProductObject",type: "dropdown", editor: {},source: { data:database },query:true },
        { title: "商品名称", data: "ProductName", type: "text", editor: {},query:true },
        { title: "供应商", data: "Manufacturer",  type: "text", editor: {} },
        { title: "成本价", data: "PurchasePrice", type: "text",  editor: {}},
        { title: "积分价格（分）", data: "MarketPrice", type: "text",  editor: {}},
        { title: "RMB价格（元）", data: "MarketIng", type: "text",  editor: {}},
        { title: "库存", data: "Amount", type: "text",  editor: {}},
        { title: "状态", data: "State", type: "dropdown",  editor: {},source: { data:databasev2 },query:true}
      ]
    };


    return <div>
                <div style={{width:"86%",margin:"15px 0 15px 7%",fontSize:"30px"}}>{self.state.typeName}</div>
                <BirdGrid gridOption={gridOption} ref="grid"></BirdGrid>
                <Modal title="加入商品到分类"
                  width="65%"
                  visible={self.state.formVisiable}
                  onCancel={() => self.cancelClick()}
                  onOk={() => self.okClick()}>                 
              <Row>
                <Col>
                  <BirdGrid gridOption={gridOptionv2} ref="grid0"></BirdGrid>
                </Col>
            </Row>
                </Modal>
           </div>
  }
}
export default connect( ( { bindActionCreators } ) => ( { bindActionCreators } ) )( tag_setting );
