import React from 'react';
import { BirdGrid } from 'components/Grid';
import { config,util,request,permission } from 'utils'
import { message } from 'antd'

class BirdGridDemoPage extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
    }
  }

  render() {
    let self = this;
    let user = util.auth.getUser();
    if(!user) {
      util.auth.removeToken();
      permission.clear();
      window.location.href = "/";
    }
    let loginid = user.id;
    let staffid = user.staffid?user.staffid:"";

    let gridOption = {
      title: "业务员商品供应商",
      url: {
        read: "/web/kcontact/index",
        //delete: "/web/kcontact/delete",
      },
      pageSize:8,
      checkable: true,
      columns: [
        { title: "编号", data: "ID", type: "number" },
        { title: "业务员id", data: "ContactId", type: "text", editor: {}, hide: true },
        { title: "业务员", data: "Contact", type: "text", editor: {}, sum:true, query: true },
        { title: "供应商id", data: "SuppliersId", type: "text", editor: {}, hide: true },
        { title: "供应商", data: "SuppliersName", type: "text", editor: {}, query: true },
        { title: "商品id", data: "GoodsId", type: "text", editor: {inline:{}},hide: true },
        { title: "商品编码", data: "GoodsCode", type: "text", query: true },
        { title: "商品", data: "GoodsName", type: "text", query: true },
        { title: "标准进价", data: "PurP", type: "number", editor: {}, query: true },
        { title: "实际进价", data: "K_Price", type: "number", query: true },
        { title: "采购员", data: "StaffName", type: "text",query:true },//
        { title: "是否已推送", data: "IsPush", type: "switch", editor: {inline:{
          onChange:function(key,value,index,that){
            //console.log(value);
            
            let items = that.state.gridDatas.items;
            let item = items[index];
            request({
              url:"/web/kcontact/setpushflag?staffid="+staffid,
              method: "post",
              data: item
            }).then(function (result) {
              if(result.success)
              message.success('保存成功');
              else{
                message.error(result.msg);
              }
            });
          }
        }}, query: true },
        
        // { title: "富文本", data: "field-richtext", type: "richtext", editor: {}, query: true },
        {
          title: "操作选项", type: "command", actions: []
        }
      ]
    };
    return <BirdGrid gridOption={gridOption} />
  }
}

export default BirdGridDemoPage
