import React from 'react';
import { BirdGrid } from 'components/Grid';
// import queryString from './query-string'
import { config,request,util } from 'utils'
import { connect } from 'dva';
import { Modal,message, Row,Col,Button,Select } from 'antd';
const { Option } = Select;

const { APIV3,APIV4 } = config

class BirdGridElasticPage extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      visible:false,
      formConfirmLoading:false,
      formVisiable:false,
      gridDatas:[],
      gridOption:[],//保存查询数据
      seleTag:[],
      tagKey:[],
      tagStyle: {display:"none"},//控制标签
      tagStyle1: {display:"none"},//控制详情
      MemGoods:[],//详情数据
      pkeyList:[],//平台已选
      zKeyList:[]//终端已选
    }
  }
 
  
          

  /* 弹出框取消事件 */
  cancelClick() {
    this.setState({
      formVisiable: false,
      formConfirmLoading: false,
      MemGoods:[]
    });
  }

  getTagList(){
    this.setState({
        tagStyle:{display:"block"},
        tagStyle1:{display:"none"},
        formVisiable: true,
        formConfirmLoading: true
      });
  }
    //处理重复标签
    unique5(arr){
        var x = new Set(arr);
       return [...x];
      }

  //下标删除对象标签
  rmTag(rowIndex){  
    this.state.seleTag.splice(rowIndex,1),
    this.state.tagKey.splice(rowIndex,1)
    this.setState({
      seleTag:this.state.seleTag,
      tagKey:this.state.tagKey,
      items:[],
      items1:[]
    }) 
  }
  //获取平台。终端
  componentDidMount(){
    let self=this
    request({
      url: APIV3+"/web/ES_UsageMem/getTermain",
     method: "post",
     data:[]
   }).then(function (result) {
     if(result.items!=null){
       self.setState({
         items:result.items
       })
     }
     if(result.items1!=null){
       self.setState({
         items1:result.items1
       })
     }
   }); 
  }
  upDurGood(arr){
    let self=this
    request({
     url: APIV3+"/web/ES_UsageMem/upDurGood",
     method: "post",
     data:{ProductCode:arr.ProductCode,MemPhone:arr.AConsigneePhone2}
   }).then(function (result) {
    self.setState({
      formVisiable: false,
      formConfirmLoading: false,
      MemGoods:[]
    });
    self.refs.grid0.reload();
   }); 
  }
  //所属平台
  handleChange(arr){
    this.setState({
      pkeyList:arr
    })
  }  
  
  //所属终端
  handleChange1(arr){
    this.setState({
      zkeyList:arr
    })
  }  
  //搜索
  getZoom(){
    let self=this; 
    let tagKey=self.state.tagKey;
    let pkeyList=self.state.pkeyList;
    let zkeyList=self.state.zkeyList;
    if(tagKey!=null && tagKey!="" && tagKey!=undefined){
      tagKey=tagKey.join(",")
    }else{
      tagKey="0"
    }
    if(pkeyList!=null && pkeyList!="" && pkeyList!=undefined){
      pkeyList=pkeyList.join(",")
    }else{
      pkeyList="0"
    }
    if(zkeyList!=null && zkeyList!="" && zkeyList!=undefined){
      zkeyList=zkeyList.join(",")
    }else{
      zkeyList="0"
    }
    /*
    let filterRules=[{
      field:"tagKey",
      operate:"contains",
      value:tagKey
    },{
      field:"pkeyList",
      operate:"contains",
      value:pkeyList
    },{
      field:"zkeyList",
      operate:"contains",
      value:zkeyList
      }]*/
      self.setState({
        tagKey1:tagKey+"_"+pkeyList+"_"+zkeyList
    })
  }



  render() { 
    let self = this;
    let seTag =[];//标签
    let itemsTag=[];//平台
    let itemsTag1=[];//终端
    let {items,items1,MemGoods} = self.state
    if(items!=null){
      itemsTag=items.map((data, rowIndex) => {
        itemsTag=[<Option key={rowIndex} value={data.ParentTerminalKey} label={data.TerminalDesc}>{data.TerminalDesc}</Option>]
       return itemsTag;
      })
    }
    if(items1!=null){
      itemsTag1=items1.map((data, rowIndex) => {
        itemsTag1=[<Option key={rowIndex} value={data.ParentTerminalKey} label={data.TerminalDesc}>{data.TerminalDesc}</Option>]
       return itemsTag1;
      })
    }
    //标签  
    seTag = self.state.seleTag.map((data, rowIndex) => {
        seTag=[<div key={rowIndex} onClick={self.rmTag.bind(self,rowIndex)} style={{border:'1px solid #CDC9C9',padding:'5px 10px',float:'left',fontSize:'12px',margin:'0 1% 0 0',textAlign:"center"}}>{data.TagName}</div>]
        return seTag;
      })
      
     //用户用药数据 
    let gridOption = {
      title: "用户用药管理",
      url: {
        read: APIV4+"/memcount/usedrug"
      },
      checkable: true,
      filterRules:[{field:"tagKey",operate:"equal",value:self.state.tagKey1}],
      //customRules:[{field:"tagKey",operate:"equal",value:self.state.tagKey1}],

      primaryKey:"_id",
      beforeQuery:function( gridDatas,filters,pageIndex,pageSize){
        if(pageIndex * pageSize > 1000000){
          message.error("不能翻页超过"+pageIndex+"页");
          return false;
        }else 
        return true;
      },
      columns: [
        { title: "用户ID", data: "_id", type: "text", editor: {}, isRequired: true,hide:true },
        { title: "昵称", data: "MemName", type: "text", editor: {}, query: false, isRequired: true },
        { title: "手机号码", data: "MemPhone", type: "text", editor: {}, query: false, isRequired: true },
        { title: "正在用药数", data: "UseCount", type: "text", editor:{},isRequired: true },
        { title: "快用完数量", data: "DomeCount", type: "text", editor: {}, isRequired: true }, 
        { title: "预计用完时间", data: "EndTime", type: "text", editor: {}, isRequired: true },
        { title: "预计用完天数", data: "OutDays", type: "number", editor: {}, query: false,hide:true },
        { title: "标签", data: "tagKey", type: "text", editor: {}, query: false,hide:true }, 
        { title: "上次操作时间", data: "UpTime", type: "text", editor: {}, isRequired: true },
        {
          title: "操作选项", type: "command", actions: [
            {
              name: '详情',
              color: '#67c23a',
              onClick: (data) => {
                if(data.Mem_Goods!=null){
                  self.setState({
                    tagStyle:{display:"none"},
                    tagStyle1:{display:"block"},
                    formVisiable: true,
                    formConfirmLoading: true,
                    MemGoods:data.Mem_Goods
                  })
                }else{
                  message.error("暂无数据！");
                }
              }
            }
          ]
        }
      ]
    };

    //对象列表
    let gridOptionsTag = {
        title: "标签列表",
        url: {
          read: "/web/mem_tag/AllTagList"
        },
        primaryKey:'_id',
        beforeQuery:function(gridDatas,filters,pageIndex,pageSize){
        let filterDistinct = [];
          if(pageIndex * pageSize > 1000000){
            message.error("不能翻页超过"+pageIndex+"页");
            return false;
          }else 
          return true;
        },
        columns: [
          { title: "标签ID", data: "_id", type: "text", editor: {ap: 'hide', ep: 'hide'}, isRequired: true },
          { title: "标签名称", data: "TagName", type: "text", editor: {},query:false,  query: true },
          { title: "标签类型名称", data: "TagTypeName", type: "text", editor: {ap: 'hide', ep: 'hide'},hide:true}, 
          { title: "标签类型", data: "TagTypeId", type: "dropdown", editor: {},
            source: { url: '/web/Mem_TagType/type?t='+self.state.randStr },query:true }, 
          { title: "标签名称", data: "TagName", type: "text", editor: {},query:false,  query: true },
        ],
        checkable: true,
        actions: [{
          name: '确认选择',
          onClick: function (e) {
            for(let key in e){
                self.state.tagKey.push(e[key])
                self.state.tagKey=self.unique5(self.state.tagKey)
              }
              var chilTag=self.state.gridDatas.current.state.gridDatas.items
              for(let tag in chilTag){
                for(let key in self.state.tagKey){
                  if(self.state.tagKey[key]==chilTag[tag].TagId){
                    self.state.seleTag.push(chilTag[tag])
                    self.state.seleTag=self.unique5(self.state.seleTag)
                    break;
                  }
                }
              }
            self.setState({
              formVisiable: false,
              formConfirmLoading: false
            });
          }
        }],
        };





    //对象列表
    let gridOptionsTag2 = {
      title: "标签列表",
      primaryKey:'ProductCode',
      dataSource: MemGoods,
      columns: [
        { title: "商品编号", data: "ProductCode", type: "text", editor: {}, isRequired: true },
        { title: "商品名称", data: "ProductName", type: "text", editor: {},query:false },
        { title: "商品规格", data: "packing", type: "text"}, 
        { title: "用法用量", data: "Dosage", type: "text", editor: {},query:false }, 
        { title: "购买时间", data: "CrDate", type: "text", editor: {},query:false},
        { title: "剩余可用天数", data: "EndCount", type: "text", editor: {},query:false},
        {
          title: "操作", type: "command", actions: [{
            name: '呼叫',
            confirm:true,
            onClick: (data) => {
              let user = util.auth.getUser();
              let staffid = user.staffid;
              request({
                url: APIV3+"/web/ES_UsageMem/getUsreTel?staffId="+staffid+"&accountId="+user.id,
               method: "get"
             }).then(function (result) {
               if(result!=null&& result.tel.length>0){
                request({
                  url: APIV3+"/web/ES_UsageMem/usreTel?staffId="+staffid,
                 method: "post",
                 data:{"userPhone":data.AConsigneePhone2,"accountTel":result.tel[0].UserTel}
               }).then(function (result) {
                    message.success("呼叫成功！");
               })
               }else{
                message.error("暂未设置分机号，前往账户列表设置！");
               }                
             })
            }
          },{
            name: '忽略',
            onClick: (data) => {
              self.upDurGood(data)
            }
          }]
        }
      ]
      };





    return <div>
      <div style={{width:"96%",marginLeft:"2%"}}>
        {seTag}      
      <Button onClick={self.getTagList.bind(self)} icon='plus' style={{float:'left'}} type="primary">{'选择标签'}</Button>
      <div style={{clear:'both'}}></div>
      </div>
    
    <div style={{width:"96%",margin:"15px 0 0 2%"}}>
      <div style={{width:'20%',float:'left'}}>
      所属平台
      <Select
        mode="multiple"
        style={{ width: '100%' }}
        placeholder="所属平台选择"
        //defaultValue={['china']}
        onChange={self.handleChange.bind(self)}
        optionLabelProp="label">
          {itemsTag1}
      </Select>
      </div>

      <div style={{width:'20%',float:'left',marginLeft:'20px'}}>
        选择终端
        <Select
          mode="multiple"
          style={{ width: '100%' }}
          placeholder="所属终端选择"
          //defaultValue={['china']}
          onChange={self.handleChange1.bind(self)}
          optionLabelProp="label">
          {itemsTag}
        </Select>
        </div>
        <div style={{width:'20%',float:'left',margin:'22px 0 0 15px'}}>
        <Button onClick={self.getZoom.bind(self)} icon='search' type="primary">{'搜索'}</Button>
      </div>

        <div style={{clear:'both'}}></div>
        </div>

      <BirdGrid gridOption={gridOption} ref="grid0"/>

      <Modal title="选择标签"
          width="70%"
          visible={self.state.formVisiable}
          okButtonProps={{ disabled: true }}
          onCancel={() => self.cancelClick()}
          confirmLoading={self.state.formConfirmLoading}>

            
      <Row>
        <Col>
        <div style={self.state.tagStyle}><BirdGrid gridOption={gridOptionsTag} ref={self.state.gridDatas}></BirdGrid></div>

         <div style={self.state.tagStyle1}><BirdGrid gridOption={gridOptionsTag2} ref="grid"></BirdGrid></div> 
          
        </Col>
      </Row>


     </Modal>
    </div>
  }
}
// export default BirdGridElasticPage
export default connect( ( { bindActionCreators } ) => ( { bindActionCreators } ) )( BirdGridElasticPage );
