import React from 'react';
import { BirdGrid } from 'components/Grid';
// import queryString from './query-string'
import { config } from 'utils'
import { connect } from 'dva';
import { routerRedux } from 'dva/router'
import { bindActionCreators } from 'redux';
import { BirdGridmem_prescriptionPage} from '../memdoc/mem_prescription';
import { Modal,message } from 'antd';
import util from '../../utils/util';
import request from "../../utils/request"

const { APIV3,APIV4 } = config

class BirdGridElasticPage extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      visible:false,
      hasInitFilters:false,

      provinces:[],
      cities:[],
      areas:[],
      terminals:{},
    }

    //初始化地区状态
    this.state.provinces = util.Provinces;
    // this.state.cities = util.Cities.filter((item) => {
    //   let province = this.state.provinces[0].value.substring(0, 2);
    //   return item.value.startsWith(province);
    // });
    // this.state.areas = util.Areas.filter((item) => {
    //   let city = this.state.cities[0].value.substring(0, 4);
    //   return item.value.startsWith(city);
    // });
    //初始化下单平台
    request({
      url:APIV4+"/terminaldoc/getSourcePlatForms",
      method:"get"
    }).then((result) => {
      let terminals = {};
      result.forEach((item) => {
        terminals[item.value] = item.label;
      });
      this.setState({terminals:terminals});
    });
  }
 
  
          
  //关闭
  onCancel = () => {
    this.setState({ visible: false });
  };

  //确定
  onCreate = () => {
    this.setState({ visible: false });
  };

  render() { 
    let self = this;
    let gridOption = {
      title: "ES会员列表",
      url: {
        // read: APIV4+"/memberList/index"
        read: "/web/ES_Member/index"
      },
      checkable: true,
      primaryKey:"_id",
      beforeQuery:function( gridDatas,filters,pageIndex,pageSize){
        if(pageIndex * pageSize > 1000000){
          message.error("不能翻页超过"+pageIndex+"页");
          return false;
        }else 
        return true;
      },
      afterQuery: function(resultout, filters) {
        if(self.state.hasInitFilters){
          return;
        }
        self.refs.grid.setState({
          filterRules:[{
            field:"MemUsualPhone",
            operate:"equal",
            value:"",
          },{
            field:"MemberNickName",
            operate:"equal",
            value:"",
          },{
            field: "Terminals.TerminalCode",
            operate:"or",
            value:""
          },{
            field: "Terminals.MemSourcePlatforms",
            operate:"or",
            value:""
          },{
            field:"MemUsualProvinceCode",
            operate:"equal",
            value:"",
            target:"MemUsualCityCode",
            onchange: (value,targetcol) => {
              let cities = util.Cities.filter((item) => {
                let province = value.substring(0, 2);
                return item.value.startsWith(province);
              });
              //self.setState({cities:cities});
              targetcol.source.data = cities;
            }
          },{
            field:"MemUsualCityCode",
            operate:"equal",
            value:"",
            target:"MemUsualAreaCode",
            onchange: (value,targetcol) => {
              let areas = util.Areas.filter((item) => {
                let city = value.substring(0, 4);
                return item.value.startsWith(city);
              });
              //self.setState({areas:areas});
              targetcol.source.data = areas;
            }
          },{
            field:"MemUsualAreaCode",
            operate:"equal",
            value:"",
          },{
            field:"MemberBirthday",
            operate:"",
            value:""
          },{
            field:"Gender",
            operate:"equal",
            value:""
          }]
        },() => {
          self.setState({hasInitFilters:true});
        });
      },
      columns: [
        { title: "ID", data: "MemUsualPhoneCr", type: "text", editor: {}, isRequired: true,hide:false ,width:"20%"},
        { title: "昵称", data: "MemberNickName", type: "text", editor: {}, query: true, isRequired: true },
        { title: "电话号码", data: "MemUsualPhone", type: "text", editor: {}, query: true, isRequired: true },
        { title: "下单平台", data:"Terminals.MemSourcePlatforms", type:"dropdown", query:true, 
          source:{
            // url:APIV4+"/terminaldoc/getSourcePlatForms",
            url:"/web/Mem_Terminaldoc/getSourcePlatForms",
            multi:true},editor:{}, 
          render: (value,data) => {
            if(value) {
              return this.state.terminals[value.TerminalCode];
            }
          },hide:true
        },
        { title: "下单终端", data: "Terminals.TerminalCode", type: "dropdown", query:true, 
          source:{
            // url:APIV4+"/terminaldoc/getterms",
            url:"/web/Mem_Terminaldoc/getterms",
            multi:true},editor: {}, hide: true},
        { title: "首次下单终端", data: "OriginType", type: "dropdown", query:true, 
          // source:{url:APIV4+"/terminaldoc/getterms",
          source:{url:"/web/Mem_Terminaldoc/getterms",
          multi:true},editor: {}},
        // { title: "地区", data:"MemUsualAreaCode", type:"region", query:true, hide:true },
        { title: "省", data:"MemUsualProvinceCode", type:"dropdown", query:true, hide:true, source:{data:this.state.provinces}, editor:{}},
        { title: "市", data:"MemUsualCityCode", type:"dropdown", query:true, hide:true,source:{data:this.state.cities}, editor:{}},
        { title: "区", data:"MemUsualAreaCode", type:"dropdown", query:true, hide:true,source:{data:this.state.areas}, editor:{}},
        { title: "住址", data: "MemUsualAddress", type: "text", editor: {} },
        { title: "出生日期", data:"MemberBirthday", type:"date", query:true, hide:true },
        { title: "选项性别(是男性，否女性)", data:"Gender", type:"dropdown",
          source:{
            // url:APIV4+"/terminaldoc/getgender"
            url:"/web/Mem_Terminaldoc/getgender"
        }, query:true, hide:true},
        {
          title: "操作选项", type: "command", actions: [
            {
              name: '详情',
              color: '#67c23a',
              onClick: (data) => {
                //console.log(data);
                
                this.props.dispatch({
                  type: 'app/updateState', payload: {
                    menuPath: [{id:"251",name:"个人用户管理"},{id:"249",name:"个人用户详情"}]
                  }
                });
                // self.props.history.push('/auth/mem_prescription?MemberPhone='+data['MemUsualPhone']);
                this.props.dispatch(routerRedux.push({
                  pathname: '/memdoc/mem_prescription',
                  query: {MemberPhone: data['MemUsualPhoneCr']},
                  // search: queryString.stringify({
                  //   MemberPhone:data['MemUsualPhone']
                  // })
                  })
                );
                
                // self.setState({visible:true});
              }
            }
          ]
        }
      ]
    };
    return <div>
      <BirdGrid gridOption={gridOption} ref="grid"/>
      {/* <Modal
          visible={self.state.visible}
          title="用户详情"
          //onokText="Create"
          onCancel={self.onCancel}
          onOk={self.onCreate}
          width={800}
        >
          <span>eee</span>
          <BirdGridmem_prescriptionPage></BirdGridmem_prescriptionPage>
        </Modal> */}
    </div>
  }
}
// export default BirdGridElasticPage
export default connect( ( { bindActionCreators } ) => ( { bindActionCreators } ) )( BirdGridElasticPage );
