import React from 'react';
import { Modal, Select, Descriptions, Button, Input, message, Switch } from 'antd';
import { BirdGrid } from 'components/Grid';
import { config } from 'utils';
import { jrequest } from 'utils/request';

const { JAPIV } = config;

class MemberGrowthSetting extends React.Component {
    constructor(props) {
        super(props)
        this.state = {
            value: '',
            visible: false,
            visibleTasks: false,
            visibleDelete: false,
            dataDelete: {},
            taskDataUpdate: {},
            pointRule: '',
            growthRule: '',
            usingGrowth: '',
            usingPoint: '',
            timeTaskClock: 0,
            timeTaskCycle: 0,
            originTypeDatabase: null,
            timeTaskClcle: [
                {
                    "label": "每1小时",
                    "value": "每1小时",
                },
                {
                    "label": "每2小时",
                    "value": "每2小时",
                },
                {
                    "label": "每3小时",
                    "value": "每3小时",
                },
                {
                    "label": "每6小时",
                    "value": "每6小时",
                },
                {
                    "label": "每12小时",
                    "value": "每12小时",
                },
                {
                    "label": "每1天",
                    "value": "每1天",
                },
                {
                    "label": "每3天",
                    "value": "每3天",
                },
                {
                    "label": "每7天",
                    "value": "每7天",
                },
            ],
            action: [
                {
                    "label": "购药",
                    "value": "购药",
                },
                {
                    "label": "浏览",
                    "value": "浏览",
                },
                {
                    "label": "抽奖",
                    "value": "抽奖",
                },
                {
                    "label": "......",
                    "value": "......",
                }
            ]
        }

        //初始化平台来源列表
        jrequest({
            url: "/dataDictory/findAllOriginType",
            method: "get",
        }).then(result => {
            console.log(result.data);
            this.setState({ originTypeDatabase: result.data });

        });

    }

    // 
    showModal = (data) => {
        console.log(data);
        this.setState({
            taskDataUpdate: data,
            usingGrowth: data.usingGrowth,
            usingPoint: data.usingPoint,
            growthRule: data.growthRule,
            pointRule: data.pointRule,
            visible: true,
        });
    };


    handleOk = (e) => {
        console.log(e);
        this.setState({
            growthRule: '',
            pointRule: '',
            visible: false,
        });
    };

    // 关闭积分规则模态框
    handleCancel = (e) => {
        this.setState({
            visible: false,
        });
    }

    // 保存积分规则至数据库
    savetaskDataUpdate = (e) => {
        console.log(e);
        let taskDataUpdate = this.state.taskDataUpdate;
        taskDataUpdate.pointRule = this.state.pointRule;
        taskDataUpdate.growthRule = this.state.growthRule;
        taskDataUpdate.usingPoint = this.state.usingPoint ? 1 : 0;
        taskDataUpdate.usingGrowth = this.state.usingGrowth ? 1 : 0;


        this.setState({
            taskDataUpdate: taskDataUpdate,
            visible: false,
        });

        jrequest({
            url: "/pointGrowthRule/rule",
            method: "put",
            data: this.state.taskDataUpdate,
        }).then(result => {
            if (result.success) {
                message.success("保存成功");
            } else {
                message.error("保存失败");
            }
        });
    };

    // 积分计算公式修改
    onChangePointRule = (event) => {
        console.log(event.target.value);
        this.setState({
            pointRule: event.target.value
        });
    }

    // 成长值计算公式修改
    onChangeGrowthRule = (event) => {
        console.log(event.target.value);
        this.setState({
            growthRule: event.target.value
        });
    }

    // 积分值计算开关变化
    onChangeUsingPoint = () => {
        this.setState({
            usingPoint: !this.state.usingPoint,
        });
    }

    // 积分值计算开关变化
    onChangeUsingGrowth = () => {
        this.setState({
            usingGrowth: !this.state.usingGrowth,
        });
    }

    // 打开定时任务模态框
    showModalTasks = (data) => {
        this.setState({
            visibleTasks: true,
            timeTaskCycle: data.timeTaskCycle,
            timeTaskClock: data.timeTaskClock,
            taskDataUpdate: data,
        });
    };

    // ok关闭定时任务模态框
    savetaskDataUpdate1 = (e) => {
        console.log("关闭定时任务模态框");
        let taskDataUpdate = this.state.taskDataUpdate;
        taskDataUpdate.timeTaskClock = this.state.timeTaskClock;
        taskDataUpdate.timeTaskCycle = this.state.timeTaskCycle;
        console.log(taskDataUpdate);
        this.setState({
            timeTaskClock: '',
            timeTaskCycle: '',
            taskDataUpdate: taskDataUpdate,
            visibleTasks: false,
        });

        jrequest({
            url: "/pointGrowthRule/rule",
            method: "put",
            data: this.state.taskDataUpdate,
        }).then(result => {
            if (result.success) {
                message.success("保存成功");
            } else {
                message.error("保存失败");
            }
        });

    };

    // 取消定时任务模态框
    handleCancelTasks = (e) => {
        console.log(e);
        console.log("关闭");
        this.setState({
            visibleTasks: false,
        });
    };

    timeOnChange = (event) => {
        console.log(event.target.value);
        this.setState({ timeTaskClock: event.target.value });
    };

    // 更改执行周期
    onChangeTimeTaskCycle = (event) => {
        let taskDataUpdate = this.state.taskDataUpdate;
        taskDataUpdate.timeTaskCycle = event;
        this.setState({
            taskDataUpdate: taskDataUpdate,
            timeTaskCycle: event
        });
    }

    render() {


        let gridOption = {
            title: "表格示例",
            url: {
                // read: APIV4 + "/userPointLog/logs",
                read: JAPIV + "/pointGrowthRule/ruleCondition",
                // add: "/japi/pointGrowthRule/rule",
                // edit: "/test/edit",
                // delete: "/japi/pointGrowthRule/deleteRule"
            },
            pageSize: 8,
            checkable: false,
            //actions: [{ name: '外部按钮', color: 'error', onClick: function () { } }],
            columns: [
                { title: "编号", data: "id", type: "text", editor: {} },
                { title: "平台名称", data: "terminalName", type: "dropdown", editor: {}, source: { data: this.state.originTypeDatabase } },
                { title: "平台编号", data: "terminalCode", type: "text", editor: {} },
                { title: "行为", data: "action", type: "dropdown", editor: {}, source: { data: this.state.action } },
                { title: "数据源表", data: "tableName", type: "text", editor: {} },
                { title: "积分计算公式", data: "pointRule", type: "text", editor: {} },
                { title: "成长值计算公式", data: "growthRule", type: "text", editor: {} },
                { title: "定时任务", data: "timeTaskClock", type: "text", editor: {} },
                { title: "状态", data: "running", type: "switch", editor: {} },
                {
                    title: "操作", type: "command", actions: [{
                        name: '定时任务',
                        color: '#1880FF',
                        onClick: (data) => {
                            this.showModalTasks(data);
                            console.log(data)
                        }
                    }, {
                        name: '修改',
                        color: '#1880FF',
                        onClick: (data) => {
                            this.showModal(data);
                        }
                    }]
                },
                { title: "是否计算成长值", data: "usingGrowth", type: "switch", editor: {}, hide: true },
                { title: "是否计算积分", data: "usingPoint", type: "switch", editor: {}, hide: true },
                { title: "执行周期", data: "timeTaskCycle", type: "dropdown", editor: {}, source: { data: this.state.timeTaskClcle }, hide: true },
                { title: "创建者", data: "crtUser", type: "text", editor: {}, hide: true },
                { title: "最近更新时间", data: "lastUpdate", type: "text", hide: true },
            ]
        };


        return (
            <div>
                <div style={{ width: '96%', margin: '30px 0 0 2%' }}>
                    以下每个规则，由开发人员设定程序执行，运营人员只支持修改积分值规则，定时任务执行时间为每天凌晨2:00计算前一天的积分值</div>

                <BirdGrid gridOption={gridOption} ref="grid" />
                <Modal
                    title="积分规则"
                    visible={this.state.visible}
                    onOk={this.handleOk}
                    onCancel={this.handleCancel}
                    footer={[
                        <Button key="submit" type="primary" onClick={this.savetaskDataUpdate} >
                            保存
                        </Button>,
                    ]}
                >
                    <Descriptions  bordered column={1} style={{padding:'10px 0px'}}>
                        <Descriptions.Item label="编号">{this.state.taskDataUpdate.id}</Descriptions.Item>
                        <Descriptions.Item label="终端">{this.state.taskDataUpdate.terminalName}</Descriptions.Item>
                        <Descriptions.Item label="行为">{this.state.taskDataUpdate.action}</Descriptions.Item>
                        <Descriptions.Item label="积分计算公式">
                            <Switch defaultChecked checked={this.state.usingPoint} onChange={this.onChangeUsingPoint} size="small" />
                            关闭后，后续规则将不计算积分值
                            <Input placeholder={this.state.taskDataUpdate.pointRule} value={this.state.pointRule} onChange={this.onChangePointRule}></Input>
                        </Descriptions.Item>
                        <Descriptions.Item label="成长值计算公式">
                            <Switch defaultChecked checked={this.state.usingGrowth} onChange={this.onChangeUsingGrowth} size="small" />
                            关闭后，后续规则将不计算成长值
                            <Input placeholder={this.state.taskDataUpdate.growthRule} value={this.state.growthRule} onChange={this.onChangeGrowthRule}></Input>
                        </Descriptions.Item>
                        <Descriptions.Item label="公式字段说明">
                            account为订单金额
                        </Descriptions.Item>
                    </Descriptions>

                </Modal>

                <Modal
                    title="定时任务"
                    visible={this.state.visibleTasks}
                    onCancel={this.handleCancelTasks}
                    footer={[
                        <Button key="submit" type="primary" onClick={this.savetaskDataUpdate1} >
                            保存
                        </Button>,
                    ]}

                >
                    <div>
                        <Descriptions  bordered column={1} style={{padding:'10px 0px'}}>
                            <Descriptions.Item label="规则编号">{this.state.taskDataUpdate.id}</Descriptions.Item>
                            <Descriptions.Item label="平台名称">{this.state.taskDataUpdate.terminalName}</Descriptions.Item>
                            <Descriptions.Item label="执行时间">
                                <Input value={this.state.timeTaskClock} onChange={this.timeOnChange} />
                            </Descriptions.Item>
                            <Descriptions.Item label="执行周期">
                                <Select defaultValue="执行周期" value={this.state.timeTaskCycle} onChange={this.onChangeTimeTaskCycle}>
                                    <Option value="每1小时">每1小时</Option>
                                    <Option value="每2小时">每2小时</Option>
                                    <Option value="每3小时">每3小时</Option>
                                    <Option value="每6小时">每6小时</Option>
                                    <Option value="每12小时">每12小时</Option>
                                    <Option value="每1天">每1天</Option>
                                    <Option value="每3天">每3天</Option>
                                    <Option value="每7天">每7天</Option>
                                </Select>
                            </Descriptions.Item>
                        </Descriptions>
                    </div>
                </Modal>

            </div>

        );
    }
}


export default MemberGrowthSetting;
