import React from 'react';
import { Modal, Select, Descriptions, Button, Input ,message} from 'antd';
import { BirdGrid } from 'components/Grid';
import { config, request, util } from 'utils'
import { jrequest } from 'utils/request';


const { Option } = Select;
const { JAPIV } = config;


class MemberPoints extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            value: '',
            visible: false,
            visibleLogs: false,
            memPointsLog: [],
            visibleEvidence: false,
            evidenceData: {},
            weixinUserInfo:{},
            addPointLog:{},
            increaseOrDecrease : "add",
            pointIncrease: 0,
            pointIncreaseDesc:'人为增加或者减少积分',
            secretPhone:""
        };

    }

    showModal = (data) => {
        this.setState({
            visible: true,
            weixinUserInfo: data
        });
    };

    handleOk = (e) => {
        let self  = this;
        console.log(e);
        let addPointLog = this.state.addPointLog;
        addPointLog.secretPhone = this.state.weixinUserInfo.secretPhone;
        addPointLog.id = this.state.weixinUserInfo.id;
        addPointLog.increase = this.state.increaseOrDecrease === "add" ? true:false;
        addPointLog.action = this.state.increaseOrDecrease === "add" ? '人为增加积分': '人为减少积分';
        addPointLog.remark = this.state.pointIncreaseDesc;
        addPointLog.value = this.state.pointIncrease;
        addPointLog.terminalName = "会员中心"
        addPointLog.terminalAction = "人为增加或者减少积分"
        if(this.state.pointIncrease <= 0){
            message.error("增加或者减少的积分不能小于等于0");
            return;
        }

        if(addPointLog.increase){
            addPointLog.balance = parseInt(this.state.weixinUserInfo.point) + parseInt(this.state.pointIncrease);
        }else{
            addPointLog.balance = parseInt(this.state.weixinUserInfo.point) - parseInt(this.state.pointIncrease);
        }
        console.log(addPointLog);
        if(addPointLog.balance < 0){
            message.error("变更后的积分不能为负数");
            return;
        }

       
        this.setState({
            pointIncrease:0,
            visible: false,
        });

        jrequest({
            url: "/wechatInfo/addPoint",
            method: "post",
            data:addPointLog
        }).then(result => {
            if (result.success) {
                message.success("保存成功");
                self.refs.grid.reload();
            } else {
                message.error("保存失败");
            }
        });

    };

    handleCancel = (e) => {
        console.log(e);
        this.setState({
            visible: false,
        });
    };


    handleCancelLogs = (e) => {
        console.log(e);
        console.log("关闭");
        this.setState({
            visibleLogs: false,
            secretPhone:""
        });
    };

    //弹出证据链查看模态框
    showModalEvidence = (data) => {
        this.setState({
            evidenceData: data,
            visibleEvidence: true,
        });
    }

     //关闭证据链查看模态框
     handleCancelEvidence = () => {
        this.setState({
            visibleEvidence: false
        })
    }

    // 增加或者减少
    increaseOrDecrease =(event) =>{
        // console.log(event);
        this.setState({
            increaseOrDecrease: event
        })
    }
    // 增加或者减少的积分数
    pointIncrease =(event) =>{
        // console.log(event.target.value);
        this.setState({
            pointIncrease: event.target.value
        })
    }
    // 增加或者减少的积分数
    pointIncreaseDesc =(event) =>{
        // console.log(event.target.value);
        this.setState({
            pointIncreaseDesc: event.target.value
        })
    }


    render() {

        let self = this;

        let gridOption = {
            title: "表格示例",
            url: {
                // read: APIV4 + "/userPointLog/logs",
                read: JAPIV + "/wechatInfo/query",
                // add: "/test/add",
                // edit: "/test/edit",
                // delete: "/test/delete"
                data: {}
            },
            pageSize: 8,
            checkable: false,
            //actions: [{ name: '外部按钮', color: 'error', onClick: function () { } }],
            columns: [
                { title: "会员ID", data: "id", type: "text", editor: {} },
                { title: "姓名（昵称）", data: "nickname", type: "number" },
                { title: "收货人", data: "consignee", type: "number" },
                { title: "手机号", data: "secretPhone1", type: "number",query:true },
                { title: "积分余额", data: "point", type: "text", editor: {} },
                { title: "成长值", data: "growth", type: "text", editor: {} },
                {
                    title: "操作选项", type: "command", actions: [{
                        name: '更改',
                        color: '#1880FF',
                        onClick: (data) => {
                            this.showModal(data)
                        }
                    }, {
                        name: '日志',
                        color: '#1880FF',
                        onClick: (data) => {
                            self.setState({
                                visibleLogs: true,
                                secretPhone:data.secretPhone
                            })
                        }
                    }]
                }
            ]
        };

        let gridOptionLogs = {
            title: "表格示例",
            //dataSource: this.state.memPointsLog,
            url: {
                read: JAPIV + "/userPointLog/logsConditionOneUserV3"
            },
            afterQuery: function(resultout, filters) {
                //查询完后直接隐藏调按钮
                let eles = document.getElementsByClassName("ant-btn-group");
                let ele = eles[eles.length - 1];
                ele.style = "display:none;";
            },
            filterRules:[{field:"secretPhone",operate:"equal",value:self.state.secretPhone}],
            pageSize: 15,
            checkable: false,
            columns: [
                { title: "会员ID", data: "id", type: "text", editor: {}, hide: true },
                { title: "时间", data: "crtDate", type: "text", editor: {} },
                { title: "原始积分值", data: "origin", type: "number" },
                { title: "变更积分值", data: "value", type: "number" },
                { title: "变更后积分值", data: "balance", type: "text", editor: {} },
                { title: "用户行为终端", data: "terminalName", type: "text", editor: {} },
                { title: "用户行为", data: "terminalAction", type: "text", editor: {} },
                { title: "备注", data: "remark", type: "text", editor: {} },
                {
                    title: "证据链", type: "command", actions: [{
                        name: '查看',
                        color: '#1880FF',
                        onClick: (data) => {
                            this.showModalEvidence(data);
                        }
                    }]
                }

            ]
        };

        const selectBefore = (
            <Select value={this.state.increaseOrDecrease} style={{ width: 90 }} onChange={this.increaseOrDecrease}>
                <Option value="add">增加</Option>
                <Option value="delete">减少</Option>
            </Select>
        );

        return (
            <div style={{ width: '96%', margin: '30px 0 20px 2%' }}>
                <BirdGrid gridOption={gridOption} ref="grid" />
                <Modal
                    title="更改积分账户余额"
                    visible={this.state.visible}
                    onOk={this.handleOk}
                    onCancel={this.handleCancel}
                    footer={[
                        <Button key="submit" type="primary" onClick={this.handleOk} >
                            保存
                        </Button>,
                    ]}
                >
                    <Descriptions bordered column={1} style={{padding:'10px 0px'}}>
                        <Descriptions.Item label="原积分">{this.state.weixinUserInfo.point}</Descriptions.Item>
                        <Descriptions.Item label="变更积分">
                            <div style={{ marginBottom: 16 }}>
                                <Input addonBefore={selectBefore} addonAfter="积分" value={this.state.pointIncrease} onChange={this.pointIncrease} placeholder={this.state.pointIncrease}></Input>
                            </div>
                        </Descriptions.Item>
                        <Descriptions.Item label="原因说明"><Input onChange={this.pointIncreaseDesc} placeholder={this.state.pointIncreaseDesc}></Input></Descriptions.Item>

                    </Descriptions>

                </Modal>

                <Modal
                    title="账户变更日志"
                    visible={this.state.visibleLogs}
                    onCancel={this.handleCancelLogs}
                    footer={null}
                    width={1000}
                >
                    <BirdGrid gridOption={gridOptionLogs} ref="grid1" />

                </Modal>


                <Modal
                    title="证据链"
                    visible={this.state.visibleEvidence}
                    onCancel={this.handleCancelEvidence}
                    footer={[
                        <Button key="submit" type="primary" onClick={this.handleCancelEvidence} >
                            返回
                                </Button>,
                    ]}
                    width="80%"
                >
                    <div>
                        <Descriptions title="基础信息"  bordered column={2} style={{padding:'10px 0px'}}>
                            <Descriptions.Item label="数据来源平台">{this.state.evidenceData.terminalName}</Descriptions.Item>
                            <Descriptions.Item label="订单编号" span={2}>{this.state.evidenceData.dataCode}</Descriptions.Item>
                            <Descriptions.Item label="用户行为" span={2}>{this.state.evidenceData.terminalAction}</Descriptions.Item>
                        </Descriptions>
                        <Descriptions title="变量字段"  bordered column={2} style={{padding:'10px 0px'}}>
                            <Descriptions.Item label="订单金额">{this.state.evidenceData.orderAmount}</Descriptions.Item>
                            <Descriptions.Item label="优惠金额">{this.state.evidenceData.discountedPrice}</Descriptions.Item>
                            <Descriptions.Item label="物流运费">{this.state.evidenceData.transportCost}</Descriptions.Item>
                            <Descriptions.Item label="实付金额">{this.state.evidenceData.payment}</Descriptions.Item>
                        </Descriptions>
                        {/* <Descriptions title="成长值计算" column={1} style={{ margin: '25px 20px 0 0' }}>
                                    <Descriptions.Item label="计算公式">{this.state.evidenceData.remark}</Descriptions.Item>
                                    <Descriptions.Item label="成长值变动">500.00 *  5% = 25</Descriptions.Item>
                                </Descriptions> */}
                        <Descriptions title="积分值计算"  bordered column={2} style={{padding:'10px 0px'}}>
                            <Descriptions.Item label="计算公式">{this.state.evidenceData.remark}</Descriptions.Item>
                            <Descriptions.Item label="积分值变动">{this.state.evidenceData.payment}*{this.state.evidenceData.remark ? this.state.evidenceData.remark.split("*")[1] : ""}={this.state.evidenceData.value}</Descriptions.Item>
                        </Descriptions>
                    </div>
                </Modal>

            </div>

        );
    }
}

export default MemberPoints;
