import React, { Component } from 'react';
import { jrequest } from 'utils/request';
import { Modal, Row, Col, Table, Button, Popconfirm, message, Descriptions, Select, Input } from 'antd';

import 'antd/dist/antd.css';

const { Option } = Select;

class Orginazation extends Component {
    constructor(props) {
        super(props);
        this.state = {
            editVisiable: false,
            editConfirmLoading: false,
            secretVisiable: false,
            secretConfirmLoading: false,
            resourceVisiable: false,
            resourceConfirmLoading: false,
            addVisiable: false,
            addConfirmLoading: false,
            organizationList: [
            ],
            resourceList: [
            ],
            organizationEdit: {},
            organizationSecret: {},
            organizationAdd: {},
            current: 1,
            total: 0,
            pageSize: 10,


            resourceListAll: [],
            resourceListCondition: [],
            resourceTypeListAll: [],
            selectedRowKeysInit: [],
            selectedRowKeys: [],

            // 即将授权的机构
            organizationResource: {},
            // 选择的接口类型
            selectedResourceType: '',
            // 选择的接口名称
            selectedResourceName: '',

        };

        //初始化所有接口类型列表
        jrequest({
            url: "/resourceType/all",
            method: "get"
        }).then(result => {
            let resourceTypeListTemp = result.data;
            this.setState({
                resourceTypeListAll: resourceTypeListTemp,
            });

        });


        //初始化接口列表
        jrequest({
            url: "/resource/all",
            method: "get",
        }).then(result => {
            let resourceListAllTemp = result.data;
            this.setState({
                resourceListAll: resourceListAllTemp,
                resourceListCondition: resourceListAllTemp,
            });
        });


        //初始化机构列表列表
        jrequest({
            url: "/orgdoc/searchByCondition",
            method: "post",
            data: {
                current: this.state.current,
                searchCount: true,
                size: this.state.pageSize,
            }
        }).then(result => {
            let organizationListTemp = result.data.records;
            this.setState({
                organizationList: organizationListTemp,
                total: result.data.total
            });
        });
    }


    // 刷新机构数据
    refreshOrganizationData = () => {
        jrequest({
            url: "/orgdoc/searchByCondition",
            method: "post",
            data: {
                current: this.state.current,
                searchCount: true,
                size: this.state.pageSize,
            }
        }).then(result => {
            let organizationListTemp = result.data.records;
            this.setState({
                organizationList: organizationListTemp,
                total: result.data.total
            });
        });
    }

    // 设置机构表格
    getTableColumnDef = () => {
        return [{
            title: "机构Id",
            dataIndex: "orgId",
            key: "orgId",
            render: (text, record, index) => {
                return <span>{text}</span>
            }
        }, {
            title: "机构名称",
            dataIndex: "orgName",
            key: "orgName",
            render: (text, record, index) => {
                return <span>{text}</span>
            }
        }, {
            title: "合作状态",
            dataIndex: "authStatus",
            key: "authStatus",
            render: (text, record, index) => {
                return <span>{text == 1 ? "合作中" : "已停止"}</span>
            }
        }, {
            title: "接口授权数量",
            dataIndex: "authNum",
            key: "authNum",
            render: (text, record, index) => {
                return <span><a style={{ marginRight: 16 }} onClick={() => this.handResource(text, record)}>{text}</a></span>
            }
        },
        {
            title: '操作',
            key: 'action',
            render: (text, record) => (
                <span>
                    <a style={{ marginRight: 16 }} onClick={() => this.handOrganizationEdit(text, record)}>编辑</a>
                    <a onClick={() => this.handOrganizationCheck(text, record)}>查看密钥</a>
                </span>
            ),
        },
        ];
    }

    // 设置授权表格
    getTableColumnDefResource = () => {
        return [{
            title: "接口编码",
            dataIndex: "code",
            key: "code",
            render: (text, record, index) => {
                return <span>{text}</span>
            }
        }, {
            title: "接口类型",
            dataIndex: "parentId",
            key: "parentId",
            render: (text, record, index) => {
                return <span>
                    {
                        this.state.resourceTypeListAll.find(resourceType => resourceType.id == text).name
                    }
                </span>
            }
        }, {
            title: "接口名称",
            dataIndex: "name",
            key: "name",
            render: (text, record, index) => {
                return <span>{text}</span>
            }
        }, {
            title: "接口描述",
            dataIndex: "description",
            key: "description",
            render: (text, record, index) => {
                return <span>{text}</span>
            }
        }

        ];
    }


    // 显示页数发生变化
    onShowSizeChange = (current, pageSize) => {
        this.setState({
            pageSize: pageSize
        }, () => { this.refreshOrganizationData() });

    }

    // 表格点击换页
    changePage = (page) => {

        this.setState({
            current: page,
        }, () => { this.refreshOrganizationData() });

    }

    // 显示总条数
    showTotal = () => {
        return '总共' + this.state.total + '条'
    }

    // 显示页数发生变化
    onShowSizeChange = (current, pageSize) => {
        this.setState({
            pageSize: pageSize
        }, () => { this.refreshOrganizationData() });

    }



    // 新增组织机构
    onAddOrganization = () => {
        this.setState({
            addVisiable: true,
            addConfirmLoading: true
        });
    }

    /* 新增机构取消事件 */
    addCancelClick = () => {
        this.setState({
            addVisiable: false,
            addConfirmLoading: false
        });
    }


    // 机构新增parentName
    organizationAddParentName = (value) => {
        let organizationAddTemp = { ...this.state.organizationAdd }
        organizationAddTemp.parentName = value
        this.setState({
            organizationAdd: organizationAddTemp
        })
    }

    // 机构新增orgName
    organizationAddOrgName = (event) => {
        let organizationAddTemp = { ...this.state.organizationAdd }
        organizationAddTemp.orgName = event.target.value
        this.setState({
            organizationAdd: organizationAddTemp
        })
    }



    // 保存新增数据
    handAddOk = (e) => {
        this.setState({
            addVisiable: false,
            addConfirmLoading: false,
        }, () => {
            jrequest({
                url: "/orgdoc/add",
                method: "post",
                data: this.state.organizationAdd
            }).then(result => {
                message.success("新增机构成功")
                this.refreshOrganizationData()
            });
        })
    }




    // 机构信息数据编辑
    handOrganizationEdit = (text, record) => {
        this.setState({
            editVisiable: true,
            organizationEdit: record
        })

    }


    /* 机构信息编辑取消 */
    editCancelClick = () => {
        this.setState({
            editVisiable: false,
            editConfirmLoading: false
        });
    }


    // 机构编辑OrgName
    organizationEditOrgName = (event) => {
        let organizationEditTemp = { ...this.state.organizationEdit }
        organizationEditTemp.orgName = event.target.value
        this.setState({
            organizationEdit: organizationEditTemp
        })
    }


    // 机构编辑ParentName
    organizationEditParentName = (value) => {
        let organizationEditTemp = { ...this.state.organizationEdit }
        organizationEditTemp.parentName = value
        this.setState({
            organizationEdit: organizationEditTemp
        })
    }

    // 机构编辑authStatus
    organizationEditauthStatus = (value) => {
        let organizationEditTemp = { ...this.state.organizationEdit }
        organizationEditTemp.authStatus = value == "合作中" ? 1 : 0;
        this.setState({
            organizationEdit: organizationEditTemp
        })
    }

    // 保存修改数据
    handEditOk = (e) => {
        this.setState({
            editVisiable: false,
            editConfirmLoading: false,
        }, () => {
            jrequest({
                url: "/orgdoc/update",
                method: "put",
                data: this.state.organizationEdit
            }).then(result => {
                message.success("更新机构信息成功")
                this.refreshOrganizationData()
            });
        })
    }


    // 接口授权窗口弹出
    handResource = (text, record) => {

        // 查询机构授权的接口
        jrequest({
            url: "/orgdocResource/selectByOrgId?orgId=" + record.id,
            method: "get",
        }).then(result => {
            let selectedRowKeysTemp = result.data.map(x => { return (x.resourceId) })
            // selectedRowKeys.push(result.data.resourceId)
            this.setState({
                selectedRowKeys: selectedRowKeysTemp,
                selectedRowKeysInit: selectedRowKeysTemp,
                organizationResource: record,
                resourceVisiable: true,
                resourceConfirmLoading: true,
                selectedResourceType: '',
                selectedResourceName: '',
            })
        });


    }


    /* 接口授权框取消事件 */
    resourceCancelClick = () => {
        this.setState({
            resourceVisiable: false,
            resourceConfirmLoading: false,
            resourceListCondition: this.state.resourceListAll
        });
    }

    // 接口授权保存
    handResourceOk = (e) => {

        const { selectedRowKeysInit, selectedRowKeys } = this.state;

        let selectedRowKeysInitSet = new Set(selectedRowKeysInit)
        let selectedRowKeysSet = new Set(selectedRowKeys)

        // 要删除的授权
        let resourceDelete = selectedRowKeysInit.filter(x => !selectedRowKeysSet.has(x)).map(key => {
            return ({
                "orgId": this.state.organizationResource.id,
                "resourceId": key
            })
        })


        if (resourceDelete.length > 0) {
            // 将删除授权信息写入数据库
            jrequest({
                url: "/orgdocResource/deleteBatch",
                method: "delete",
                data: resourceDelete
            }).then(result => {
                message.success("删除授权成功")
                this.refreshOrganizationData()
            });
        }


        // 要保存的授权
        let resourceAdd = selectedRowKeys.filter(x => !selectedRowKeysInitSet.has(x)).map(key => {
            return ({
                "orgId": this.state.organizationResource.id,
                "resourceId": key
            })
        })

        if (resourceAdd.length > 0) {
            // 将授权信息写入数据库
            jrequest({
                url: "/orgdocResource/addBatch",
                method: "post",
                data: resourceAdd
            }).then(result => {
                message.success("新增授权成功")
                this.refreshOrganizationData()
            });
        }

        this.setState({
            resourceVisiable: false,
            resourceConfirmLoading: false,
            resourceListCondition: this.state.resourceListAll
        })


    }


    /* 密钥查看取消事件 */
    secretCancelClick = () => {
        this.setState({
            secretVisiable: false,
            secretConfirmLoading: false
        });
    }


    // 接口密钥查看
    handOrganizationCheck = (text, record) => {
        this.setState({
            organizationSecret: record,
            secretVisiable: true,
            secretConfirmLoading: true,
        })

    }

    // 接口密钥Ips
    organizationSecretIps = (event) => {
        let organizationSecretTemp = { ...this.state.organizationSecret }
        organizationSecretTemp.ips = event.target.value
        this.setState({
            organizationSecret: organizationSecretTemp
        })
    }


    // 接口密钥保存
    handSecretOk = (e) => {
        this.setState({
            secretVisiable: false,
            secretConfirmLoading: false,
        }, () => {
            jrequest({
                url: "/orgdoc/update",
                method: "put",
                data: this.state.organizationSecret
            }).then(result => {
                message.success("更新ip白名单成功")
                this.refreshOrganizationData()
            });
        })
    }


    // 选择授权
    onSelectChange = selectedRowKeys => {
        this.setState({
            selectedRowKeys
        })
    };

    // 全部授权按钮
    selectAllRowkeys = () => {
        this.setState({
            selectedRowKeys: this.state.resourceListCondition.map(x => { return (x.id) })
        })
    }

    // 选择接口类型
    selectedResourceTypeChange = (value) => {
        this.setState({
            selectedResourceType: value
        })
    }

    // 选择接口名称
    selectedResourceNameChange = (event) => {
        this.setState({
            selectedResourceName: event.target.value
        })
    }

    // 查询
    conditionQuery = () => {
        let resourceListConditionTemp = null
        if (this.state.selectedResourceType != '' && this.state.selectedResourceName != '') {
            resourceListConditionTemp = this.state.resourceListAll.filter(x => x.parentId == this.state.resourceTypeListAll.find(x => x.name == this.state.selectedResourceType).id && x.name == this.state.selectedResourceName)
        }
        if (this.state.selectedResourceType != '' && this.state.selectedResourceName == '') {
            resourceListConditionTemp = this.state.resourceListAll.filter(x => x.parentId == this.state.resourceTypeListAll.find(x => x.name == this.state.selectedResourceType).id )
        }
        if (this.state.selectedResourceType == '' && this.state.selectedResourceName != '') {
            resourceListConditionTemp = this.state.resourceListAll.filter(x => x.name == this.state.selectedResourceName )
        }
        if (this.state.selectedResourceType == '' && this.state.selectedResourceName == '') {
            resourceListConditionTemp = this.state.resourceListAll
        }


        this.setState({
            resourceListCondition: resourceListConditionTemp
        })


    }


    render() {


        const { selectedRowKeys } = this.state;

        const rowSelection = {
            selectedRowKeys,
            onChange: this.onSelectChange,
            columnTitle: "授权",
            fixed: true
        };

        return (
            <div style={{ padding: '25px', background: 'white' }}>
                <div style={{ padding: '10px 0px' }}>
                    <Button type="primary" onClick={this.onAddOrganization} >添加</Button>
                </div>

                {/* 机构表 */}
                <div>
                    <Table
                        size="small"
                        dataSource={this.state.organizationList}
                        bordered
                        pagination={{ pageSize: 10 }}
                        columns={this.getTableColumnDef()}
                        rowKey={record => record.id}
                        pagination={{  // 分页
                            current: this.state.current,
                            total: this.state.total,
                            onChange: this.changePage,
                            showTotal: this.showTotal,
                            showSizeChanger: true,
                            showQuickJumper: true,
                            onShowSizeChange: (current, pageSize) => this.onShowSizeChange(current, pageSize)
                        }}
                    />
                </div>

                {/* 添加机构 */}
                <div>
                    <Modal title="添加机构"
                        width="70%"
                        visible={this.state.addVisiable}
                        okButtonProps={{ disabled: true }}
                        onCancel={() => this.addCancelClick()}
                        confirmLoading={this.state.addConfirmLoading}
                        footer={[
                            <Button key="submit" type="primary" onClick={this.handAddOk} >
                                保存
                            </Button>,
                        ]}>

                        <Descriptions bordered column={1} style={{ padding: '10px 0px' }}>
                            <Descriptions.Item label="机构名称"><Input value={this.state.organizationAdd.orgName} onChange={this.organizationAddOrgName}></Input></Descriptions.Item>
                            <Descriptions.Item label="所属平台">
                                <Select value={this.state.organizationAdd.parentName} style={{ width: 180 }} onChange={this.organizationAddParentName}>
                                    <Option value="亮健官网">亮健官网</Option>
                                    <Option value="互联网医院">互联网医院</Option>
                                    <Option value="亮健优医">亮健优医</Option>
                                </Select>
                            </Descriptions.Item>
                        </Descriptions>


                    </Modal>
                </div>

                {/* 机构信息编辑 */}
                <div>
                    <Modal title="机构信息编辑"
                        width="70%"
                        visible={this.state.editVisiable}
                        okButtonProps={{ disabled: true }}
                        onCancel={() => this.editCancelClick()}
                        confirmLoading={this.state.editConfirmLoading}
                        footer={[
                            <Button key="submit" type="primary" onClick={this.handEditOk} >
                                保存
                            </Button>,
                        ]}>

                        <Descriptions bordered column={1} style={{ padding: '10px 0px' }}>
                            <Descriptions.Item label="机构ID">{this.state.organizationEdit.id}</Descriptions.Item>
                            <Descriptions.Item label="机构名称">
                                <Input value={this.state.organizationEdit.orgName} onChange={this.organizationEditOrgName}></Input>
                            </Descriptions.Item>
                            <Descriptions.Item label="所属平台">
                                <Select value={this.state.organizationEdit.parentName} style={{ width: 180 }} onChange={this.organizationEditParentName}>
                                    <Option value="亮健官网">亮健官网</Option>
                                    <Option value="互联网医院">互联网医院</Option>
                                    <Option value="亮健优医">亮健优医</Option>
                                </Select>
                            </Descriptions.Item>
                            <Descriptions.Item label="合作状态">
                                <Select value={this.state.organizationEdit.authStatus == 1 ? "合作中" : "已停止"} style={{ width: 180 }} onChange={this.organizationEditauthStatus}>
                                    <Option value="合作中">合作中</Option>
                                    <Option value="已停止">已停止</Option>
                                </Select>
                            </Descriptions.Item>
                        </Descriptions>


                    </Modal>
                </div>

                {/* 接口密钥 */}
                <div>
                    <Modal title="接口密钥"
                        width="70%"
                        visible={this.state.secretVisiable}
                        okButtonProps={{ disabled: true }}
                        onCancel={() => this.secretCancelClick()}
                        confirmLoading={this.state.secretConfirmLoading}
                        footer={[
                            <Button key="submit" type="primary" onClick={this.handSecretOk} >
                                保存
                            </Button>,
                        ]}>

                        <Descriptions bordered column={1} style={{ padding: '10px 0px' }}>
                            <Descriptions.Item label="机构">{this.state.organizationSecret.id}</Descriptions.Item>
                            <Descriptions.Item label="机构名称">{this.state.organizationSecret.orgName}</Descriptions.Item>
                            <Descriptions.Item label="所属平台">{this.state.organizationSecret.parentName}</Descriptions.Item>
                            <Descriptions.Item label="APPID">{this.state.organizationSecret.orgId}</Descriptions.Item>
                            <Descriptions.Item label="KEY">{this.state.organizationSecret.secret}</Descriptions.Item>
                            <Descriptions.Item label="IP白名单"><Input value={this.state.organizationSecret.ips} onChange={this.organizationSecretIps}></Input></Descriptions.Item>
                        </Descriptions>


                    </Modal>

                </div>

                {/* 接口授权 */}
                <div>
                    <Modal title="接口授权"
                        width="70%"
                        visible={this.state.resourceVisiable}
                        okButtonProps={{ disabled: true }}
                        onCancel={() => this.resourceCancelClick()}
                        confirmLoading={this.state.resourceConfirmLoading}
                        footer={[
                            <Button key="submit" type="primary" onClick={this.handResourceOk} >
                                保存
                            </Button>,
                        ]}>

                        <Select value={this.state.selectedResourceType} style={{ padding: "10px 0px", width: "100px" }} onChange={this.selectedResourceTypeChange}>
                            <Option value='' key='empty'></Option>
                            {
                                this.state.resourceTypeListAll.map((x) => {
                                    return (<Option value={x.name} key={x.id}>{x.name}</Option>)
                                })
                            }
                            
                        </Select>
                        <Input value={this.state.selectedResourceName} style={{ padding: "10px 10px", width: "100px" }} onChange={this.selectedResourceNameChange}></Input>
                        <Button type="primary" style={{ padding: "0px 10px", width: "100px" }} onClick={this.conditionQuery}>查询</Button>
                        <Button type="primary" style={{ width: "100px", float: "right" }} onClick={this.selectAllRowkeys}>全部授权</Button>

                        <Table
                            size="small"
                            dataSource={this.state.resourceListCondition}
                            bordered
                            pagination={{ pageSize: 10 }}
                            columns={this.getTableColumnDefResource()}
                            rowKey={record => record.id}
                            rowSelection={rowSelection}
                            pagination={{  // 分页
                                showTotal: (() => { return '总共' + this.state.resourceListAll.length + '条' }),
                                showSizeChanger: true,
                                showQuickJumper: true,
                            }}
                        />


                    </Modal>


                </div>

            </div>
        );
    }
}

export default Orginazation;