import React from 'react';
import ReactEcharts from 'echarts-for-react';

import {
  request,
  config,
  util,
  permission
} from 'utils';
const {
  APIV3
} = config


class BirdGridPermissionPage extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      option: {}
    }
    this.onChartClick=this.onChartClick.bind(this);
  }

  componentWillMount() {
    let o = this;
    let op  = {
      tooltip: {
          trigger: 'item',
          formatter: "{a} <br/>{b}: {c} ({d}%)"
      },
      legend: {
          orient: 'vertical',
          x: 'left',
          data:[]
      },
      series: [
          {
              name:'推送消息统计',
              type:'pie',
              radius: ['25%', '60%'],
              avoidLabelOverlap: false,
              label: {
                  normal: {
                      show: false,
                      position: 'center'
                  },
                  emphasis: {
                      show: true,
                      textStyle: {
                          fontSize: '22',
                          fontWeight: 'bold'
                      }
                  }
              },
              labelLine: {
                  normal: {
                      show: false
                  }
              },
              data:[
              ]
          }
      ]
  };


    request({
      url: APIV3 + '/api/home',
      method: "get"
    }).then((resp) => {
      let arr = []
      arr.push({
        value: resp.data[0].fill,
        name: '已填写'
      })
      arr.push({
        value: resp.data[0].unfill,
        name: '未填写'
      })
      arr.push({
        value: resp.data[0].lessthan,
        name: '低于需求数量'
      })
      arr.push({
        value: resp.data[0].genpro,
        name: '生成采购计划'
      })
      arr.push({
        value: resp.data[0].genord,
        name: '生成订单'
      })
      op.series[0].data = arr.sort(function (a, b) {
        return a.value - b.value;
      })
      console.log(op)
      o.setState({
        option: op
      })
    });
  }

  getOption() {
    const option = this.state.option
    return option;
  }

  onChartClick(arg) {
        switch (arg.data.name) {
          case '已填写':
            this.props.history.push('/pushrecord/pushrecordconfirmed');
            break;
          case '未填写':
            this.props.history.push('/pushrecord/pushrecord');
            break;
          case '低于需求数量':
            this.props.history.push('/pushrecord/pushrecordconfirm');
            break;
          case '生成采购计划':
            this.props.history.push('/pushrecord/pushrecordhasplan');
            break;
          case '生成订单':
            this.props.history.push('/pushrecord/pushrecordhasorder');
            break;

        }
  }

  render() {
    let onEvents = {
      'click': this.onChartClick
    }
    return <ReactEcharts option = {
      this.getOption()
    }
    onEvents = {
      onEvents
    }
    style = {
      {
        height: '600px'
      }
    }
    />
  }
}

export default BirdGridPermissionPage
