import React from 'react';
import { BirdForm } from 'components/Form';
import { Modal, message, Input, Select, Card, Icon, Tree, Button, Row, Col, Table, } from 'antd';
import axios from "axios";
import { config, util, request, deepClone } from 'utils'
const { APIV4, APIV3 } = config
import { BirdGrid } from 'components/Grid';
const { Option } = Select;
const { TreeNode, DirectoryTree } = Tree;
const { TextArea } = Input;
class addTag_setting extends React.Component {
  constructor(props) {
    super(props);
    let editParam=this.props.location.query.params;
    let hasEditParam=(editParam) ? true : false;
    let outArr = {
      logicTree: {
        node: { left: { id: '', cnName: '',name:'' }, right: '',rightType:'object', type: 'EQ', leftTableId: '' },
        extNodes: [{ binOperation: { left: { id: '', cnName: '',name:'' }, right: '',rightType:'object', type: 'EQ', leftTableId: '' }, logicType: 'AND' }]
      }
    };
    let condition=null;
    if(hasEditParam && editParam.outputCondition && editParam.outputCondition.length>10){
      condition=JSON.parse(editParam.outputCondition);
      if(condition.extNodes && condition.extNodes.length>0){
        for(let i in condition.extNodes){
          if(condition.extNodes[i].binOperation && condition.extNodes[i].binOperation.left){
            condition.extNodes[i].node= condition.extNodes[i].binOperation;
          }
        }
      }
    }
    let tagNews=[];
    if(hasEditParam && editParam.tagNews && editParam.tagNews.length>0){
      tagNews=JSON.parse(editParam.tagNews);
    }
    this.state = {
      id: (hasEditParam && editParam.id) ? editParam.id : '',
      name: (hasEditParam && editParam.name) ? editParam.name :'',//名称
      description: (hasEditParam && editParam.description) ? editParam.description :'',//说明
      tablesSql: [],//pdm表源
      tablesSql1: [],//表
      tablesSql2: [],//表字段
      object: [],//对象列表
      objectOption: [],  //对象下拉列表-dom
      outputType: 0,  //标签类型 0新建自定义标签 1已存在自定义标签 2对象标签
      childrenTag: [],//子表
      dbId: (hasEditParam && editParam.dbId) ? editParam.dbId :'',  //选中数据源的id
      tableId: (hasEditParam && editParam.tableId) ? editParam.tableId :'',  //选中表的id
      objectCode: (hasEditParam && editParam.objectCode) ? editParam.objectCode :'',  //被分析对象code
      objectColumn: (hasEditParam && editParam.objectColumn) ? editParam.objectColumn :'',  //被分析对象唯一标识列
      objectColumnComment: '',  //被分析对象唯一标识的显示值
      selectdTableRemark: '',  //选中的表类型
      analysisMethod: (hasEditParam && editParam.analysisMethod) ? editParam.analysisMethod :'basicBehavior',  //选中的分析方式
      selectdTreeNode: {}, //选中的树节点
      binOperation: (condition &&condition.node && condition.node.left && condition.node.left.id) ? condition.node :{},  //第一个节点
      extNodes: (condition &&condition.extNodes && condition.extNodes.length>0) ?condition.extNodes :[], //后续条件集extNodes{node:binOperation,type:'AND'}
      objectTag:(tagNews.length>0) ? tagNews[0] :{}  //对象标签
    }
  }

  componentDidMount() {
    this.getTablesObj("pdm", 1);
    if (this.state.dbId && this.state.dbId.length > 0) {
      this.getTagTab(this.state.dbId);
    }
    if (this.state.tableId && this.state.tableId.length > 0) {
      this.changeTable(this.state.tableId);
    }
    //获取对象列表
    this.getObjectOption();
  }

  //获取数据源/表的元数据
  getTablesObj(arr, code) {
    let self = this;
    let paramObj = { prtId: arr };
    if (code == 2) {//表
      paramObj.remarks = self.state.selectdTableRemark;
    }
    axios.get(APIV4 + '/meta/children', { params: paramObj }).then(function (response) {
      if (response.status == 200) {
        if (code == 1) {//表源
          let tab = response.data.data;
          let tabsql = []
          for (var i = 0; i < tab.length; i++) {
            if (tab[i].name && tab[i].name.toLowerCase().indexOf("impala") != -1) {
              tabsql.push(tab[i]);
              break;
            }
          }
          self.setState({
            tablesSql: tabsql
          })
        } else if (code == 2) {//表
          self.setState({
            tablesSql1: response.data.data
          })
        } else if (code == 3) {//表字段
          let objectColumnComment='';
          if(response.data.data && response.data.data.length>0){
            for(let i in response.data.data){
              if(response.data.data[i].name == self.state.objectColumn){
                objectColumnComment= (response.data.data[i].cnName&&response.data.data[i].cnName.length>0) ?response.data.data[i].cnName :response.data.data[i].name;
              }
            }
          }
          self.setState({
            tablesSql2: response.data.data,
            childrenTag: [],
            objectColumnComment: objectColumnComment
          })
          axios.get(APIV4 + '/meta/relChildren?id=' + arr).then(function (response1) {
            if (response1.data.data.length > 0) {
              for (var obj in response1.data.data) {
                self.getChildTagList(response1.data.data[obj]);
              }
            }
          })
        }
      }
    }).catch(function (error) {
      console.log(error);
    })
  }
  //获取子表
  getChildTagList(arr) {
    let self = this
    axios.get(APIV4 + '/meta/children', { params: { prtId: arr["id"] } })
      .then(function (response1) {
        let childrenTag = self.state.childrenTag
        let childobj = { cnName: arr["cnName"], tagList: response1.data.data }
        childrenTag.push(childobj)
        self.setState({
          childrenTag: childrenTag
        })
      })
  }
  //切换数据源  更新表
  getTagTab(arr) {
    this.state.dbId= arr;
    this.getTablesObj(arr, 2);
  }
  //切换表 更新字段
  changeTable(arr) {
    this.state.tableId = arr;
    this.getTablesObj(arr, 3);
  }
  //切换表类型
  changeTableRemark(arr) {  
    let self = this;
    self.setState({
      selectdTableRemark: arr
    }, () => {
      self.getTablesObj(self.state.dbId, 2) //tableId参数在 getTablesObj中获取
    });
  }
  //获取所有对象
  getObjectOption = () => {
    let relf = this;
    axios.get(APIV4 + '/object/loadAll', {})
      .then(function (res) {
        if (res.data.data && res.data.data.length > 0) {
          relf.state.objectOption.push(<Option key='' value=''>请选择对象类型</Option>);
          for (var i in res.data.data) {
            relf.state.object.push(res.data.data[i]);
            relf.state.objectOption.push(<Option key={res.data.data.id} value={res.data.data[i].objectCode}>{res.data.data[i].objectName}</Option>);
          }
        }
      })
  }
   //修改后续条件的值
  changeExtNodesRight(i,e){
    let relf = this;
    relf.state.extNodes.map((item, _index) => {
      if (_index == i) {
        item.node.right = e.target.value;
      } else {
        item;
      }
    });
    relf.setState({
      extNodes: relf.state.extNodes
    })
  }
  //修改后续条件中对比类型
  changeExtNodesRightType(i,val){
    let relf = this;
    relf.state.extNodes.map((item, _index) => {
      if (_index == i) {
        item.node.rightType = val;
        item.node.right = '';
      } else {
        item;
      }
    });
    if(val=='object'){
      relf.setState({
        extNodes: relf.state.extNodes
      })
    }else{
      relf.setState({
        extNodes: relf.state.extNodes,
        objectTag: {}
      })
    }
  }
  //删除一个后续条件
  deleteExtNodes(i){
    let relf = this;
    relf.state.extNodes.splice(i, 1);
    relf.setState({
      extNodes: relf.state.extNodes
    });
  }
  //修改对象类型
  changeObject(i,val,option){
    let relf = this;
    if(typeof(i)=='number' && i >=0){
      relf.state.extNodes.map((item, _index) => {
        if (_index == i) {
          item.node.right = val;
        } else {
          item;
        }
      });
    }else{
      relf.state.binOperation.right=val;
    }
    if(val==''){
      relf.setState({
        objectTag:{id:'0', code:'', name:'', type:2}
      });
      return;
    }
    let objectTag={id:'0', code:val, name:option.props.children, type:2};
    relf.setState({
      objectTag:objectTag
    });
  }
  //规则组选择表字段
  onSelect = (keys, event) => {
    let relf = this
    var nodeVlaue = event.node.props;
    let tablesSql2 = relf.state.tablesSql2;
    let tablesSql1 = relf.state.tablesSql1;
    //获取选中字段的prtId
    for (var obj in tablesSql2) {
      if (tablesSql2[obj].id == nodeVlaue.eventKey) {
        relf.state.selectdTreeNode = tablesSql2[obj];
        break;
      }
    }
  };
  //绑定表单数据
  handeChange(item, event) { //输入框    
    for (let StateItem in this.state) {
      if (item === StateItem) {
        this.state[item] = event.target.value;
        this.setState(this.state)
      }
    }
  }
 
  getPhoneDes(phone) {
    request({
      url: APIV3 + "/web/ES_DataStais/getPhoneencDes?desPhone=" + phone,
      method: "get"
    }).then(function (result) {
      console.log(result)
      return result;
    })
  }
  //点击提交规则
  submitTagRule(){
    let relf=this;
    let postData={};
    //是否存在BinOperation
    let hasBinOperation= (relf.state.binOperation.left && relf.state.binOperation.left.id) ? 1:0
    if(!relf.state.name || relf.state.name.length==0){ message.error("请输入规则名称");return;}  
    if(!relf.state.description || relf.state.description.length==0){ message.error("请输入规则说明");return;}
    if(!relf.state.objectCode || relf.state.objectCode.length==0){ message.error("请选择被分析对象类型");return;}
    if(!relf.state.objectColumn || relf.state.objectColumn.length==0){ message.error("请添加对象唯一标识");return;}
    if(!relf.state.dbId || relf.state.dbId.length==0){ message.error("请选择数据源");return;}
    if(!relf.state.tableId || relf.state.tableId.length==0){ message.error("请选择表");return;}
    if(!relf.state.analysisMethod || relf.state.analysisMethod.length==0){ message.error("请选择分析方式");return;}
    if((!relf.state.binOperation.left || !relf.state.binOperation.left.id) && 
    (!relf.state.extNodes[0] || !relf.state.extNodes[0].node ||!relf.state.extNodes[0].node.left.id)){
      message.error("请添加规则条件");
      return;
    }
    if(hasBinOperation && (!relf.state.binOperation.right || relf.state.binOperation.right=='') ){
      message.error(`第1个条件的值不能为空`);
      return;
    }
    //条件中是否含有对象
    let isObject=false;
    if(relf.state.binOperation.rightType && relf.state.binOperation.rightType=='object'){
      isObject=true;
    }
    for(var i in relf.state.extNodes){
      if(relf.state.extNodes[i] && relf.state.extNodes[i].node && relf.state.extNodes[i].node.rightType){
        if(isObject && relf.state.extNodes[i].node.rightType =='object'){
          message.error("条件集中只能存在一个对象");
          return;
        }
        if(!relf.state.extNodes[i].node.right || relf.state.extNodes[i].node.right.length <=0){
          message.error(`第${i+1+hasBinOperation}个条件的值不能为空`);
          return;
        }
      }
    }
    if(!relf.state.objectTag.name || relf.state.objectTag.name.length==0){message.error("请添加对象标签");return;} 
    postData.id=relf.state.id;
    postData.name=relf.state.name;
    postData.description=relf.state.description;
    postData.objectCode=relf.state.objectCode;
    postData.objectColumn=relf.state.objectColumn;
    postData.dbId=relf.state.dbId;
    postData.tableId=relf.state.tableId;
    postData.analysisMethod=relf.state.analysisMethod;
    postData.tagNews=[];
    postData.tagNews.push(relf.state.objectTag);
    //第一个条件binOperation为空，而后续条件集extNodes有值时，取后续条件集的第一个为第一个条件
    if((!relf.state.binOperation.left || !relf.state.binOperation.left.id) && relf.state.extNodes[0].node &&relf.state.extNodes[0].node.left.id.length>0){
      relf.state.binOperation=relf.state.extNodes[0].node;
      relf.state.extNodes.splice(0,1);
    }
    postData.outputCondition={node: relf.state.binOperation, extNodes: relf.state.extNodes};
    request({
      url: APIV4 + "/tagrule/addTagRuleSecond" ,
      method: "post",
      data:postData
    }).then(function (res) {
      if(res.success){
        message.info("保存成功");
      }
    })
  }
  render() {
    let relf = this;
    let { tablesSql, tablesSql1, tablesSql2, childrenTag } = relf.state;
    let sqlTab = [];
    if (tablesSql.length > 0) {//源
      sqlTab = tablesSql.map((data, rowIndex) => {
        if (data.cnName != null && data.cnName.length > 0) {
          sqlTab = [<Option key={rowIndex} value={data.id}>{data.cnName}</Option>]
        }
        return sqlTab;
      })
    }
    let sqlTab1 = [];
    if (tablesSql1.length > 0) {//表
      sqlTab1 = tablesSql1.map((data, rowIndex) => {
        if (data.cnName != null) {
          sqlTab1 = [<Option key={rowIndex} value={data.id}>{data.cnName}</Option>];
        }
        return sqlTab1;
      })
    }
    let sqlTab2 = [];
    if (tablesSql2.length > 0) {//字段
      for (var i = 0; i < tablesSql2.length; i++) {
        if (tablesSql2[i].cnName != null && tablesSql2[i].cnName.length > 0) {
          sqlTab2.push([<TreeNode icon=' ' style={{ whiteSpace: 'nowrap', overflow: 'hidden', textOverflow: 'ellipsis', width: '80%' }} title={tablesSql2[i].cnName} key={tablesSql2[i].id} />])
        } else if (tablesSql2[i].name != null && tablesSql2[i].name.length > 0) {
          sqlTab2.push([<TreeNode icon=' ' style={{ whiteSpace: 'nowrap', overflow: 'hidden', textOverflow: 'ellipsis', width: '80%' }} title={tablesSql2[i].name} key={tablesSql2[i].id} />])
        }
      }
    }
    let childTag = [];
    if (childrenTag.length > 0) {//子表
      for (var obj in childrenTag) {
        if (childrenTag[obj]["tagList"].length > 0) {
          let chil = []
          for (var i in childrenTag[obj]["tagList"]) {
            if (childrenTag[obj]["tagList"][i]["cnName"] != null && childrenTag[obj]["tagList"][i]["cnName"].length > 0) {
              chil.push(<TreeNode style={{ whiteSpace: 'nowrap', overflow: 'hidden', textOverflow: 'ellipsis', width: '80%' }} title={childrenTag[obj]["tagList"][i]["cnName"]} key={childrenTag[obj]["tagList"][i]["id"]} isLeaf />)
            } else if (childrenTag[obj]["tagList"][i]["name"] != null && childrenTag[obj]["tagList"][i]["name"].length > 0) {
              chil.push(<TreeNode style={{ whiteSpace: 'nowrap', overflow: 'hidden', textOverflow: 'ellipsis', width: '80%' }} title={childrenTag[obj]["tagList"][i]["name"]} key={childrenTag[obj]["tagList"][i]["id"]} isLeaf />)
            }
          }
          childTag.push(
            <TreeNode title={childrenTag[obj]["cnName"]} key={childrenTag[obj]["cnName"]}>
              {chil}
            </TreeNode>
          )
        }
      }
    }

    //条件集
    let condition = [];
    if (relf.state.binOperation.left && relf.state.binOperation.left.id && relf.state.binOperation.left.id.length > 0) {
      let operation = relf.state.binOperation;
      let rightHtml = <Select defaultValue={operation.right} style={{ width: '18%', margin: '0 10px' }}  onChange={relf.changeObject.bind(this,-1)}>{relf.state.objectOption}</Select>;
      if (operation.rightType && operation.rightType != 'object') {
        rightHtml = <Input placeholder="请输入对应格式的值" style={{ width: '18%', margin: '0 10px' }} defaultValue={operation.right} onChange={(e)=>{
          relf.state.binOperation.right=e.target.value;
        }}></Input>
      }
      condition.push(<div style={{ border: '1px solid #CDC9C9', width: '95%', margin: '5px 2%' }} draggable="true">
        <span style={{ padding: '0 20px' }}> {operation.left.cnName != '' ? operation.left.cnName : operation.left.name} </span>
        <Select defaultValue={operation.type} style={{ width: '15%', margin: '0 10px' }}>
          <Option value="EQ">等于</Option>
          <Option value="GT">大于</Option>
          <Option value="LT">小于</Option>
          <Option value="GE">大于等于</Option>
          <Option value="LE">小于等于</Option>
          <Option value="CONTAINS">包含</Option>
        </Select>
        <Select defaultValue={operation.rightType} style={{ width: '15%', margin: '0 10px' }} onChange={(val) => {
          let binOperation = deepClone(relf.state.binOperation);
          binOperation.rightType = val;
          binOperation.right='';
          if(val=='object'){
            relf.setState({
              binOperation: binOperation,
            });
          }else{
            relf.setState({
              binOperation: binOperation,
              objectTag: {}
            });
          }
        }}>
          <Option value="string">字符</Option>
          <Option value="number">数字</Option>
          <Option value="dateTime">时间（yyyy-mm-dd hh:mm:ss）</Option>
          <Option value="date">日期（yyyy-mm-dd）</Option>
          <Option value="object">对象</Option>
        </Select>
        {rightHtml}
        {/* 删除第一个条件 */}
        <Button type='danger' onClick={() => {
          this.setState({
            binOperation: {}
          });
        }}> 删除</Button>
      </div>);
    }
    if (relf.state.extNodes.length > 0) {
      for (var i=0;i<relf.state.extNodes.length;i++) {
        let operation = relf.state.extNodes[i].node;
        let rightHtml = <Select key={operation.right} defaultValue={operation.right} style={{ width: '18%', margin: '0 10px' }} onChange={relf.changeObject.bind(this,i)}>{relf.state.objectOption}</Select>;
        if (operation.rightType && operation.rightType != 'object') {
          rightHtml = <Input placeholder="请输入对应格式的值" style={{ width: '18%', margin: '0 10px' }}  defaultValue={operation.right} onChange={relf.changeExtNodesRight.bind(this,i)}></Input>
        }
        condition.push(
          <div style={{ border: '1px solid #CDC9C9', width: '95%', margin: '5px 2%' }} draggable="true">
            <span style={{ padding: '0 20px' }}> {operation.left.cnName != '' ? operation.left.cnName : operation.left.name} </span>
            <Select defaultValue={operation.type} style={{ width: '15%', margin: '0 10px' }}>
              <Option value="EQ">等于</Option>
              <Option value="GT">大于</Option>
              <Option value="LT">小于</Option>
              <Option value="GE">大于等于</Option>
              <Option value="LE">小于等于</Option>
              <Option value="CONTAINS">包含</Option>
            </Select>
            <Select defaultValue={operation.rightType} style={{ width: '15%', margin: '0 10px' }} onChange={relf.changeExtNodesRightType.bind(this,i)}>
              <Option value="string">字符</Option>
              <Option value="number">数字</Option>
              <Option value="dateTime">时间（yyyy-mm-dd hh:mm:ss）</Option>
              <Option value="date">日期（yyyy-mm-dd）</Option>
              <Option value="object">对象</Option>
            </Select>

            {rightHtml}
            {/* 删除后续条件 */}
            <Button type='danger' onClick={relf.deleteExtNodes.bind(this,i)}>删除</Button>
          </div>
        )
      }
    };

    return (
      <div style={{ width: '90%', marginLeft: '5%' }}>
        <div style={{ marginLeft: '5%', border: '1px solid #CDC9C9', padding: '20px 80px' }}>
          规则名称<Input onChange={relf.handeChange.bind(this, "name")} value={relf.state.name} style={{ width: '30%', height: '30px', marginLeft: '20px' }} /><br />
          规则说明<TextArea onChange={relf.handeChange.bind(this, "description")} value={relf.state.description} rows='3' style={{ width: '50%', height: '60px', marginTop: '13px', marginLeft: '20px' }} />
        </div>
        <div style={{ margin: '15px 0 0 5%', border: '1px solid #CDC9C9', padding: '20px 80px' }}>
          <hr />
          <div style={{ marginTop: '20px' }}>
            <Select defaultValue="选择数据源" onChange={relf.getTagTab.bind(this)} style={{ width: '15%', marginLeft: '10px' }}>
              {sqlTab}
            </Select>
            <Select style={{ width: '12%' }} defaultValue="" placeholder="选择表类型" onChange={relf.changeTableRemark.bind(this)}>
              <Option value="">表类型</Option>
              <Option value="basicBehavior">行为记录表</Option>
              <Option value="basicData">基础信息表</Option>
            </Select>
            <Select defaultValue={relf.state.tableId} onChange={relf.changeTable.bind(this)} style={{ width: '15%', marginLeft: '10px' }}>
              {sqlTab1}
            </Select>
          </div>

          <div style={{ width: '100%', marginTop: '20px' }}>
            {/**表 树形 */}
            <div style={{ width: '25%', float: 'left', border: '1px solid #CDC9C9', minHeight: '400px' }}>
              {/* multiple-支持多选 defaultExpandAll-默认打开全部 */}
              <DirectoryTree multiple defaultExpandAll onSelect={relf.onSelect}>
                {sqlTab2}
                {childTag}
              </DirectoryTree>
            </div>
            <div style={{ width: '74%', float: "right", border: '1px solid #CDC9C9', minHeight: '20px', background: "#fff", paddingLeft: '20px' }}>
              被分析对象
              <Select style={{ width: '16%', marginLeft: '20px' }} defaultValue={relf.state.objectCode} onChange={(val) => {
                relf.state.objectCode = val;
              }} >
                {relf.state.objectOption}
              </Select>
              <Button size='small' type="primary" style={{ margin: '10px 5%' }} onClick={() => {
                if (!relf.state.selectdTreeNode.id || relf.state.selectdTreeNode.id.length <= 0) {
                  message.error("请先在左边的树中选择被分析对象的标识列");
                  return;
                }
                let columnComment = relf.state.selectdTreeNode.cnName != '' ? relf.state.selectdTreeNode.cnName : relf.state.selectdTreeNode.name;
                relf.setState({
                  objectColumn: relf.state.selectdTreeNode.name,
                  objectColumnComment: columnComment
                });
              }}> <Icon type="plus" />添加对象唯一标识</Button>
              <Button style={{ width: '150px', marginLeft: '10px', marginTop: '0.6%' }}>{relf.state.objectColumnComment}</Button>
            </div>
            {/**标签产出 */}
            <div style={{ width: '74%', float: "right", border: '1px solid #CDC9C9', minHeight: '400px', background: "#fff" }}>
              分析方式：<Select defaultValue="分析方式" value={relf.state.analysisMethod} onChange={(value) => { relf.setState({ analysisMethod: value }) }} style={{ width: '15%' }}>
                <Option value="basicBehavior">基本行为分析</Option>
                <Option value="behaviorStatistics">行为统计分析</Option>
                <Option value="basicData">基础资料分析</Option>
              </Select>
              <div style={{ width: '96%', margin: '20px 2%', border: '1px solid #CDC9C9', minHeight: '70px' }}>
                {/**条件块 */}
                {condition}
                <Button size='small' type="primary" style={{ margin: '10px 5%' }} onClick={() => {
                  if (!relf.state.selectdTreeNode.id || relf.state.selectdTreeNode.id.length <= 0) {
                    message.error("请先在左边的树中选择被分析对象的标识列");
                    return;
                  }
                  let selectdTreeNode = relf.state.selectdTreeNode;
                  let operation = {
                    left: {id: selectdTreeNode.id, cnName: selectdTreeNode.cnName, name: selectdTreeNode.name}, right: '', type: 'EQ',
                    leftTableId: relf.state.tableId, rightType: 'object'
                  };
                  if (!relf.state.binOperation.left || !relf.state.binOperation.left.id || relf.state.binOperation.left.id.length <= 0) {
                    relf.setState({
                      binOperation: operation
                    });
                  } else {
                    //后续逻辑节点
                    let logicNode = { type: 'AND', node: operation };
                    relf.setState({
                      extNodes: [...relf.state.extNodes, logicNode]
                    });
                  }
                }}><Icon type="plus" /> 添加条件 </Button>
                <hr />
                <span>产出结果</span>
                <div style={{ width: '96%', margin: '20px 2%', border: '1px solid #CDC9C9', minHeight: '50px' }}>
                <Button style={{ width: '10%', margin: "10px 10px" }}> {relf.state.objectTag.name} </Button>
                  <span style={{ padding: '0 20px' }}>的所有标签</span>
                  {/* <Button type="danger">删除</Button> */}
                </div>
                {/* <Button size='small' type="primary" style={{margin:'10px 5%'}}><Icon type="plus" />添加标签</Button>  */}
              </div></div>
            <Button style={{ margin: "20px 0 0 40%" }} size='default' type="primary" onClick={relf.submitTagRule.bind(this)}>
              提交
            </Button>
            <div style={{ clear: 'both' }}></div>
          </div>
        </div>
      </div>
    )
  }
}

export default addTag_setting
