import React from 'react';
import { BirdGrid } from 'components/Grid';
import { deepClone,util,config } from 'utils';
import { Row,Col } from 'antd';
const { APIV4 } = config

class TagsList extends React.Component {
  constructor(props) {
    super(props)
    this.state = {  
      data: [],
      randStr:"",
      loading: false,
    }
  }
 
render() {
  var self = this;
  let gridOptionsTagType = {
    title: "标签类型列表",
    url: {
      read: APIV4+"/memcount/TagTypes",
      add: APIV4+"/memcount/editType",
      edit: APIV4+"/memcount/editType",
      // delete: APIV4+"/memcount/deleteTag"
      // read: "/web/Mem_TagType/TagTypes",
      // add: "/web/Mem_TagType/addTagType",
      // edit: "/web/Mem_TagType/edit",
      // delete: "/web/Mem_TagType/delete"
    },
    checkable: false,
    filterOption:{display:'none'},
    afterSave:function afterSave(){
      let columns = util.object.deepClone(self.refs.grid.state.columns);
      for(var col in columns){
        if(columns[col].data === 'TagTypeId'){
          let randstr = util.string.generateRandom(5);
          columns[col].source.url = '/web/Mem_TagType/type'
          +"?t="+randstr;
          self.setState({randStr:randstr});
        }
      }
      
      self.setState({laoding:true});
      //gridOptionsTagType = gridOption;

      self.refs.grid.setState({columns:columns});
      self.refs.grid.reload();
    },
    afterQuery:function(){
      
      self.setState({laoding:false});
    },
    primaryKey:"Id",
    columns: [
      { title: "标签类型id", data: "Id", type: "text", editor: {ap: 'hide', ep: 'hide'}, hide: true },
      { title: "标签类型值", data: "Value", type: "text", editor: {ap: 'hide', ep: 'hide'},query:true,  isRequired: true },
      { title: "标签类型名称", data: "Text", type: "text", editor: {},query:true, isRequired: true }, 
      {
        title: "操作选项", type: "command", actions: [{
          name: '明细',
          color: '#67c23a',
          onClick: (data) => {
            let customRules = this.state.customRule||[];
            customRules = [{
               field: "TagTypeId",
               value: data.Value
            }];
            if(this.refs.grid)
            this.refs.grid.setCustomData(customRules);
          }
        }]
      }
    ],
  //   actions:[{ name: '保存', onClick: function () {
       
  //   }
  // }]
    };

  let gridOptionsTag = {
    title: "标签列表",
    url: {
      read: APIV4+"/memcount/AllTagList",
      add: APIV4+"/memcount/EditTag",
      edit: APIV4+"/memcount/EditTag"
      
      // read: "/web/mem_tag/AllTagList",
      // add: "/web/mem_tag/EditTag",
      // edit: "/web/mem_tag/EditTag"
    },
    checkable: false,
    beforeQuery:function(gridDatas,filters,pageIndex,pageSize){
    let filterDistinct = [];
      
      if(pageIndex * pageSize > 1000000){
        message.error("不能翻页超过"+pageIndex+"页");
        return false;
      }else 
      return true;
    },
    afterCheck:function checkclick(datalist,checkkey){
    },
    beforeSave:function beforeSave(initValue,that){
    },
    primaryKey:"_id",
    columns: [
      { title: "标签ID", data: "_id", type: "text", editor: {ap: 'hide', ep: 'hide'}, isRequired: true },
      { title: "标签名称", data: "TagName", type: "text", editor: {},query:false,  query: true },
      { title: "标签类型名称", data: "TagTypeName", type: "text", editor: {ap: 'hide', ep: 'hide'},hide:true}, 
      { title: "标签类型", data: "TagTypeId", type: "dropdown", 
        editor: {
        //   onChange:function(key,value,indexstr,that){
        //   let options = self.refs.grid.state.sourceKeyMap[key];
        //     if(options && options[value]){
        //       let gridDatas = deepClone(self.refs.grid.state.gridDatas);
        //       if(gridDatas.items[indexstr]){
        //         let item = gridDatas.items[indexstr]; 
        //         item['TagTypeName'] = options[value].label;
        //         self.refs.grid.setState({gridDatas:gridDatas});
        //       }
        //     }
        // }
        },
        source: { url: '/web/Mem_TagType/type?t='+self.state.randStr },
        query:true }, 
      {
        title: "操作选项", type: "command", actions: []
      }
    ],
  //   actions:[{ name: '保存', onClick: function () {
       
  //   }
  // }]
    };

    return (
      <Row>
        <Col span={6}>
      <BirdGrid gridOption={gridOptionsTagType} ref="TagType"></BirdGrid>
        </Col>
        <Col span={18}>
          <BirdGrid gridOption={gridOptionsTag} ref="grid"></BirdGrid>
          </Col>
      </Row>
    )
  }
}

export default TagsList
