import React from 'react';
import { BirdGrid } from 'components/Grid';
import { routerRedux } from 'dva/router'
import { config,request,util } from 'utils'
import { jrequest } from 'utils/request';
import { connect } from 'dva';
import axios from "axios";
import moment from 'moment';
import {BirdForm} from 'components/Form';
import {Modal,message,Input, Select,Card,Icon,Tree,Button,Row,Col,Radio,DatePicker} from 'antd';
import { json } from 'graphlib';
const { RangePicker } = DatePicker;
const { APIV4 } = config
class tag_setting extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      formConfirmLoading:false,
      formVisiable:false,
      hidePop:true,
      TagConten:[],
      entObject:[],
      active:true,
      repeatType:'4',
      repeatRule:'1',
      repeats:true,
      pageSize:20,
      startTime:new Date()
    }
  }

  //获取规则数据
  componentDidMount(){ 
    
 }
 getTagList(arr){
  let self=this;
  axios.get(APIV4+'/tagrule/getTagRuleOfPage',arr)
   .then(function (response) {
    if(response.status==200 && response.data.content!=null){
     var TagConten= response.data.content;
     TagConten.length=response.data.totalElements
      for(var obj in TagConten){
        if(TagConten[obj].jobInfo && TagConten[obj].jobInfo.active){
          TagConten[obj].activeName='已开启'
        }else{
          TagConten[obj].activeName='未开启'
        }
      }
     self.setState({
       TagConten:TagConten
     })    
    }
   }).catch(function (error) {
     console.log(error);
   })
 }
 cancelClick() {
  this.setState({
    formVisiable: false,
    formConfirmLoading: false
  });
}
okClick(){
  let self=this
  var user = util.auth.getUser();
  var entObject=self.state.entObject;
  var entObject1={};
  entObject1["crtUser"]=user.id,
  entObject1["id"]=entObject.jobId;
  entObject1["active"]=self.state.active;
  entObject1["repeatType"]=self.state.repeatType;
  entObject1["repeatRule"]=self.state.repeatRule;
  entObject1["repeats"]=self.state.repeats;
  entObject1["startTime"]=self.state.startTime;
  if(entObject1.id!=null&&entObject1.id.length>0){
    axios.put(APIV4+'/tagrule/jobinfo',entObject1)
    .then(function (response) {
      self.setState({
         formVisiable: false,
         formConfirmLoading: false
       });
       self.getTagList({params:{page:"1",size:self.state.pageSize}})
    })
    .catch(function (error) {
      console.log(error);
    })
  }else{
    entObject1["name"]=JSON.stringify(self.state.startTime)+Math.floor(Math.random()*10);
    axios.post(APIV4+'/tagrule/jobinfo',entObject1)
    .then(function (response) {
      self.setState({
         formVisiable: false,
         formConfirmLoading: false
       });
       axios.get(APIV4+'/tagrule/jobinfo?page=1&size=1&name='+entObject1["name"])
       .then(function (response1) {       
         if(response1.data.content.length>0){
          entObject["object"]=entObject["object"]=="员工"?1:(entObject["object"]=="用户"?2:3);
          entObject["jobId"]=response1.data.content[0].id
          axios.put(APIV4+'/tagrule/rule',entObject)
          .then(function (response2) { 
            self.getTagList({params:{page:"1",size:self.state.pageSize}}) 
          })
         }
       })
    }).catch(function (error) {
      console.log(error);
    })
  }
}
handeChange(item,event){ //输入框    
  this.state[item]=event.target.value;
  this.setState(this.state) 
}
handeChangev2(item,event){
  var date = new Date(event);
  this.state[item]=date;
  this.setState(this.state)
}
setJobInfo(id){
  axios.get(APIV4+'/tagrule/jobDetail?jobId='+id)
  .then(function (response) {
    self.setState({
      repeatRule:response.data.data.repeatRule,
      repeatType:response.data.data.repeatType,
      repeats:response.data.data.repeats,
      startTime:response.data.data.startTime,
      active:response.data.data.active
    })
  })
}
  render() {
    let self = this;
    let {TagConten}=self.state;
    let gridOption = {
      title: "表格示例",
      url: {
        read: APIV4+'/tagrule/getTagRuleOfPage'
      },
      pageSize:10,
      checkable: true,
      columns: [
        { title: "编号", data: "id", type: "text", editor: {} },
        { title: "规则名称", data: "name", type: "text", editor: {},query:true },
        { title: "规则用途", data: "description", type: "text", editor: {} },
        { title: "执行时间", data: "jobInfo.datetime",  type: "text", editor: {} },
        { title: "任务状态", data: "jobInfo.active", type: "dropdown",  editor: {}, query:true,render:(col, row, i) =>{
          if(col && col==true){
            return  <div key={i}>已开启</div>
          }else{
            return  <div key={i}>未开启</div>
          }
        },source:{multi: false, data: [
          { label: '已开启', value: true },
          { label: '未开启', value: false }]}
        },
        { title: "操作选项", type: "command", actions: [
            { name: '编辑任务', color: 'red',
                onClick: (data) => {
                  if(data.jobId!=null&&data.jobId.length>0){ 
                    self.setJobInfo(data.jobId)
                }
                this.setState({
                  formConfirmLoading:true,
                  formVisiable:true,
                  entObject:data
                })
              }
            },
            {name: '编辑规则', color: '#67c23a',
            onClick: (data) => {
              this.props.dispatch({
                type: 'app/updateState', payload: {
                  menuPath: [{id:"300",name:"创建规则"}]
                }
              });
              this.props.dispatch(routerRedux.push({
                pathname: '/tag/addTag_setting',
                query: {params: data},
                })
              );
            }
          },{name: '删除', color: 'red', confirm:true,
            onClick: (data) => {
              jrequest({
                url:APIV4+'/tagrule/deleteTagRule',
                method:"delete",
                data: {id:data.id}
            }).then((result) => {
                message.warning(result.msg);
                location.reload();
            });
            }
          }
        ]
        }
      ],actions: [
        { name: '创建规则',color: '#67c23a',
        onClick: (data) => {
          this.props.dispatch({
            type: 'app/updateState', payload: {
              menuPath: [{id:"300",name:"创建规则"}]
            }
          });
          this.props.dispatch(routerRedux.push({
            pathname: '/tag/addTag_setting',
            query: {},
            })
          );
        } }
      ],
      afterQuery:function(result,filters){
        //  if(result.items!=null && result.items.length>0){
        //    for(var i in result.items){
        //      debugger;
        //     if(!result.items[i].jobInfo){
        //       result.items[i].jobInfo={};
        //       result.items[i].jobInfo.active=false;
        //      }else if(!result.items[i].jobInfo.active){
        //       result.items[i].jobInfo.active=false;
        //      }
        //    }
        //    self.refs.pageGrid.
        //  } 
      }
    };
    return <div>
                <BirdGrid gridOption={gridOption} ref="pageGrid"></BirdGrid>
                <Modal title="选择标签"
                width="50%"
                visible={this.state.formVisiable}
                onCancel={() => this.cancelClick()}
                onOk={() => this.okClick()}>
                <Card>执行时间 <DatePicker showTime placeholder="Select Time" defaultValue={moment(self.state.startTime, 'YYYY-MM-DD')} onOk={self.handeChangev2.bind(this,'startTime')} /></Card>
                <Card>重复执行<Input type="number" value={self.state.repeatRule} onChange={self.handeChange.bind(this,'repeatRule')}></Input></Card>
                <Card>
                  <Radio.Group defaultValue={self.state.repeats} buttonStyle="solid" onChange={self.handeChange.bind(this,'repeats')}>
                <Radio.Button value={true}>重复</Radio.Button>
                <Radio.Button value={false}>不重复</Radio.Button>
                </Radio.Group>
                是否开启<Radio.Group defaultValue={self.state.active} buttonStyle="solid" onChange={self.handeChange.bind(this,'active')}>
                <Radio.Button value={true}>开启</Radio.Button>
                <Radio.Button value={false}>关闭</Radio.Button>
              </Radio.Group></Card>
              </Modal>
           </div>
  }
}
export default connect( ( { bindActionCreators } ) => ( { bindActionCreators } ) )( tag_setting );
