import React from 'react';
import { BirdGrid } from 'components/Grid';
import { config,request,util } from 'utils';
import { message } from 'antd';
import axios from 'axios'
const { APIV3 } = config

class BirdGridPermissionPage extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
    }
  }

  
  render() {
    var user = util.auth.getUser();
    let staffid = user.staffid;
    
    let gridOption = {
      title: "批件下载",
      url: {
        read: '/web/upload/getalldata?staffid='+staffid 
      },
      checkable: false,
      actions: [],
      columns: [
        { title: "id", data: "id", type: "number", editor: {ep:'hide',ap:'hide'},hide:true},
        { title: "业务员", data: "userName", type: "text" , editor: {ep:'hide'},query: true},
        { title: "商品名称", data: "goodsName", type: "text" , editor: {ep:'hide'},query: true},
        { title: "批准文号", data: "approvalNo", type: "text" , editor: {ep:'hide'},query: true}, 
        { title: "文件", data: "field_file", type: "files", editor: {} },
        {
          title: "操作选项",
          type: "command",
          actions: [{
            name: '下载',
            color: '#67c23a',
            hideFunc:function(data){
              if(data['field_file'].length > 0){
                  return false;
              }
              return true;
            },
            onClick: (data) => {               
                let arr=  data.field_file.split(",");
                for(let i=0 ;i<arr.length;i++){                   
                    axios({
                        url: APIV3 + '/web/upload/download?filePath='+arr[i], 
                        method: 'post',
                        data: data,
                        responseType: 'blob'
                        }).then(function (result) {          
                            var blob = new Blob([result.data])                 
                            var downloadElement = document.createElement('a');
                        　　var href = window.URL.createObjectURL(blob); //创建下载的链接
                        　　downloadElement.href = href;
                        　　downloadElement.download = 'pic.jpg'; //下载后文件名
                        　　document.body.appendChild(downloadElement);
                        　　downloadElement.click(); //点击下载
                        　　document.body.removeChild(downloadElement); //下载完成移除元素
                        　　window.URL.revokeObjectURL(href); //释放掉blob对象 
                          });                
                }        
            }
          }]
        }
      ]
    };
    return <BirdGrid gridOption={gridOption} />
  }
}

export default BirdGridPermissionPage
