import React from 'react';
import { BirdGrid } from 'components/Grid';
import { config,util,request } from 'utils'
const { APIV3 } = config
import { message } from 'antd'

class BirdGridPermissionPage extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
    }
  }


  render() {
    //let password = function (){return util.string.generateRandom(5);};
    let gridOption = {
      title: "供应商联系人账户",
      url: {
        read: "/web/user/salesman",
        //add: "/web/user/add",
        edit: "/web/user/edit",
        delete: "/web/user/delete"
      },
      checkable: true,
      primaryKey:"Pk",
      deleteKey:"Id",
      ////actions: [{ name: '外部按钮', color: 'error', onClick: function () { } }],
      columns: [
        { title: "Pk", data: "Pk", type: "text", hide:true},
        { title: "用户id", data: "Id", type: "text", editor: {ep:"disabled"} },
        { title: "用户账户", data: "AccountName", type: "text", editor: {}, query: true ,isRequired: true},
        { title: "用户密码", data: "AccountPassWord", type: "text", editor: {}, query: true ,isRequired: true},
        { title: "真实姓名", data: "AccountRealName", type: "text", editor: {}, query: true },
        { title: "手机号", data: "AccountPhone", type: "text", editor: {}, query: true },
        { title: "微信绑定标识", data: "WxOpenId", type: "text", editor: {} },
        { title: "是否禁用", data: "IsDelete", type: "switch", editor: {}, query: true },
        { title: "角色", data: "RoleId", type: "dropdown", editor: {value:"3"}, source: { url: '/web/user/role' }, query: true },
        { title: "关联采购员", data: "StaffName", type: "text",  query: true },
        { title: "所属货主", data: "OrgId", type: "dropdown",  query: true ,editor:{
            inline:{},
          }, source: { url: '/web/owner/orgs' },width:"90px"
        },
        { title: "创建人", data: "Creater", type: "text",  query: true },
        { title: "创建时间", data: "CreationDate", type: "datetime",  query: true },
        // { title: "富文本", data: "field-richtext", type: "richtext", editor: {}, query: true },
        {
          title: "操作选项", type: "command", actions: [{
            name: '保存',
            color: '#67c23a',
            onClick: (data) => {
              request({
                url: APIV3 + '/web/owner/setOrgKContact',
                method: "post",
                data: data
              }).then(function (result) {
                if (result.success)
                  message.success('保存成功');
                else
                  message.error(result.msg);
              });
            }
          }]
        }
      ]
    };
    return <BirdGrid gridOption={gridOption}/>
  }
}
export default BirdGridPermissionPage
