import React from 'react';
import {Card} from 'antd';
import {BirdForm} from 'components/Form';
import { config,util } from 'utils'
const { APIV3 } = config

let password = util.string.generateRandom(5);
const fields=[
  {
    name: '用户账户登陆名',
    key: 'AccountName',
    fieldType: 'text',
    isRequired: true,
    tips:'我是提示啊',
    groupName:'基础信息',
  },
  {
    name: '用户账户密码',
    key: 'AccountPassWord',
    fieldType: 'text',
    groupName:'基础信息',
  },
  {
    name: '真实名',
    key: 'AccountRealName',
    fieldType: 'text',
    groupName:'基础信息',
  },
  {
    name: '手机号',
    key: 'AccountPhone',
    fieldType: 'number',
    groupName:'基础信息',
  },
  {
    name: '角色',
    key: 'RoleId',
    fieldType: 'dropdown',
    value:3,
    source:{url:'/web/user/role'},
    groupName:'基础信息',
  },
  {
    name: '是否禁用',
    key: 'IsDelete',
    fieldType: 'switch',
    groupName:'基础信息',
    innerProps:{
      checkedChildren:"yes"
    }
  },
];

class BirdFormDemoPage extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
    }
  }

  render() {

    return (
      <Card>
        <BirdForm fields={fields} lineCapacity={1} saveUrl={'/web/user/add'} withTab={true} 
        value={{'AccountPassWord':password,'RoleId':'3'}}/>
      </Card>
    )
  }
}

export default BirdFormDemoPage
