import React from 'react';
import { BirdGrid } from 'components/Grid';
import { config,util,permission,request } from 'utils'
import { Modal,message,Input } from 'antd';
const { APIV3 } = config

class BirdGridPermissionPage extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      formWidth: 500,
      formConfirmLoading:false,
      formVisiable:false,
      userData:{
        userId:0,
        userTel:0,
        content:0,
        code:1
      }
    }
  }

  saveClick(callback) {
    let self=this
    var user = util.auth.getUser();
    let staffid = user.staffid;
    let userData=self.state.userData;
    request({
      url: APIV3+"/web/ES_UsageMem/addUsreTel?staffId="+staffid,
     method: "post",
     data:userData
   }).then(function (result) {
     message.success("设置成功！")
     self.cancelClick()
   })
  }
  cancelClick() {
    this.setState({
      formVisiable: false,
      formConfirmLoading: false,
      userData:{userId:0,
        userTel:0,
        content:0,
        code:1}
    });
  }
  handeChange(name,e){
    var content=e.target.value;
    if(content!=null&&this.state.userId!=0){
      var userData=this.state.userData
      userData[name]=content
      this.setState({
        userData:userData
      })
    }
  }
  render() {
    let user = util.auth.getUser();
    let self = this;
    var userTel=self.state.userData.userTel
    if(!user) {
      util.auth.removeToken();
      permission.clear();
      window.location.href = "/";
    }
    let staffid = user.staffid;

    let gridOption = {
      title: "账户列表",
      url: {
        read: "/web/user/index/2/"+staffid,
        edit: "/web/user/edit",
        delete: "/web/user/delete"
      },
      checkable: true,
      ////actions: [{ name: '外部按钮', color: 'error', onClick: function () { } }],
      columns: [
        { title: "用户id", data: "Id", type: "text", editor: {ep:"disabled"} },
        { title: "用户账户", data: "AccountName", type: "text", editor: {}, query: true },
        { title: "用户密码", data: "AccountPassWord", type: "text", editor: {}, query: true },
        { title: "真实姓名", data: "AccountRealName", type: "text", editor: {}, query: true },
        { title: "手机号", data: "AccountPhone", type: "number", editor: {}, query: true },
        { title: "微信绑定", data: "WxOpenId", type: "text", editor: {},hide:true },
        { title: "是否禁用", data: "IsDelete", type: "switch", editor: {}, query: true },
        { title: "角色", data: "RoleId", type: "dropdown", editor: {}, source: { url: '/web/user/role' }, query: true },
        { title: "创建时间", data: "CreationDate", type: "datetime",  query: true },
        // { title: "富文本", data: "field-richtext", type: "richtext", editor: {}, query: true },
        {
          title: "操作选项", type: "command", actions: [{
            name: '设置分机号',
            onClick: (data) => {
              if(data!=null&&data.Id!=null){
                let userData=self.state.userData
                userData["userId"]=data.Id
                request({
                  url: APIV3+"/web/ES_UsageMem/getUsreTel?staffId="+staffid+"&accountId="+data.Id,
                 method: "get"
               }).then(function (result) {

                 if(result!=null&& result.tel.length>0){
                  userData["code"]="2";
                  userData["userTel"]=result.tel[0]["UserTel"];
                 }  
                 self.setState({
                  formVisiable: true,
                  formConfirmLoading: true,
                  userData:userData
                });
               })
              }
            }
          }]
        }
      ]
    };
    return <div>
      <BirdGrid gridOption={gridOption} />
      <Modal title={"设置分机号"}
        width={this.state.formWidth}
        visible={this.state.formVisiable}
        onOk={() => this.saveClick()}
        onCancel={() => this.cancelClick()}
      >
        <Input addonBefore="分机号" type="text" value={userTel} onChange={this.handeChange.bind(this,"userTel")} />
        <Input style={{marginTop:"20px"}} addonBefore="备注" type="text" onChange={this.handeChange.bind(this,"content")} />
    </Modal>
      </div>
  }
}

export default BirdGridPermissionPage
