import React from 'react';
import { BirdGrid } from 'components/Grid';
import { config,util,permission } from 'utils'
const { APIV3 } = config

class BirdGridPermissionPage extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
    }
  }


  render() {
    let user = util.auth.getUser();
    if(!user) {
      util.auth.removeToken();
      permission.clear();
      window.location.href = "/";
    }
    let staffid = user.staffid;

    let gridOption = {
      title: "管理员账户",
      url: {
        read: "/web/user/index/1/"+staffid,
        add: "/web/user/add",
        edit: "/web/user/edit",
        delete: "/web/user/delete"
      },
      checkable: true,
      ////actions: [{ name: '外部按钮', color: 'error', onClick: function () { } }],
      columns: [
        { title: "用户id", data: "Id", type: "text" },
        { title: "用户账户", data: "AccountName", type: "text", editor: {}, query: true },
        { title: "用户密码", data: "AccountPassWord", type: "text", editor: {}, query: true },
        { title: "真实姓名", data: "AccountRealName", type: "text", editor: {}, query: true },
        { title: "手机号", data: "AccountPhone", type: "number", editor: {}, query: true },
        { title: "openid", data: "WxOpenId", type: "text", editor: {} },
        { title: "是否禁用", data: "IsDelete", type: "switch", editor: {}, query: true },
        { title: "角色", data: "RoleId", type: "dropdown", editor: {}, source: { url: '/web/user/role' }, query: true },
        { title: "创建时间", data: "CreationDate", type: "datetime",  query: true },
        // { title: "富文本", data: "field-richtext", type: "richtext", editor: {}, query: true },
        {
          title: "操作选项", type: "command", actions: []
        }
      ]
    };
    return <BirdGrid gridOption={gridOption} />
  }
}

export default BirdGridPermissionPage
